package org.kldp.ebmsh.bi.generator.io;

import java.io.IOException;

import com.softmeca.util.io.FileIoUtil;


/**
 * Source File  ϴ Ŭ
 * 
 * Singleton pattern
 * 
 * @author ø콺
 */
public class SourceWriter {
	private final static SourceWriter instance = new SourceWriter();
	
	private SourceWriter() {
	}
	
	public static SourceWriter getInstance() {
		return instance;
	}
	
	/**
	 * ڷ Ѿ source sourcePath Ѵ.
	 * 
	 * Test plan
	 * - source ڷ null̳ ڿ   -> GeneratorIOException ߻ ( error : source null  ϴ. )
	 * - source directory path ڷ null̳ ڿ   -> GeneratorIOException ߻ ( error : source directory path null  ϴ. )
	 * - source file name ڷ null̳ ڿ   -> GeneratorIOException ߻ ( error : source file name null  ϴ. )
	 * -    -> GeneratorIOException ߻ ( error :    ϴ. + errorMessage )
	 * 
	 * @param source
	 * @param sourceDirectoryPath
	 * @param sourceFileName
	 * @throws GeneratorIOException
	 */
	public void writeSource(String source, String sourceDirectoryPath, String sourceFileName) throws GeneratorIOException {
		if( source == null || source.equals(""))
			throw new GeneratorIOException("source null  ϴ.");
		
		if( sourceDirectoryPath == null || sourceDirectoryPath.equals(""))
			throw new GeneratorIOException("source directory path null  ϴ.");
		
		if( sourceFileName == null || sourceFileName.equals(""))
			throw new GeneratorIOException("source file name null  ϴ.");
		
		// 丮 
		FileIoUtil.directoryCreateOrNone(sourceDirectoryPath);
		
		//  
		try {
			FileIoUtil.saveDataToFile(sourceDirectoryPath, sourceFileName, source);
		}
		catch(IOException e) {
			throw new GeneratorIOException("   ϴ.", e);
		}
	}
}
