package org.kldp.ebmsh.bi.generator.source;

import java.io.File;

import org.kldp.ebmsh.bi.generator.context.ActionHandlerProcesserContext;
import org.kldp.ebmsh.bi.generator.context.Context;
import org.kldp.ebmsh.bi.generator.context.Ejb2MDBContext;
import org.kldp.ebmsh.bi.generator.io.GeneratorIOException;
import org.kldp.ebmsh.bi.generator.io.SourceWriter;
import org.kldp.ebmsh.bi.generator.template.GeneratorTemplateException;
import org.kldp.ebmsh.bi.generator.template.TemplateEngine;

import com.softmeca.util.io.FileIoUtil;

/**
 * Action handler Ѵ.
 * 
 * @author ø콺
 */
public class ActionHandlerProcesserGenerator extends SourceGenerator {
	/**
	 * ActionHandlerProcesserTemplateFileName
	 */
	private final String ActionHandlerProcesserTemplateFileName = "ActionHandlerProcesser.vm";
	
	/**
	 * ActionHandlerProcesserOutputDirectory
	 */
	private final String ActionHandlerProcesserOutputDirectory = 
		"org" + File.separator + "kldp" + File.separator + "ebmsh" + File.separator + "bi" + File.separator + "actionhandler";
	
	
	/**
	 * Template Source ȰҶ  TemplateGenerator Ѵ.
	 * 
	 * @param templater
	 */
	public ActionHandlerProcesserGenerator(TemplateEngine templater) throws GeneratorSourceGeneratorException {
		super(templater);
	}
	
	
	/**
	 * generate ޼ override
	 * 
	 * TestPlan
	 * -  actionHandlerProcesserContext null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : actionHandlerProcesserContext null  ϴ. ) 
	 */
	public void generate(ActionHandlerProcesserContext actionHandlerProcesserContext, String outputDirectory) throws GeneratorSourceGeneratorException {
		if( actionHandlerProcesserContext == null )
			throw new GeneratorSourceGeneratorException("actionHandlerProcesserContext null  ϴ.");
		
		generateSource(actionHandlerProcesserContext, outputDirectory);
	}

	
	/**
	 * ҽ merge ϰ Ͽ ϴ ޼
	 * 
	 * TestPlan
	 * -  context null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : Context null  ϴ. )
	 * -  outputDirectory null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : outputDirectory null  ϴ. )
	 * 
	 * @param context
	 * @param outputDirectory
	 */
	protected void generateSource(Context context, String outputDirectory) throws GeneratorSourceGeneratorException {
		ActionHandlerProcesserContext actionHandlerProcesserContext = (ActionHandlerProcesserContext)context;
		
		String actionHandlerProcesserSource = null;
		
		// Template context merge
		try {
			actionHandlerProcesserSource = templateEngine.merge(ActionHandlerProcesserTemplateFileName, context);
		}
		catch(GeneratorTemplateException e) {
			throw new GeneratorSourceGeneratorException(e);
		}
		
		// Ͽ ҽ 
		try {
			SourceWriter.getInstance().writeSource(actionHandlerProcesserSource, FileIoUtil.fileSeparatorAddOrNone(outputDirectory) + ActionHandlerProcesserOutputDirectory, actionHandlerProcesserContext.getProcesserClassName() + ".java");
		}
		catch(GeneratorIOException e) {
			throw new GeneratorSourceGeneratorException(e);
		}
	}
}
