package org.kldp.ebmsh.bi.generator.source;

import java.io.File;

import org.kldp.ebmsh.bi.generator.context.Context;
import org.kldp.ebmsh.bi.generator.context.Ejb2EjbJarContext;
import org.kldp.ebmsh.bi.generator.context.EjbJarContext;
import org.kldp.ebmsh.bi.generator.io.GeneratorIOException;
import org.kldp.ebmsh.bi.generator.io.SourceWriter;
import org.kldp.ebmsh.bi.generator.template.GeneratorTemplateException;
import org.kldp.ebmsh.bi.generator.template.TemplateEngine;

import com.softmeca.util.io.FileIoUtil;


/**
 * Ejb jar source mergeϰ   Ͽ ϴ Ŭ
 * 
 * @author ø콺
 */
public class Ejb2EjbJarGenerator extends EjbJarGenerator {
	/**
	 * Template file name
	 */
	private final String Ejb2EjbJarTemplateFileName = "Ejb2EjbJar.vm";
	
	/**
	 * Output directory
	 */
	private final String Ejb2EjbJarOutputDirectory = "META-INF";
	
	/**
	 * Output file name
	 */
	private final String Ejb2EjbJarOutputFileName = "ejb-jar.xml";
	

	/**
	 * 
	 * 
	 * @param templateGenerator
	 */
	public Ejb2EjbJarGenerator(TemplateEngine templateGenerator) {
		super(templateGenerator);
	}
	
	
	/**
	 * generate ޼ override
	 * 
	 * TestPlan
	 * -  ejbJarContext null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : EjbJarContext null  ϴ. ) 
	 * -  ejbJarContext class type Ejb2EjbJarContext ƴϸ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : EjbJarContext Type Ejb2EjbJarContext ƴմϴ. )
	 */
	public void generate(EjbJarContext ejbJarContext, String outputDirectory) throws GeneratorSourceGeneratorException {
		if( ejbJarContext == null )
			throw new GeneratorSourceGeneratorException("ejbJarContext null  ϴ.");
		
		if( !(ejbJarContext instanceof Ejb2EjbJarContext) ) 
			throw new GeneratorSourceGeneratorException("EjbJarContext Type Ejb2EjbJarContext ƴմϴ.");
		
		generateSource(ejbJarContext, outputDirectory);
	}

	
	/**
	 * ҽ merge ϰ Ͽ ϴ ޼
	 * 
	 * TestPlan
	 * -  context null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : Context null  ϴ. )
	 * -  outputDirectory null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : outputDirectory null  ϴ. )
	 * 
	 * @param context
	 * @param outputDirectory
	 */
	protected void generateSource(Context context, String outputDirectory) throws GeneratorSourceGeneratorException {		
		String ejb2EjbJarSource = null;
		
		// Template context merge
		try {
			ejb2EjbJarSource = templateEngine.merge(Ejb2EjbJarTemplateFileName, context);
		}
		catch(GeneratorTemplateException e) {
			throw new GeneratorSourceGeneratorException(e);
		}
		
		// Ͽ ҽ 
		try {
			SourceWriter.getInstance().writeSource(ejb2EjbJarSource, FileIoUtil.fileSeparatorAddOrNone(outputDirectory) + Ejb2EjbJarOutputDirectory, Ejb2EjbJarOutputFileName);
		}
		catch(GeneratorIOException e) {
			throw new GeneratorSourceGeneratorException(e);
		}
	}
}