package org.kldp.ebmsh.bi.generator.source;

import java.io.File;

import org.kldp.ebmsh.bi.generator.context.MDBContext;
import org.kldp.ebmsh.bi.generator.context.Context;
import org.kldp.ebmsh.bi.generator.context.Ejb2MDBContext;
import org.kldp.ebmsh.bi.generator.io.GeneratorIOException;
import org.kldp.ebmsh.bi.generator.io.SourceWriter;
import org.kldp.ebmsh.bi.generator.template.GeneratorTemplateException;
import org.kldp.ebmsh.bi.generator.template.TemplateEngine;

import com.softmeca.util.io.FileIoUtil;


/**
 * Action handler mdb ϴ Ŭ ejb version 2.0 ° Ѵ.
 * 
 * @author ø콺
 */
public class Ejb2MDBSourceGenerator extends MDBSourceGenerator {
	/**
	 * Ejb2ActionHandlerMDBTemplateFileName
	 */
	private final String Ejb2MDBTemplateFileName = "Ejb2MDB.vm";
	
	
	/**
	 * Ejb2ActionHandlerMDBOutputDirectory
	 */
	private final String Ejb2ActionHandlerMDBOutputDirectory = 
		"org" + File.separator + "kldp" + File.separator + "ebmsh" + File.separator + "bi" + File.separator + "actionhandler";
	
	
	/**
	 * Template Source ȰҶ  TemplateGenerator Ѵ.
	 * 
	 * @param templater
	 */
	public Ejb2MDBSourceGenerator(TemplateEngine templater) {
		super(templater);
	}

	
	/**
	 * generate ޼ override
	 * 
	 * TestPlan
	 * -  mdbConetxt null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : mdbConetxt null  ϴ. ) 
	 * -  mdbConetxt class type Ejb2MDBContext ƴϸ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : mdbConetxt Type Ejb2MDBConetxt ƴմϴ. )
	 */
	public void generate(MDBContext mdbConetxt,	String outputDirectory) throws GeneratorSourceGeneratorException {
		if( mdbConetxt == null )
			throw new GeneratorSourceGeneratorException("mdbConetxt null  ϴ.");
		
		if( !(mdbConetxt instanceof Ejb2MDBContext) ) 
			throw new GeneratorSourceGeneratorException("mdbConetxt Type Ejb2EjbJarContext ƴմϴ.");
		
		generateSource(mdbConetxt, outputDirectory);
	}

	
	/**
	 * ҽ merge ϰ Ͽ ϴ ޼
	 * 
	 * TestPlan
	 * -  context null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : Context null  ϴ. )
	 * -  outputDirectory null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : outputDirectory null  ϴ. )
	 * 
	 * @param context
	 * @param outputDirectory
	 */
	protected void generateSource(Context context, String outputDirectory) throws GeneratorSourceGeneratorException {
		Ejb2MDBContext actionHandlerContext = (Ejb2MDBContext)context;
		
		String ejb2ActionHandlerMDBSource = null;
		
		// Template context merge
		try {
			ejb2ActionHandlerMDBSource = templateEngine.merge(Ejb2MDBTemplateFileName, context);
		}
		catch(GeneratorTemplateException e) {
			throw new GeneratorSourceGeneratorException(e);
		}
		
		// Ͽ ҽ 
		try {
			SourceWriter.getInstance().writeSource(ejb2ActionHandlerMDBSource, FileIoUtil.fileSeparatorAddOrNone(outputDirectory) + Ejb2ActionHandlerMDBOutputDirectory, actionHandlerContext.getClassName() + ".java");
		}
		catch(GeneratorIOException e) {
			throw new GeneratorSourceGeneratorException(e);
		}
	}
}
