package org.kldp.ebmsh.bi.generator.source;

import org.kldp.ebmsh.bi.generator.context.Context;
import org.kldp.ebmsh.bi.generator.context.ServerDescriptionContext;
import org.kldp.ebmsh.bi.generator.io.GeneratorIOException;
import org.kldp.ebmsh.bi.generator.io.SourceWriter;
import org.kldp.ebmsh.bi.generator.template.GeneratorTemplateException;
import org.kldp.ebmsh.bi.generator.template.TemplateEngine;

import com.softmeca.util.io.FileIoUtil;


/**
 * JEUS5 Server description mergeϰ   Ͽ ϴ Ŭ
 * 
 * @author ø콺
 */
public class Jeus5ServerDescriptionGenerator extends ServerDescriptionGenerator {
	/**
	 * Jeus5ServerDescriptionFileName
	 */
	private final String Jeus5ServerDescriptionFileName = "Jeus5ServerDescription.vm";
	
	/**
	 * Jeus5ServerDescriptionOutputDirectory
	 */
	private final String Jeus5ServerDescriptionOutputDirectory = "META-INF";
	
	/**
	 * Jeus5ServerDescriptionOutputFileName
	 */
	private final String Jeus5ServerDescriptionOutputFileName = "jeus-ejb-dd.xml";

	
	/**
	 * 
	 * 
	 * @param templateGenerator
	 */
	public Jeus5ServerDescriptionGenerator(TemplateEngine templateGenerator) {
		super(templateGenerator);
	}

	
	/**
	 * generate ޼ override
	 * 
	 * TestPlan
	 * -  serverDescriptionContext null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : serverDescriptionContext null  ϴ. ) 
	 * -  serverDescriptionContext class type Ejb2ServerDescriptionContext ƴϸ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : serverDescriptionContext Type Jeus5ServerDescriptionContext ƴմϴ. )
	 */
	public void generate(ServerDescriptionContext serverDescriptionContext, String outputDirectory) throws GeneratorSourceGeneratorException {
		generateSource(serverDescriptionContext, outputDirectory);
	}

	
	/**
	 * ҽ merge ϰ Ͽ ϴ ޼
	 * 
	 * TestPlan
	 * -  context null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : Context null  ϴ. )
	 * -  outputDirectory null Ѿ GeneratorSourceGeneratorException ߻Ų. ( errorMessage : outputDirectory null  ϴ. )
	 * 
	 * @param context
	 * @param outputDirectory
	 */
	protected void generateSource(Context context, String outputDirectory) throws GeneratorSourceGeneratorException {
		String serverDescriptionContextSource = null;
		
		
		// Template context merge
		try {
			serverDescriptionContextSource = templateEngine.merge(Jeus5ServerDescriptionFileName, context);
		}
		catch(GeneratorTemplateException e) {
			throw new GeneratorSourceGeneratorException(e);
		}
		
		
		// Ͽ ҽ 
		try {
			SourceWriter.getInstance().writeSource(serverDescriptionContextSource, FileIoUtil.fileSeparatorAddOrNone(outputDirectory) + Jeus5ServerDescriptionOutputDirectory, Jeus5ServerDescriptionOutputFileName);
		}
		catch(GeneratorIOException e) {
			throw new GeneratorSourceGeneratorException(e);
		}
	}

}
