package org.kldp.ebmsh.bi.generator.template;

import java.io.StringWriter;
import java.util.Iterator;
import java.util.Set;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.Velocity;
import org.kldp.ebmsh.bi.generator.context.Context;

import com.softmeca.util.io.FileIoUtil;


/**
 * VelocityTemplater
 * 
 * template  Velocity մϴ.
 * 
 * @author ø콺
 */
public class VelocityTemplateEngine extends TemplateEngine {
	/**
	 * templateFileName شϴ Template о, context ˸° merge   String Ѵ.
	 * 
	 * Test plan
	 * - templateFileName ڷ null̳ ڿ   -> TemplaterException ߻ ( error : template file name null  ϴ. )
	 * - context ڷ null   -> TemplaterException ߻ ( error : context null  ϴ. )
	 * 
	 * @param templateFileName
	 * @param context
	 * @return
	 */
	public String merge(String templateFileName, Context context) throws GeneratorTemplateException {
		if( templateFileName == null || templateFileName.equals("") )
			throw new GeneratorTemplateException("template file name null̳  ڿ  ϴ.");
		
		if( context == null )
			throw new GeneratorTemplateException("context null  ϴ");
		
		// Context to Velocity context
		VelocityContext velocityContext = new VelocityContext();
		
		Set<String> keySet = context.getKeySet();		
		Iterator<String> keyIterator = keySet.iterator();
		
		while( keyIterator.hasNext() ) {
			String key = keyIterator.next();
			String value = context.getValue(key);
			
			velocityContext.put(key, value);
		}
		
		// Merge
		String templatedSource = "";
		
		try {
			String templateFilePath = FileIoUtil.fileSeparatorAddOrNone(TEMPLATE_DIRECTORY) + templateFileName;
			StringWriter stringWriter = new StringWriter();
			
			Template template = Velocity.getTemplate( templateFilePath );
			template.merge(velocityContext, stringWriter);
			
			templatedSource = stringWriter.toString();
			
			stringWriter.flush();
			stringWriter.close();
		}
		catch(Exception e) {
			throw new GeneratorTemplateException("Template Mergeϴµ ߽ϴ.", e);
		}
		
		return templatedSource;
	}

}
