package org.kldp.ebmsh.bi;


/**
 * @author sirius
 * @since 2007-02-22
 * @version v1.0
 *
 * @$comment Business logic root exception
 */

public class BiException extends RuntimeException {
	private int errorLevel = 0;
	private int errorCode = 0;
	
	
	/**
	 * @stereotype constructor
	 */
	
	public BiException() {
		super();
		
		this.setErrorLevel(-1);
		this.setErrorCode(-1);
	} 
	
	
	/**
	 * @stereotype constructor
	 */
	
	public BiException(int errorLevel, int errorCode) {
		super();
		
		this.setErrorLevel(errorLevel);
		this.setErrorCode(errorCode);
	}
	
	
	/**
	 * @stereotype constructor
	 */
	
	public BiException(int errorLevel, int errorCode, String message) {
		super(message);
		
		this.setErrorLevel(errorLevel);
		this.setErrorCode(errorCode);
	}
	
	
	/**
	 * @stereotype constructor
	 */
	
	public BiException(int errorLevel, int errorCode, String message, Throwable cause) {
		super(message, cause);
		
		this.setErrorLevel(errorLevel);
		this.setErrorCode(errorCode);
	}
	
	
	/**
	 * @stereotype constructor
	 */
	
	public BiException(int errorLevel, int errorCode, Throwable cause) {
		super(cause);
		
		this.setErrorLevel(errorLevel);
		this.setErrorCode(errorCode);
	}
	
	public void setErrorLevel(int errorLevel) {
		this.errorLevel = errorLevel;
	}
	
	public int getErrorLevel() {
		return this.errorLevel;
	}
	
	public void setErrorCode(int errorCode) {
		this.errorCode = errorCode;
	}
	
	public int getErrorCode() {
		return this.errorCode;
	}
}
