package org.kldp.ebmsh.bi.environment;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.util.io.FileIoUtil;
import org.kldp.util.log.LogUtil;

/**
 * Bizbox environment
 * 
 * Bizbox õ ȯ   ִ.
 * 
 * @author Sirius
 */
public class EbbiConstants {
	private final static Log log = LogFactory.getLog(EbbiConstants.class);
	
	public static String queueConnectionFactoryName; // <queueConnectionFactoryName> 1
	public static String queueJNDIHeaderName; // <queueJNDIHeaderName> 1
	public static String applicationResultQueueName; // <applicationResultQueueName> 1
	public static String trackerQueueName; // <trackerQueueName> 1
	
	public static String dataSourceName; // <dataSourceName> 1
	
	public static int duplicateErrorCode; // oracle
	public static String databaseType;
	
	public static String bizboxDatabaseHeaderName;
	
	static {
		log.info("BusinessLogic   ε մϴ.");
		
		String jeusHomeDirectory = System.getProperty("user.dir");
		
		String ebmsDirectory = FileIoUtil.fileSeparatorAddOrNone( jeusHomeDirectory + File.separator + "webhome" + File.separator + "deploy_home" + File.separator + "EbmsEngine" );
		
		String ebmsConfigPath = ebmsDirectory + "config" + File.separator + "ebmsConfig.properties";
		
		log.info("BusinessLogic   : " + ebmsConfigPath);
		
		Properties properties = new Properties();
		
		try {
			properties.load(new FileInputStream(ebmsConfigPath));
			
			EbbiProperties ebbiProperties = new EbbiProperties(properties);
			
			dataSourceName = ebbiProperties.getDataSourceName();	
			log.info("dataSourceName -> " + dataSourceName);
			
			queueConnectionFactoryName = ebbiProperties.getQueueConnectionFactoryName();
			log.info("queueConnectionFactoryName -> " + queueConnectionFactoryName);
			
			queueJNDIHeaderName = ebbiProperties.getQueueJNDIHeaderName();
			log.info("queueJNDIHeaderName -> " + queueJNDIHeaderName);
			
			trackerQueueName = ebbiProperties.getTrackerQueueName();
			log.info("trackerQueueName -> " + trackerQueueName);
			
			applicationResultQueueName = ebbiProperties.getApplicationResultQueueName();
			log.info("applicationResultQueueName -> " + trackerQueueName);
			
			databaseType = ebbiProperties.getDatabaseType();
			
			if( databaseType.equals("mysql") ) {
				duplicateErrorCode = 1062;
			}
			else if( databaseType.equals("oracle") ) {
				duplicateErrorCode = 1;
			}
			log.info("databaseType -> " + databaseType);
			log.info("duplicateErrorCode -> " + duplicateErrorCode);
			
			bizboxDatabaseHeaderName = ebbiProperties.getBizboxDatabaseHeaderName();
			log.info("bizboxDatabaseHeaderName -> " + bizboxDatabaseHeaderName);
		}
		catch(IOException e) {
			log.fatal(LogUtil.stackTraceToString(e));
		}
	}
}