package org.kldp.ebmsh.bi.persistant;

import java.util.Date;

import org.kldp.ebmsh.bi.environment.EbbiConstants;



public class BiDatabaseManager {
	/**
	 * MessageStatus ϰ Ʈϴ ޼
	 * 
	 * @param messageId
	 * @param status
	 * @param statusDesc
	 * @throws BiPersistantException
	 */
	public void saveMessageStatus(String messageId, int status, String statusDesc) throws BiPersistantException {
		BiMessageStatusDAO bsiMessageStatusDAO = new BiMessageStatusDAO();
		
		try {
			bsiMessageStatusDAO.insertMessageStatus(messageId, status, statusDesc);
		}
		catch(BiPersistantException e) {
			if( e.getErrorCode() == EbbiConstants.duplicateErrorCode )
				bsiMessageStatusDAO.updateMessageStatus(messageId, status, statusDesc);
			else
				throw e;
		}
	}
	
	/**
	 * DocumentId  ɴϴ.
	 * 
	 * DocumentId Action, ÷ι ġ, XPath  ֽϴ.
	 * 
	 * @param action
	 * @return
	 * @throws BiPersistantException
	 */
	public DocumentIdInfo getDocumentIdInfoByAction(String action) throws BiPersistantException {
		DocumentIdInfoDAO documentIdInfoDAO = new DocumentIdInfoDAO();
		
		return documentIdInfoDAO.getDocumentIdInfoByAction(action);
	}
	
	
	/**
	 * MessageId DocumentId    մϴ.
	 * 
	 * @param messageId
	 * @param documentId
	 * @throws BiPersistantException
	 */
	public void saveMessageIdAndDocumentId(String messageId, String documentId) throws BiPersistantException {
		MessageIdAndDocumentIdDAO messageIdAndDocumentIdDAO = new MessageIdAndDocumentIdDAO();
		
		try {
			messageIdAndDocumentIdDAO.insertMessageIdAndDocumentId(messageId, documentId);
		}
		catch(BiPersistantException ex) {
			if( ex.getErrorCode() == EbbiConstants.duplicateErrorCode  ) {
				messageIdAndDocumentIdDAO.updateMessageIdAndDocumentId(messageId, documentId);
			}
			else
				throw ex;
		}
	}
	
	public void insertTrackerDetail(String messageId, String state, String information) throws BiPersistantException {
		TrackerDAO trackerDAO = new TrackerDAO();
		
		trackerDAO.insertTracker(messageId, new Date().getTime(), state, information);
	}
}