package org.kldp.ebmsh.bi.persistant;

import java.sql.Connection;
import java.sql.SQLException;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.bi.environment.EbbiConstants;



class BiMessageStatusDAO {
	private final static Log log = LogFactory.getLog(BiMessageStatusDAO.class);
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbxmlPersistantException
	 */
	void insertMessageStatus(String messageId, int messageStatus, String statusDesc) throws BiPersistantException {
		final String queryStr = "insert into " + EbbiConstants.bizboxDatabaseHeaderName + "BsiMessageStatus(MessageId, Status, StatusDesc) values(?, ?, ?)";
		
		int status = messageStatus;
		
		final Object[] parameters = new Object[3];
		parameters[0] = messageId; // [0] MessageId
		parameters[1] = new Integer(status); // [1] Status
		parameters[2] = statusDesc; // [2] StatusDesc
		
		DbTemplate dbTemplate = new DbTemplate();
		dbTemplate.executeQuery(
				new DbWorker() {
					public Object work(Connection _conn) throws BiPersistantException {
						QueryRunner runner = new QueryRunner();
						
						try {
							runner.update(_conn, queryStr, parameters);
						} 
						catch (SQLException e) {
							throw new BiPersistantException(1, e.getErrorCode(), e);
						}
						
						return null;
					}
				}
			);
	}
	
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbxmlPersistantException
	 */
	void updateMessageStatus(String messageId, int messageStatus, String statusDesc) throws BiPersistantException {
		final String queryStr = "update " + EbbiConstants.bizboxDatabaseHeaderName + "BsiMessageStatus set Status=?, StatusDesc=? where MessageId=?";
		
		int status = messageStatus;
		
		final Object[] parameters = new Object[3];
		parameters[0] = new Integer(status); // [0] Status
		parameters[1] = statusDesc; // [1] StatusDesc
		parameters[2] = messageId; // [2] MessageId
		
		
		DbTemplate dbTemplate = new DbTemplate();
		dbTemplate.executeQuery(
				new DbWorker() {
					public Object work(Connection _conn) throws BiPersistantException {
						QueryRunner runner = new QueryRunner();
						
						try {
							runner.update(_conn, queryStr, parameters);
						} catch (SQLException e) { 
							throw new BiPersistantException(1, e.getErrorCode(), e);
						}
						
						return null;
					}
				}
			);
	}
}
