package org.kldp.ebmsh.bi.persistant;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.apache.commons.dbutils.handlers.BeanListHandler;
import org.kldp.ebmsh.bi.environment.EbbiConstants;



public class DocumentIdInfoDAO {
	/**
	 * Action شϴ DocumentId ɴϴ.
	 * 
	 * @param messageId
	 * @return
	 * @throws EbxmlPersistantException
	 */
	public DocumentIdInfo getDocumentIdInfoByAction(String action) throws BiPersistantException {
		DocumentIdInfo documentIdInfo = null;
		
		DbTemplate dbTemplate = new DbTemplate();
		
		final String queryStr = "select * from " + EbbiConstants.bizboxDatabaseHeaderName + "DocumentIdInfo where Action=?";
		
		final Object[] parameters = new Object[1];
		parameters[0] = action; // [0] Action
		
		documentIdInfo = (DocumentIdInfo)dbTemplate.executeQuery(
				new DbWorker() {
					
					public Object work(Connection _conn) throws BiPersistantException {
						QueryRunner runner = new QueryRunner();
						ResultSetHandler resultSetHandler = new BeanHandler(DocumentIdInfo.class);
						
						DocumentIdInfo documentIdInfo = null;
						
						try {
							documentIdInfo = (DocumentIdInfo)runner.query(_conn, queryStr, parameters, resultSetHandler);
						}
						catch(SQLException e) {
							throw new BiPersistantException(0, e.getErrorCode(), e);
						}
						
						return documentIdInfo;
					}
					
				});
		
		return documentIdInfo;
	}
	
	
	/**
	 * DB ϵ  DocumentIdInfo ɴϴ.
	 * 
	 * @param messageId
	 * @return
	 * @throws EbxmlPersistantException
	 */
	public List getDocumentIds() throws BiPersistantException {
		List documentIdInfos = null;
		
		DbTemplate dbTemplate = new DbTemplate();
		
		final String queryStr = "select * from " + EbbiConstants.bizboxDatabaseHeaderName + "DocumentIdInfo";
		
		documentIdInfos = (List)dbTemplate.executeQuery(
				new DbWorker() {
					
					public Object work(Connection _conn) throws BiPersistantException {
						QueryRunner runner = new QueryRunner();
						ResultSetHandler resultSetHandler = new BeanListHandler(DocumentIdInfo.class);
						
						List documentIdInfos = null;
						
						try {
							documentIdInfos = (List)runner.query(_conn, queryStr, resultSetHandler);
						}
						catch(SQLException e) {
							throw new BiPersistantException(0, e.getErrorCode(), e);
						}
						
						return documentIdInfos;
					}
					
				});
		
		return documentIdInfos;
	} 
}