package org.kldp.ebmsh.bi.persistant;

import java.sql.Connection;
import java.sql.SQLException;

import org.apache.commons.dbutils.QueryRunner;
import org.kldp.ebmsh.bi.environment.EbbiConstants;


class MessageIdAndDocumentIdDAO {
	/**
	 * " + Environment.bizboxDatabaseName + "Tracker TrackerKey MessageId մϴ.
	 * 
	 * @param trackerKey
	 * @param messageId
	 * @throws EbxmlPersistantException
	 */
	void insertMessageIdAndDocumentId(String messageId, String documentId) throws BiPersistantException {
		final String queryStr = "insert into " + EbbiConstants.bizboxDatabaseHeaderName + "MessageIdAndDocumentId(MessageId, DocumentId) values(?, ?)";
		
		final Object[] parameters = new Object[2];
		parameters[0] = messageId; // [0] MessageId
		parameters[1] = documentId; // [1] DocumentId
		
		DbTemplate dbTemplate = new DbTemplate();
		dbTemplate.executeQuery(
				new DbWorker() {
					public Object work(Connection _conn) throws BiPersistantException {
						QueryRunner runner = new QueryRunner();
						
						try {
							runner.update(_conn, queryStr, parameters);
						} catch (SQLException e) {
							throw new BiPersistantException(1, e.getErrorCode(), e);
						}
						
						return null;
					}
				}
			);
	}
	
	
	/**
	 * " + Environment.bizboxDatabaseName + "Tracker TrackerKey MessageId մϴ.
	 * 
	 * @param trackerKey
	 * @param messageId
	 * @throws EbxmlPersistantException
	 */
	void updateMessageIdAndDocumentId(String messageId, String documentId) throws BiPersistantException {
		final String queryStr = "update " + EbbiConstants.bizboxDatabaseHeaderName + "MessageIdAndDocumentId set DocumentId=? where MessageId=?";
		
		final Object[] parameters = new Object[2];
		parameters[0] = documentId; // [0] DocumentId
		parameters[1] = messageId; // [1] MessageId
		
		DbTemplate dbTemplate = new DbTemplate();
		dbTemplate.executeQuery(
				new DbWorker() {
					public Object work(Connection _conn) throws BiPersistantException {
						QueryRunner runner = new QueryRunner();
						
						try {
							runner.update(_conn, queryStr, parameters);
						} catch (SQLException e) {
							throw new BiPersistantException(1, e.getErrorCode(), e);
						}
						
						return null;
					}
				}
			);
	}
}
