package org.kldp.ebbp.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;
import org.kldp.ebbp.instance.Bprole;


/**
 * Data access object (DAO) for domain model class Bprole.
 * @see com.softmeca.ebbp.hibernate.Bprole
 * @author MyEclipse - Hibernate Tools
 */
public class BproleDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(BproleDAO.class);

	//property constants
	public static final String ROLE_ID = "roleId";

    
    public void save(Bprole transientInstance) {
        log.debug("saving Bprole instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Bprole persistentInstance) {
        log.debug("deleting Bprole instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Bprole findById( java.lang.String id) {
        log.debug("getting Bprole instance with id: " + id);
        try {
            Bprole instance = (Bprole) getSession()
                    .get("com.softmeca.ebbp.instance.Bprole", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Bprole instance) {
        log.debug("finding Bprole instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.softmeca.ebbp.instance.Bprole")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Bprole instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Bprole as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByRoleId(Object roleId) {
		return findByProperty(ROLE_ID, roleId);
	}
	
    public Bprole merge(Bprole detachedInstance) {
        log.debug("merging Bprole instance");
        try {
            Bprole result = (Bprole) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Bprole instance) {
        log.debug("attaching dirty Bprole instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Bprole instance) {
        log.debug("attaching clean Bprole instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}