package org.kldp.ebbp.instance;

import java.io.File;
import java.util.Date;

import org.apache.xmlbeans.XmlObject;
import org.kldp.ebbp.config.Config;
import org.kldp.ebbp.dao.ProcessspecificationDAO;
import org.kldp.ebbp.exception.EbbpResourceNotFoundException;
import org.kldp.ebbp.exception.EbbpXmlException;
import org.oasisOpen.docs.ebxmlBp.ebbp20.BinaryCollaborationType;
import org.oasisOpen.docs.ebxmlBp.ebbp20.BusinessCollaborationType;
import org.oasisOpen.docs.ebxmlBp.ebbp20.MultiPartyCollaborationType;
import org.oasisOpen.docs.ebxmlBp.ebbp20.ProcessSpecificationDocument;

import com.softmeca.util.io.FileIoUtil;


/**
 * Bpinstance generated by MyEclipse - Hibernate Tools
 */
public class Bpinstance implements java.io.Serializable {
	// Fields    
	private String bpInstanceId;
	private String processSpecificationId;
	
	private Bprole bprole;
	private Bpcollaboration bpcollaboration;
	private Bpinstancetime bpinstancetime;
	private Bpinstancestatus bpinstancestatus;
	private Bpinstancestate bpinstancestate;
	private Processspecification processspecification;
	
	
	/**
	 * @param ebbpInstanceId
	 * @param bpId
	 * @param collaborationNameID
	 * @param roleNameID
	 * @throws EbbpXmlException
	 * @throws EbbpResourceNotFoundException
	 */
	public Bpinstance(String bpInstanceId, String processSpecificationId, String collaborationNameID, String roleNameID) throws EbbpXmlException, EbbpResourceNotFoundException {
		try {
			// Bp  
			// String processSpecificationPath = FileIoUtil.fileSeparatorAddOrNone(Config.ProcessSpecificationDirectory) + processSpecificationId + ".xml";
			
			// Bp instance id 
			this.setBpInstanceId(bpInstanceId);
			
			Processspecification processSpecification = new ProcessspecificationDAO().findById(processSpecificationId);
			
			if( processSpecification == null ) 
				throw new EbbpResourceNotFoundException("Business process ã  ϴ.");
			
			this.setProcessspecification(processSpecification);
			
			// Collaboration 
			Bpcollaboration bpcollaboration = new Bpcollaboration();
			bpcollaboration.setBpinstance(this);
			bpcollaboration.setCollaborationId(collaborationNameID);			
			this.setBpcollaboration(bpcollaboration);
			
			// Role 
			Bprole bprole = new Bprole();
			bprole.setBpinstance(this);
			bprole.setRoleId(roleNameID);			
			this.setBprole(bprole);
			
			// Bpinstance status 
			Bpinstancestatus bpinstancestatus = new Bpinstancestatus();
			bpinstancestatus.setBpinstance(this);
			bpinstancestatus.setStatus("INITED");
			bpinstancestatus.setStatusTime(new Date());			
			this.setBpinstancestatus(bpinstancestatus);
			
			// Bpinstance state 
			Bpinstancestate bpinstancestate = new Bpinstancestate();
			bpinstancestate.setBpinstance(this);
			bpinstancestate.setState(BpinstancestateConstant.INITED);
			bpinstancestate.setStateTime(new Date());
			this.setBpinstancestate(bpinstancestate);
			
			
			// bpinstance time 
			Bpinstancetime bpinstancetime = new Bpinstancetime();
			bpinstancetime.setBpinstance(this);
			bpinstancetime.setStartTime(new Date());
			bpinstancetime.setEndTime(new Date());
			this.setBpinstancetime(bpinstancetime);
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	// Constructors
	public Processspecification getProcessspecification() {
		return processspecification;
	}

	public void setProcessspecification(Processspecification businessprocess) {
		this.processspecification = businessprocess;
	}

	public Bpinstancestate getBpinstancestate() {
		return bpinstancestate;
	}

	public void setBpinstancestate(Bpinstancestate bpinstancestate) {
		this.bpinstancestate = bpinstancestate;
	}

	public Bpinstancestatus getBpinstancestatus() {
		return bpinstancestatus;
	}

	public void setBpinstancestatus(Bpinstancestatus bpinstancestatus) {
		this.bpinstancestatus = bpinstancestatus;
	}

	public Bpinstancetime getBpinstancetime() {
		return bpinstancetime;
	}

	public void setBpinstancetime(Bpinstancetime bpinstancetime) {
		this.bpinstancetime = bpinstancetime;
	}

	/** default constructor */
	public Bpinstance() {
	}

	/** minimal constructor */
	public Bpinstance(String bpInstanceId) {
		this.bpInstanceId = bpInstanceId;
	}

	/** full constructor */
	public Bpinstance(String bpInstanceId, String bpId, Bprole bprole) {
		this.bpInstanceId = bpInstanceId;
		this.processSpecificationId = bpId;
		this.bprole = bprole;
	}


	// Property accessors

	public String getBpInstanceId() {
		return this.bpInstanceId;
	}

	public void setBpInstanceId(String bpInstanceId) {
		this.bpInstanceId = bpInstanceId;
	}

	public String getProcessSpecificationId() {
		return this.processSpecificationId;
	}

	public void setProcessSpecificationId(String bpId) {
		this.processSpecificationId = bpId;
	}

	public Bprole getBprole() {
		return this.bprole;
	}

	public void setBprole(Bprole bprole) {
		this.bprole = bprole;
	}

	public Bpcollaboration getBpcollaboration() {
		return bpcollaboration;
	}

	public void setBpcollaboration(Bpcollaboration bpcollaboration) {
		this.bpcollaboration = bpcollaboration;
	}
	
	
	/**
	 * Start state ãϴ.
	 */
	public void getStartState() {
		
	}
}