package org.kldp.ebbp.processspecification;

import org.apache.xmlbeans.XmlObject;
import org.kldp.ebbp.processspecification.collaboration.BusinessCollaboration;
import org.kldp.ebbp.processspecification.collaboration.Collaboration;
import org.oasisOpen.docs.ebxmlBp.ebbp20.BinaryCollaborationType;
import org.oasisOpen.docs.ebxmlBp.ebbp20.BusinessCollaborationType;
import org.oasisOpen.docs.ebxmlBp.ebbp20.ProcessSpecificationDocument;


public class ProcessSpecification {
	private ProcessSpecificationDocument processSpecificationDocument = null;
	private ProcessSpecificationDocument.ProcessSpecification processSpecification = null;
	
	public ProcessSpecification(ProcessSpecificationDocument processSpecificationDocument, ProcessSpecificationDocument.ProcessSpecification processSpecification) {
		this.processSpecificationDocument = processSpecificationDocument;
		this.processSpecification = processSpecification;
	}
	
	public Collaboration getCollaboration(String nameID) {
		Collaboration collaboration = null;
		
		String ebbpNamespace = "declare namespace ebbp='http://docs.oasis-open.org/ebxml-bp/ebbp-2.0';";

		String pathExpression = "$this//ebbp:BusinessCollaboration[@nameID='" + nameID + "'] " +
				"| $this//ebbp:BinaryCollaboration[@nameID='" + nameID + "'] " +
				"| $this//ebbp:MultipartyCollaboration[@nameID='" + nameID + "']";
		
		XmlObject[] results = processSpecification.selectPath(ebbpNamespace + pathExpression);
		
		if( results.length == 0 )
			throw new RuntimeException("Collaboration ã  ϴ.");
		
		if( results.length > 1 )
			throw new RuntimeException(" ̸  collaboration ߺǼ մϴ.");
		
		XmlObject result = results[0];
		
		if( result instanceof BusinessCollaborationType )
			collaboration = new BusinessCollaboration((BusinessCollaborationType)result);
		else
			throw new RuntimeException(" ʴ Collaboration typeԴϴ.");
		
		return collaboration;
	}
}
