package org.kldp.ebbp.processspecification;

import java.io.File;
import java.io.IOException;
import java.util.Hashtable;

import org.apache.xmlbeans.XmlException;
import org.kldp.ebbp.config.Config;
import org.oasisOpen.docs.ebxmlBp.ebbp20.ProcessSpecificationDocument;

import com.softmeca.util.io.FileIoUtil;

public class ProcessSpecificationManager {
	private final static ProcessSpecificationManager processSpecificationManager = new ProcessSpecificationManager();
	private static Hashtable<String, ProcessSpecificationDocument> processSpecificationStore;
	
	private ProcessSpecificationManager() {
		processSpecificationStore = new Hashtable<String, ProcessSpecificationDocument>();
		
		this.parseProcessSpecification();
	}
	
	public static ProcessSpecificationManager getInstance() {
		return processSpecificationManager;
	}
	
	public void parseProcessSpecification() {
		try {
			File file = new File(Config.ProcessSpecificationDirectory);
			
			if( !file.exists() ) {
				System.err.println("ProcessSpecification 丮  ʽϴ. -> " + Config.ProcessSpecificationDirectory);
				
				throw new RuntimeException("ProcessSpecification 丮  ʽϴ. -> " + Config.ProcessSpecificationDirectory);
			}
			
			String[] processSpecificationArray = file.list();
			
			for(int i = 0; i < processSpecificationArray.length; i++) {
				System.out.println("\t" + processSpecificationArray[i] + " parsing");
				
				processSpecificationArray[i] = processSpecificationArray[i].substring(0, processSpecificationArray[i].length() - 4);
				
				ProcessSpecificationDocument processSpecificationDoc = null;
				
				processSpecificationDoc = ProcessSpecificationDocument.Factory.parse( new File( FileIoUtil.fileSeparatorAddOrNone(Config.ProcessSpecificationDirectory) + processSpecificationArray[i] + ".xml" ) );
				
				processSpecificationStore.put(processSpecificationArray[i], processSpecificationDoc);
			}
		}
		catch(XmlException e) {
			e.printStackTrace();
		}
		catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public ProcessSpecification getProcessSpecification(String processSpecificiationId) {
		ProcessSpecificationDocument processSpecificationDocument = (ProcessSpecificationDocument)processSpecificationStore.get(processSpecificiationId);
		
		if( processSpecificationDocument != null )
			return new ProcessSpecification(processSpecificationDocument, processSpecificationDocument.getProcessSpecification());
		else
			return null;
	}
}
