package org.kldp.ebbp.processspecification.state;

import org.apache.xmlbeans.XmlObject;
import org.kldp.ebbp.processspecification.transactionactivity.BusinessTransactionActivity;
import org.oasisOpen.docs.ebxmlBp.ebbp20.BusinessTransactionActivityDocument;
import org.oasisOpen.docs.ebxmlBp.ebbp20.BusinessTransactionType;
import org.oasisOpen.docs.ebxmlBp.ebbp20.impl.BusinessTransactionTypeImpl;


public class ToLink extends BusinessStateLink {
	private org.oasisOpen.docs.ebxmlBp.ebbp20.ToLinkDocument.ToLink toLink;
	
	public ToLink(org.oasisOpen.docs.ebxmlBp.ebbp20.ToLinkDocument.ToLink toLink) {
		this.toLink = toLink;
	}
	
	public String getToBusinessStateRefByString() {
		return toLink.getToBusinessStateRef();
	}
	
	public State getToBusinessStateRefByState() {
		String businessTransactionRef = toLink.getToBusinessStateRef();
		
		String ebbpNamespace = "declare namespace ebbp='http://docs.oasis-open.org/ebxml-bp/ebbp-2.0';";

		String pathExpression = "//ebbp:BusinessTransactionActivity[@nameID='" + businessTransactionRef + "']";
		
		XmlObject[] results = toLink.selectPath(ebbpNamespace + pathExpression);
		
		BusinessTransactionActivityDocument.BusinessTransactionActivity bta = (BusinessTransactionActivityDocument.BusinessTransactionActivity)results[0];
		
		return new BusinessTransactionActivity(bta);
	}
}
