package org.kldp.ebbp.queue;

import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.QueueSession;

public class CompleteMessageConverter implements MessageConverter {
	public Message convertToJMSMessage(QueueSession queueSession, QueueMessage queueMessage) {
		MapMessage mapMessage = null;
		CompleteMessage completeMessage = (CompleteMessage)queueMessage;
		
		try {
			validateMessage(completeMessage);
			
			mapMessage = queueSession.createMapMessage();
			
			mapMessage.setString("messageType", completeMessage.getMessageType());
			mapMessage.setString("workflowInstanceId", completeMessage.getWorkflowInstanceId());
			mapMessage.setString("nextStateNameID", completeMessage.getNextStateNameID());
			mapMessage.setObject("message", completeMessage.getMessage());
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
		return mapMessage;
	}

	
	public QueueMessage convertToQueueMessage(Message message) {
		try {
			MapMessage mapMessage = (MapMessage)message;
			
			CompleteMessage completeMessage = new CompleteMessage();
			
			completeMessage.setWorkflowInstanceId( mapMessage.getString("workflowInstanceId") );
			completeMessage.setNextStateNameID( mapMessage.getString("nextStateNameID") );
			completeMessage.setMessage(mapMessage.getObject("message"));
			
			return completeMessage;
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
		return null;
	}

	public void validateMessage(Message message) {
		try {
			if( message == null )
				throw new IllegalArgumentException("Message nullԴϴ.");
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	public void validateMessage(QueueMessage queueMessage) {
		try {
			if( queueMessage == null )
				throw new IllegalArgumentException("CompleteMessage nullԴϴ.");
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
}
