package org.kldp.ebbp.queue;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;


/**
 * QueueHelper 
 * 
 * Ư JMS Queue ޽   ϴ Helper Ŭ
 * 
 * @author Sirius
 */
public class QueueHelper {
	protected Queue queue;
	protected QueueConnectionFactory queueConnectionFactory;
	
	public QueueHelper(QueueConnectionFactory queueConnectionFactory, Queue queue) {
		this.queue = queue;
		this.queueConnectionFactory = queueConnectionFactory;
	}
	
	public void sendMessage(QueueMessage queueMessage, MessageConverter messageConverter) throws JMSException {
		QueueConnection queueConnection = null;
		QueueSession session = null;
		QueueSender queueSender = null;
		
		try {
			queueConnection = queueConnectionFactory.createQueueConnection();
			session = queueConnection.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
			queueSender = session.createSender(queue);
			
			// QueueMessage javax.jms.Message ȯѴ.
			Message message = messageConverter.convertToJMSMessage(session, queueMessage);
			
			// Queue ޽ Ѵ.
			queueSender.send(message);
		}
		finally {
			try {
				if( queueSender != null )
					try {
						queueSender.close();
					}
					catch(JMSException e) {
						e.printStackTrace();
					}
					
				
				if( session != null )
					try {
						session.close();
					}
					catch(JMSException e) {
						e.printStackTrace();
					}
				
				if( queueConnection != null )
					try {
						queueConnection.close();
					}
					catch(JMSException e) {
						e.printStackTrace();
					}
			}
			catch(Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	public void sendMessage(Message jmsMessage) throws JMSException {
		QueueConnection queueConnection = null;
		QueueSession session = null;
		QueueSender queueSender = null;
		
		try {
			queueConnection = queueConnectionFactory.createQueueConnection();
			session = queueConnection.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
			queueSender = session.createSender(queue);
			
			// Queue ޽ Ѵ.
			queueSender.send(jmsMessage);
		}
		finally {
			try {
				if( queueConnection != null )
					queueConnection.close();
			}
			catch(Exception e) {
				e.printStackTrace();
			}
		}
	}
}