package org.kldp.ebbp.queue;

import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.QueueSession;

public class StartMessageConverter implements MessageConverter {
	public Message convertToJMSMessage(QueueSession queueSession, QueueMessage queueMessage) {
		MapMessage mapMessage = null;
		StartMessage startMessage = (StartMessage)queueMessage;
		
		try {
			validateMessage(startMessage);
			
			mapMessage = queueSession.createMapMessage();
			
			mapMessage.setString("messageType", startMessage.getMessageType());
			
			mapMessage.setString("workflowInstanceId", startMessage.getWorkflowInstanceId());
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
		return mapMessage;
	}

	
	public QueueMessage convertToQueueMessage(Message message) {
		try {
			MapMessage mapMessage = (MapMessage)message;
			
			StartMessage startMessage = new StartMessage();
			
			startMessage.setWorkflowInstanceId( mapMessage.getString("workflowInstanceId") );
			
			return startMessage;
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
		return null;
	}

	public void validateMessage(Message message) {
		try {
			if( message == null )
				throw new IllegalArgumentException("Message nullԴϴ.");
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	public void validateMessage(QueueMessage queueMessage) {
		try {
			if( queueMessage == null )
				throw new IllegalArgumentException("StartMessage nullԴϴ.");
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
}
