package org.kldp.ebbp.queue;

import javax.ejb.EJBException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.QueueConnectionFactory;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.kldp.ebbp.dao.BpinstanceDAO;
import org.kldp.ebbp.instance.Bpcollaboration;
import org.kldp.ebbp.instance.Bpinstance;
import org.kldp.ebbp.instance.Bpinstancestate;
import org.kldp.ebbp.instance.BpinstancestateConstant;
import org.kldp.ebbp.processspecification.ProcessSpecification;
import org.kldp.ebbp.processspecification.ProcessSpecificationManager;
import org.kldp.ebbp.processspecification.collaboration.Collaboration;
import org.kldp.ebbp.processspecification.state.Start;
import org.kldp.ebbp.processspecification.state.State;
import org.kldp.ebbp.processspecification.state.StateResult;
import org.kldp.ebbp.queue.StartMessage;
import org.kldp.ebbp.queue.StartMessageConverter;


public class EbbpEventQueueHandler implements MessageDrivenBean, MessageListener {
	public void ejbCreate() throws EJBException  {
	}

	public void ejbRemove() throws EJBException {
		// TODO Auto-generated method stub
	}

	public void setMessageDrivenContext(MessageDrivenContext arg0) throws EJBException {
		// TODO Auto-generated method stub
	}

	public void onMessage(Message arg0) {
		try {
			MapMessage mapMessage = (MapMessage)arg0;

			System.out.println("------------------");
			System.out.println("޽ ߽ϴ.");
			
			String messageType = mapMessage.getString("messageType");
			
			if( messageType.equals("startMessage") ) {
				System.out.println("StartMessage ޽ Դϴ.");
				
				StartMessage startMessage = (StartMessage) new StartMessageConverter().convertToQueueMessage(arg0);
				
				String workflowInstanceId = startMessage.getWorkflowInstanceId();
				
				
				System.out.println("Workflow instance id: " + startMessage.getWorkflowInstanceId() + "   մϴ.");
				
				// Bp instance ãϴ.
				Bpinstance bpinstance = new BpinstanceDAO().findById(workflowInstanceId);
				
				// Bp instance ¸ Started մϴ.
				Bpinstancestate bpinstancestate = bpinstance.getBpinstancestate();				
				bpinstancestate.setState(BpinstancestateConstant.STARTED);
				
				// Bp instance Collboration  ɴϴ.
				Bpcollaboration bpCollaboration = bpinstance.getBpcollaboration();
				
				// Bp instance Process specification  Start ãϴ.
				String processSpecificationId = bpinstance.getProcessspecification().getProcessSpecificationId();
				
				ProcessSpecification processSpecification = ProcessSpecificationManager.getInstance().getProcessSpecification(processSpecificationId);
				
				Collaboration collaboration = processSpecification.getCollaboration(bpCollaboration.getCollaborationId());
				
				Start start = collaboration.getStartState();
				
				System.out.println( start );
				
				StateResult sr = start.perform(null);
				
				System.out.println(sr.getNextStateNameID());
				
				
			}
			else {
				System.out.println("ó   ޽ Դϴ.");
			}
		}
		catch(Throwable e) {
			e.printStackTrace();
		}
		
		/*try {
			System.out.println("޽ ");
			
			MapMessage mapMessage = (MapMessage)arg0;

			System.out.println("------------------");
			System.out.println("޽ ߽ϴ.");
			
			String messageType = mapMessage.getString("messageType");
			
			if( messageType.equals("startMessage") ) {
				System.out.println("StartMessage ޽ Դϴ.");
				
				StartMessage startMessage = (StartMessage) new StartMessageConverter().convertToQueueMessage(arg0);
				
				System.out.println("Workflow instance id: " + startMessage.getWorkflowInstanceId() + "   մϴ.");
				
				Context context = new InitialContext();
				
				WorkflowInstanceManagerHome workflowInstanceManagerHome = (WorkflowInstanceManagerHome)context.lookup("WorkflowInstanceManager");
				
				WorkflowInstanceManager manager = workflowInstanceManagerHome.create();
				
				WorkflowInstance workflowInstance = manager.getWorkflowInstance(startMessage.getWorkflowInstanceId());
				
				State state = workflowInstance.getCollaboration().nextState();
				
				StateInput stateInput = new StateInput();
				
				StateResult stateResult = state.perform(stateInput);
				
				try {
					// Bpms Queue 뺸ؾմϴ.
					System.out.println("State  BpmsQueue ˸ϴ.");
					
					CompleteMessage completeMessage = new CompleteMessage();
					completeMessage.setWorkflowInstanceId(startMessage.getWorkflowInstanceId());
					completeMessage.setNextStateNameID(stateResult.getNextStateNameID());
					completeMessage.setMessage(stateResult.getMessage());
					
					QueueConnectionFactory queueConnectionFactory = (QueueConnectionFactory)context.lookup("QueueConnectionFactory");
					Queue queue = (Queue)context.lookup("EbbpMessageQueue");
					
					new QueueHelper(queueConnectionFactory, queue).sendMessage(completeMessage, new CompleteMessageConverter());
				}
				catch(Exception e) {
					e.printStackTrace();
				}
			}
			else if( messageType.equals("completeMessage") ) {
				System.out.println("CompleteMessage ޽ Դϴ.");
				
				CompleteMessage _completeMessage = (CompleteMessage) new CompleteMessageConverter().convertToQueueMessage(arg0);
				
				System.out.println("Workflow instance id: " + _completeMessage.getWorkflowInstanceId() + "   մϴ.");
				
				System.out.println(" state id: " + _completeMessage.getNextStateNameID());
				

				Context context = new InitialContext();
				
				WorkflowInstanceManagerHome workflowInstanceManagerHome = (WorkflowInstanceManagerHome)context.lookup("WorkflowInstanceManager");
				
				WorkflowInstanceManager manager = workflowInstanceManagerHome.create();
				
				WorkflowInstance workflowInstance = manager.getWorkflowInstance(_completeMessage.getWorkflowInstanceId());
				
				State state = workflowInstance.getCollaboration().getState(_completeMessage.getNextStateNameID());
				
				System.out.println("state: " + state);
				
				StateInput stateInput = new StateInput();
				
				StateResult stateResult = state.perform(stateInput);
				
				try {
					// Bpms Queue 뺸ؾմϴ.
					System.out.println("State  BpmsQueue ˸ϴ.");
					
					System.out.println(state.getClass());
					
					if( state instanceof Failure ) {
					}
					else {	
						CompleteMessage completeMessage = new CompleteMessage();
						completeMessage.setWorkflowInstanceId(_completeMessage.getWorkflowInstanceId());
						completeMessage.setNextStateNameID(stateResult.getNextStateNameID());
						completeMessage.setMessage(stateResult.getMessage());
						
						QueueConnectionFactory queueConnectionFactory = (QueueConnectionFactory)context.lookup("QueueConnectionFactory");
						Queue queue = (Queue)context.lookup("EbbpMessageQueue");
						
						new QueueHelper(queueConnectionFactory, queue).sendMessage(completeMessage, new CompleteMessageConverter());
					}
				}
				catch(Exception e) {
					e.printStackTrace();
				}
				
				
				
				//workflowInstance.getCollaboration().get
				
				
				/*Context context = new InitialContext();
				
				WorkflowInstanceManagerHome workflowInstanceManagerHome = (WorkflowInstanceManagerHome)context.lookup("WorkflowInstanceManager");
				
				WorkflowInstanceManager manager = workflowInstanceManagerHome.create();
				
				WorkflowInstance workflowInstance = manager.getWorkflowInstance(completeMessage.getWorkflowInstanceId());
				
				State state = workflowInstance.getCollaboration().nextState();
				
				System.out.println(" state: " + state);
			}
			
			System.out.println("------------------");
		}
		catch(Exception e) {
			e.printStackTrace();
		}*/
	}
}