package org.kldp.ebbp.hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Bpcollaboration.
 * @see org.kldp.ebbp.hibernate.Bpcollaboration
 * @author MyEclipse - Hibernate Tools
 */
public class BpcollaborationDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(BpcollaborationDAO.class);

	//property constants
	public static final String COLLABORATION_ID = "collaborationId";

    
    public void save(Bpcollaboration transientInstance) {
        log.debug("saving Bpcollaboration instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Bpcollaboration persistentInstance) {
        log.debug("deleting Bpcollaboration instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Bpcollaboration findById( java.lang.String id) {
        log.debug("getting Bpcollaboration instance with id: " + id);
        try {
            Bpcollaboration instance = (Bpcollaboration) getSession()
                    .get("com.softmeca.ebbp.hibernate.Bpcollaboration", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Bpcollaboration instance) {
        log.debug("finding Bpcollaboration instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.softmeca.ebbp.hibernate.Bpcollaboration")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Bpcollaboration instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Bpcollaboration as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByCollaborationId(Object collaborationId) {
		return findByProperty(COLLABORATION_ID, collaborationId);
	}
	
    public Bpcollaboration merge(Bpcollaboration detachedInstance) {
        log.debug("merging Bpcollaboration instance");
        try {
            Bpcollaboration result = (Bpcollaboration) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Bpcollaboration instance) {
        log.debug("attaching dirty Bpcollaboration instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Bpcollaboration instance) {
        log.debug("attaching clean Bpcollaboration instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}