package org.kldp.ebbp.hibernate;

import java.util.Date;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Bpinstancestate.
 * @see org.kldp.ebbp.hibernate.Bpinstancestate
 * @author MyEclipse - Hibernate Tools
 */
public class BpinstancestateDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(BpinstancestateDAO.class);

	//property constants
	public static final String STATE = "state";

    
    public void save(Bpinstancestate transientInstance) {
        log.debug("saving Bpinstancestate instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Bpinstancestate persistentInstance) {
        log.debug("deleting Bpinstancestate instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Bpinstancestate findById( java.lang.String id) {
        log.debug("getting Bpinstancestate instance with id: " + id);
        try {
            Bpinstancestate instance = (Bpinstancestate) getSession()
                    .get("com.softmeca.ebbp.hibernate.Bpinstancestate", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Bpinstancestate instance) {
        log.debug("finding Bpinstancestate instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.softmeca.ebbp.hibernate.Bpinstancestate")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Bpinstancestate instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Bpinstancestate as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByState(Object state) {
		return findByProperty(STATE, state);
	}
	
    public Bpinstancestate merge(Bpinstancestate detachedInstance) {
        log.debug("merging Bpinstancestate instance");
        try {
            Bpinstancestate result = (Bpinstancestate) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Bpinstancestate instance) {
        log.debug("attaching dirty Bpinstancestate instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Bpinstancestate instance) {
        log.debug("attaching clean Bpinstancestate instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}