package org.kldp.ebbp.hibernate;

import java.util.Date;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Bpinstancestatus.
 * @see org.kldp.ebbp.hibernate.Bpinstancestatus
 * @author MyEclipse - Hibernate Tools
 */
public class BpinstancestatusDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(BpinstancestatusDAO.class);

	//property constants
	public static final String STATUS = "status";

    
    public void save(Bpinstancestatus transientInstance) {
        log.debug("saving Bpinstancestatus instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Bpinstancestatus persistentInstance) {
        log.debug("deleting Bpinstancestatus instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Bpinstancestatus findById( java.lang.String id) {
        log.debug("getting Bpinstancestatus instance with id: " + id);
        try {
            Bpinstancestatus instance = (Bpinstancestatus) getSession()
                    .get("com.softmeca.ebbp.hibernate.Bpinstancestatus", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Bpinstancestatus instance) {
        log.debug("finding Bpinstancestatus instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.softmeca.ebbp.hibernate.Bpinstancestatus")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Bpinstancestatus instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Bpinstancestatus as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByStatus(Object status) {
		return findByProperty(STATUS, status);
	}
	
    public Bpinstancestatus merge(Bpinstancestatus detachedInstance) {
        log.debug("merging Bpinstancestatus instance");
        try {
            Bpinstancestatus result = (Bpinstancestatus) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Bpinstancestatus instance) {
        log.debug("attaching dirty Bpinstancestatus instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Bpinstancestatus instance) {
        log.debug("attaching clean Bpinstancestatus instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}