package org.kldp.ebbp.hibernate;

import java.util.Date;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.Transaction;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Bpinstancetime.
 * @see org.kldp.ebbp.hibernate.Bpinstancetime
 * @author MyEclipse - Hibernate Tools
 */
public class BpinstancetimeDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(BpinstancetimeDAO.class);

	//property constants
    public void save(Bpinstancetime transientInstance) {
        log.debug("saving Bpinstancetime instance");
        
        
        
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
    
	public void delete(Bpinstancetime persistentInstance) {
        log.debug("deleting Bpinstancetime instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
	
    public Bpinstancetime findById( java.lang.String id) {
        log.debug("getting Bpinstancetime instance with id: " + id);
        try {
            Bpinstancetime instance = (Bpinstancetime) getSession()
                    .get("com.softmeca.ebbp.hibernate.Bpinstancetime", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Bpinstancetime instance) {
        log.debug("finding Bpinstancetime instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.softmeca.ebbp.hibernate.Bpinstancetime")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Bpinstancetime instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Bpinstancetime as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

    public Bpinstancetime merge(Bpinstancetime detachedInstance) {
        log.debug("merging Bpinstancetime instance");
        try {
            Bpinstancetime result = (Bpinstancetime) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Bpinstancetime instance) {
        log.debug("attaching dirty Bpinstancetime instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Bpinstancetime instance) {
        log.debug("attaching clean Bpinstancetime instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}