package org.kldp.ebbp.hibernate;

import java.util.List;
import java.util.Set;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Businessprocess.
 * @see org.kldp.ebbp.hibernate.Businessprocess
 * @author MyEclipse - Hibernate Tools
 */
public class BusinessprocessDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(BusinessprocessDAO.class);

	//property constants
	public static final String VERSION = "version";
	public static final String LOCATION = "location";
	public static final String BP_NAME = "bpName";

    
    public void save(Businessprocess transientInstance) {
        log.debug("saving Businessprocess instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Businessprocess persistentInstance) {
        log.debug("deleting Businessprocess instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Businessprocess findById( java.lang.String id) {
        log.debug("getting Businessprocess instance with id: " + id);
        try {
            Businessprocess instance = (Businessprocess) getSession()
                    .get("com.softmeca.ebbp.hibernate.Businessprocess", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Businessprocess instance) {
        log.debug("finding Businessprocess instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.softmeca.ebbp.hibernate.Businessprocess")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Businessprocess instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Businessprocess as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByVersion(Object version) {
		return findByProperty(VERSION, version);
	}
	
	public List findByLocation(Object location) {
		return findByProperty(LOCATION, location);
	}
	
	public List findByBpName(Object bpName) {
		return findByProperty(BP_NAME, bpName);
	}
	
    public Businessprocess merge(Businessprocess detachedInstance) {
        log.debug("merging Businessprocess instance");
        try {
            Businessprocess result = (Businessprocess) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Businessprocess instance) {
        log.debug("attaching dirty Businessprocess instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Businessprocess instance) {
        log.debug("attaching clean Businessprocess instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}