package org.kldp.ebmsh.cpa.ejb;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xmlbeans.XmlException;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.cpa.EbmsCpaException;
import org.kldp.ebmsh.cpa.Cpa;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.CollaborationProtocolAgreementDocument;



/**
 * CpaManagerBean - Session bean
 * 
 * Cpa εϰ ϴ ü
 * 
 * @author Sirius
 */
public class CpaManagerBean implements SessionBean {
	// EJB section
	private SessionContext sessionContext;
	
	public void setSessionContext(SessionContext argSessionContext) {
		this.sessionContext = argSessionContext;
	}
	
	/**
	 * bean ɶ cpa parsing մϴ.
	 */
	public void ejbCreate() {
		if( isInitialized == false ) {
			cpaStore = new HashMap();
			
			parseCpa();
			
			isInitialized = true;
		}
	}
	
	public void ejbRemove() {}
	public void ejbActivate() {}
	public void ejbPassivate() {}
	// EJB section end
	
	
	// User section
	private final static Log log = LogFactory.getLog(CpaManagerBean.class);
	private static HashMap cpaStore = null;
	private static boolean isInitialized = false;
	
	
	/**
	 * cpaId شϴ cpa ã  մϴ.
	 * 
	 * @param cpaId
	 * @return
	 */
	public Cpa getCpa(String cpaId) {
		CollaborationProtocolAgreementDocument cpaDoc = (CollaborationProtocolAgreementDocument)cpaStore.get(cpaId);
		
		if(cpaDoc != null)
			return new Cpa(cpaDoc, cpaDoc.getCollaborationProtocolAgreement());
		else
			return null;
	}
	
	
	/**
	 * Version     - v1.0
	 * Create time - 2007. 06. 12
	 * Update time - 2007. 06. 12
	 *
	 * Author      - Administrator
	 * 
	 * CPA Manager Ǿִ cpa id  ã ȯմϴ.
	 */
	public List<String> getCpaIds() {
		List<String> list = new ArrayList<String>();
		
		Set keySet = cpaStore.keySet();
		Iterator iter = keySet.iterator();
		
		while( iter.hasNext() ) {
			String cpaId = (String)iter.next();
			
			list.add(cpaId);
		}
		
		return list;
	}
	
	
	/**
	 * CPA 丮  CPA parsing
	 * 
	 * @throws EbmsCpaException
	 */
	public void parseCpa() throws EbmsCpaException {
		log.info("CPA parsing");
		
		CollaborationProtocolAgreementDocument cpaDoc = null;
		File f = new File( EbmsConstants.cpaPath );
		
		// CPA 丮  ʴ°
		if( !f.exists() )
			throw new EbmsCpaException(1, 0, "CPA 丮  ʽϴ.( " + EbmsConstants.cpaPath + " )");
		
		String[] cpaArray = f.list();
		
		for( int i = 0 ; i < cpaArray.length;i++ )
		{	
			try {
				log.info("\t" + cpaArray[i] + " parsing");
				
				File file = new File(EbmsConstants.cpaPath + cpaArray[i]);
				
				if( file.isFile() ) {
					cpaDoc = CollaborationProtocolAgreementDocument.Factory.parse(file);
				
					String fileName = file.getName();
					
					fileName = fileName.substring(0, fileName.indexOf("."));
					
					cpaStore.put(fileName, cpaDoc);
				}
				else if( file.isDirectory() ) {
					throw new IOException("丮 parsing   ϴ.");
				}
			}
			catch(XmlException e) {
				log.fatal("\t\t" + cpaArray[i] + " can't parsing");
				e.printStackTrace();
			}
			catch(IOException e) {
				log.fatal("\t\t" + cpaArray[i] + " can't parsing");
				e.printStackTrace();
			}
		}
		
		log.info("CPA parsing end");
	}
}
