package org.kldp.ebmsh.config;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Properties;

/**
 * 
 * config/bizboxConfig.properties ϴ properties wrappingϴ Ŭ
 * 
 * @author ø콺
 */
public class EbmsProperties {
	private Properties bizboxProperties;
	
	private final String applicationResultQueueName = "EbmsApplicationResultQueue";
	private final String trackerQueueName = "EbmsTrackerQueue";
	private final String cpaManagerJNDIName = "CpaManager";
	private final String cpaPath = "cpa";
	private final String messagePath = "message";
	private final String keyStoreType = "jks";
	private final String keyStorePath = "jks";
	private final String keyStorePassword = "softmeca!!";
	private final String keyPassword = "softmeca!!";
	private final String csrPath = "csr";
	
	public EbmsProperties() {
		this.bizboxProperties = new Properties();
	}

	public EbmsProperties(Properties bizboxProperties) {
		this.bizboxProperties = bizboxProperties;
	}
	
	public void saveToFile(String filePath) {
		try {
			OutputStream os = new FileOutputStream(new File(filePath));
			
			bizboxProperties.store(os, "Bizbox config file");
		}
		catch(IOException e) {
			throw new EbmsConfigException(1, 0, e);
		}
	}

	public String getApplicationResultQueueName() {
		return applicationResultQueueName;
	}

	public String getBizboxDatabaseHeaderName() {
		return bizboxProperties.getProperty("bizboxDatabaseHeaderName");
	}

	public void setBizboxDatabaseHeaderName(String bizboxDatabaseHeaderName) {
		bizboxProperties.setProperty("bizboxDatabaseHeaderName", bizboxDatabaseHeaderName);
	}

	public String getConnectionTimeOut() {
		return bizboxProperties.getProperty("connectionTimeOut");	 
	}

	public void setConnectionTimeOut(String connectionTimeOut) {
		bizboxProperties.setProperty("connectionTimeOut", connectionTimeOut);
	}

	public String getCpaManagerJNDIName() {
		return this.cpaManagerJNDIName;
	}

	public String getCpaPath() {
		return this.cpaPath;
	}

	public String getCsrPath() {
		return csrPath;
	}


	public String getDatabaseType() {
		return bizboxProperties.getProperty("databaseType");
	}

	public void setDatabaseType(String databaseType) {
		bizboxProperties.setProperty("databaseType", databaseType);
	}

	public String getDataSourceName() {
		return bizboxProperties.getProperty("dataSourceName");
	}

	public void setDataSourceName(String dataSourceName) {
		bizboxProperties.setProperty("dataSourceName", dataSourceName);
	}

	public String getKeyPassword() {
		return keyPassword;
	}
	
	public String getKeyStorePassword() {
		return keyStorePassword;
	}

	public String getKeyStorePath() {
		return keyStorePath;
	}


	public String getKeyStoreType() {
		return keyStoreType;
	}

	public String getMessagePath() {
		return this.messagePath;
	}

	public String getPkcs11cfgPath() {
		return bizboxProperties.getProperty("pkcs11cfgPath");
	}

	public void setPkcs11cfgPath(String pkcs11cfgPath) {
		bizboxProperties.setProperty("pkcs11cfgPath", pkcs11cfgPath);
	}

	public String getQueueConnectionFactoryName() {
		return bizboxProperties.getProperty("queueConnectionFactoryName");
	}

	public void setQueueConnectionFactoryName(String queueConnectionFactoryName) {
		bizboxProperties.setProperty("queueConnectionFactoryName", queueConnectionFactoryName);
	}

	public String getQueueJNDIHeaderName() {
		return bizboxProperties.getProperty("queueJNDIHeaderName");
	}

	public void setQueueJNDIHeaderName(String queueJNDIHeaderName) {
		bizboxProperties.setProperty("queueJNDIHeaderName", queueJNDIHeaderName);
	}

	public String getTrackerQueueName() {
		return this.trackerQueueName;
	}
}
