package org.kldp.ebmsh.cpa;

import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.CanReceiveDocument;

public class CanReceive {
	private CanReceiveDocument.CanReceive canReceive = null;
	
	public CanReceive(CanReceiveDocument.CanReceive _canReceive) {
		this.canReceive = _canReceive;
	}
	
	public boolean getNonRepudiation() throws EbmsCpaException {
		try {
			return canReceive.getThisPartyActionBinding().getBusinessTransactionCharacteristics().getIsNonRepudiationRequired();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public boolean getNonRepudiationReceipt() throws EbmsCpaException {
		try {
			return canReceive.getThisPartyActionBinding().getBusinessTransactionCharacteristics().getIsNonRepudiationReceiptRequired();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String[] getChannelIds() throws EbmsCpaException {
		try {
			return canReceive.getThisPartyActionBinding().getChannelIdArray();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getPackageId() throws EbmsCpaException {
		try {
			return canReceive.getThisPartyActionBinding().getPackageId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getAction() throws EbmsCpaException {
		try {
			return canReceive.getThisPartyActionBinding().getAction();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getBindingId() throws EbmsCpaException {
		try {
			return canReceive.getThisPartyActionBinding().getId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}		
	
	public String getOtherPartyActionBinding() throws EbmsCpaException {
		try {
			return canReceive.getOtherPartyActionBinding();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setChannelId(int seq, String _channelId) throws EbmsCpaException {
		try {
			canReceive.getThisPartyActionBinding().setChannelIdArray(seq, _channelId);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setPackageId(String _packageId) throws EbmsCpaException {
		try {
			canReceive.getThisPartyActionBinding().setPackageId(_packageId);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setAction(String _action) throws EbmsCpaException {
		try {
			canReceive.getThisPartyActionBinding().setAction(_action);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setBindingId(String _bindingId) throws EbmsCpaException {
		try {
			canReceive.getThisPartyActionBinding().setId(_bindingId);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setOtherPartyActionBinding(String _otherPartyActionBinding) throws EbmsCpaException {
		try {
			canReceive.setOtherPartyActionBinding(_otherPartyActionBinding);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
}