package org.kldp.ebmsh.cpa;

import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.CanSendDocument;

public class CanSend {
	CanSendDocument.CanSend canSend = null;
	
	public CanSend(CanSendDocument.CanSend _canSend) {
		this.canSend = _canSend;
	}
	
	public boolean getNonRepudiation() throws EbmsCpaException {
		try {
			return canSend.getThisPartyActionBinding().getBusinessTransactionCharacteristics().getIsNonRepudiationRequired();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public boolean getNonRepudiationReceipt() throws EbmsCpaException {
		try {
			return canSend.getThisPartyActionBinding().getBusinessTransactionCharacteristics().getIsNonRepudiationReceiptRequired();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getOtherPartyActionBinding() throws EbmsCpaException {
		try {
			return canSend.getOtherPartyActionBinding();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String[] getChannelIds() throws EbmsCpaException {
		try {
			return canSend.getThisPartyActionBinding().getChannelIdArray();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getPackageId() throws EbmsCpaException {
		try {
			return canSend.getThisPartyActionBinding().getPackageId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getAction() throws EbmsCpaException {
		try {
			return canSend.getThisPartyActionBinding().getAction();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getBindingId() throws EbmsCpaException {
		try {
			return canSend.getThisPartyActionBinding().getId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
		
	
	public void setOtherPartyActionBinding(String _otherPartyActionBinding) throws EbmsCpaException {
		try {
			canSend.setOtherPartyActionBinding(_otherPartyActionBinding);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setChannelId(int _seq, String _channelId) throws EbmsCpaException {
		try {
			canSend.getThisPartyActionBinding().setChannelIdArray(_seq, _channelId);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setPackageId(String _packageId) throws EbmsCpaException {
		try {
			canSend.getThisPartyActionBinding().setPackageId(_packageId);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setAction(String _action) throws EbmsCpaException {
		try {
			canSend.getThisPartyActionBinding().setAction(_action);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setBindingId(String _bindingId) throws EbmsCpaException {
		try {
			canSend.getThisPartyActionBinding().setId(_bindingId);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
}