package org.kldp.ebmsh.cpa;

import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.DeliveryChannelDocument;

public class DeliveryChannel {
	DeliveryChannelDocument.DeliveryChannel deliveryChannel = null;
	
	public DeliveryChannel(DeliveryChannelDocument.DeliveryChannel _deliveryChannel) {
		this.deliveryChannel = _deliveryChannel;
	}
	
	public String getChannelId() throws EbmsCpaException {
		try {
			return deliveryChannel.getChannelId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getTransportId() throws EbmsCpaException {
		try {
			return deliveryChannel.getTransportId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getDocExchangeId() throws EbmsCpaException {
		try {
			return deliveryChannel.getDocExchangeId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getSyncReplyMode() throws EbmsCpaException {
		try {
			return deliveryChannel.getMessagingCharacteristics().getSyncReplyMode().toString();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getAckRequested() throws EbmsCpaException {
		try {
			return deliveryChannel.getMessagingCharacteristics().getAckRequested().toString();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getAckSignatureRequested() throws EbmsCpaException {
		try {
			return deliveryChannel.getMessagingCharacteristics().getAckSignatureRequested().toString();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getDuplicateElimination() throws EbmsCpaException {
		try {
			return deliveryChannel.getMessagingCharacteristics().getDuplicateElimination().toString();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public String getActor() throws EbmsCpaException {
		try {
			return deliveryChannel.getMessagingCharacteristics().getActor().toString();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
}
