package org.kldp.ebmsh.cpa;

import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ActorType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.MessagingCharacteristicsDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.PerMessageCharacteristicsType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SyncReplyModeType;

public class MessagingCharacteristics {
	MessagingCharacteristicsDocument.MessagingCharacteristics messagingCharacteristics;
	
	public MessagingCharacteristics(MessagingCharacteristicsDocument.MessagingCharacteristics messagingCharacteristics) {
		this.messagingCharacteristics = messagingCharacteristics;
	}
	
	public PerMessageCharacteristicsType.Enum getAckRequested() throws EbmsCpaException {
		try {
			return messagingCharacteristics.getAckRequested();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public PerMessageCharacteristicsType.Enum getAckSignatureRequested() throws EbmsCpaException {
		try {
			return messagingCharacteristics.getAckSignatureRequested();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public ActorType.Enum getActor() throws EbmsCpaException {
		try {
			return messagingCharacteristics.getActor();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public PerMessageCharacteristicsType.Enum getDuplicateElimination() throws EbmsCpaException {
		try {
			return messagingCharacteristics.getDuplicateElimination();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public SyncReplyModeType.Enum getSyncReplyMode() throws EbmsCpaException {
		try {
			return messagingCharacteristics.getSyncReplyMode();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public PerMessageCharacteristicsType.Enum setDuplicateElimination() throws EbmsCpaException {
		try {
			return messagingCharacteristics.getDuplicateElimination();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	public void setAckRequested(PerMessageCharacteristicsType.Enum _ackRequested) throws EbmsCpaException {
		try {
			messagingCharacteristics.setAckRequested(_ackRequested);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public void setAckSignatureRequested(PerMessageCharacteristicsType.Enum _ackSignatureRequested) throws EbmsCpaException {
		try {
			messagingCharacteristics.setAckSignatureRequested(_ackSignatureRequested);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public void setActor(ActorType.Enum _actor) throws EbmsCpaException {
		try {
			messagingCharacteristics.setActor(_actor);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public void setDuplicateElimination(PerMessageCharacteristicsType.Enum _duplicateElimination) throws EbmsCpaException {
		try {
			messagingCharacteristics.setDuplicateElimination(_duplicateElimination);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public void setSyncReplyMode(SyncReplyModeType.Enum _syncReplyMode) throws EbmsCpaException {
		try {
			messagingCharacteristics.setSyncReplyMode(_syncReplyMode);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
}