package org.kldp.ebmsh.cpa;

import java.math.BigInteger;
import java.security.cert.X509Certificate;

import org.apache.xmlbeans.GDuration;
import org.apache.xmlbeans.XmlBase64Binary;
import org.apache.xmlbeans.XmlDuration;
import org.apache.xmlbeans.XmlObject;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ActionBindingType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ActorType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.BusinessTransactionCharacteristicsDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.CanReceiveDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.CanSendDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.CertificateDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.CertificateRefType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ChannelIdDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.CollaborationRoleDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.DeliveryChannelDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.DocExchangeDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.EbXMLReceiverBindingDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.EbXMLSenderBindingDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.EndpointDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.EndpointTypeType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.MessageOrderSemanticsType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.MessagingCharacteristicsDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.PartyIdDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.PartyInfoDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.PartyRefDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.PerMessageCharacteristicsType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ProtocolType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ReceiverNonRepudiationDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ReliableMessagingDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.RoleDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SecurityDetailsDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SecurityDetailsRefType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SenderNonRepudiationDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ServiceType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SignatureAlgorithmDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SyncReplyModeType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.TransportClientSecurityDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.TransportDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.TransportReceiverDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.TransportSenderDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.TransportServerSecurityDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.TrustAnchorsDocument;
import org.w3.x2000.x09.xmldsig.KeyInfoType;
import org.w3.x2000.x09.xmldsig.X509DataType;

import sun.misc.BASE64Encoder;

public class PartyInfo extends Cpa {
	private PartyInfoDocument.PartyInfo partyInfo = null;

	public PartyInfo(PartyInfoDocument.PartyInfo partyInfo) {
		this.partyInfo = partyInfo;
	}
	
	/**
	 * PartyInfo PartyName element 
	 * 
	 * @param _partyName	Party Name
	 * 
	 * @return void
	 */
	public void setPartyName(String _partyName) throws EbmsCpaException {
		try {
			partyInfo.setPartyName(_partyName);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo PartyName element ȯ
	 * 
	 * @return PartyName
	 */
	public String getPartyName() throws EbmsCpaException {
		try {
			return partyInfo.getPartyName();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo DefaultMshChannelId element 
	 * 
	 * @param _id	PartyInfo attribute 'DefaultMshChannelId'
	 * 
	 * @return void
	 */
	public void setDefaultMshChannelId(String _id) throws EbmsCpaException {
		try {
			partyInfo.setDefaultMshPackageId(_id);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo DefaultMshChannelId element ȯ
	 * 
	 * @return DefaultMshChannelId
	 */
	public String getDefaultMshChannelId() throws EbmsCpaException {
		try {
			return partyInfo.getDefaultMshChannelId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo DefaultMshPackageId element 
	 * 
	 * @param _id	PartyInfo attribute 'DefaultMshPackageId'
	 * 
	 * @return void
	 */
	public void setDefaultMshPackageId(String _id) throws EbmsCpaException {
		try {
			partyInfo.setDefaultMshPackageId(_id);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);			
		}
	}
	
	/**
	 * PartyInfo DefaultMshPackageId element ȯ
	 * 
	 * @return DefaultMshPackageId
	 */
	public String getDefaultMshPackageId(String _id) throws EbmsCpaException {
		try {
			return partyInfo.getDefaultMshPackageId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);			
			
			
		}
	}
	
	/**
	 * PartyInfo PartyId element ߰
	 * 
	 * @param _type		PartyId attribute 'type'
	 * @param _value	PartyId value
	 * 
	 * @return  PartyId
	 */
	public PartyIdDocument.PartyId addPartyId(String _type, String _value) throws EbmsCpaException {
		try {
			PartyIdDocument.PartyId partyId = partyInfo.addNewPartyId();
			
			partyId.setType(_type);
			partyId.setStringValue(_value);
			
			return partyId;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo PartyId element 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _seq		PartyId sequence
	 * @param _type		PartyId attribute 'type'
	 * @param _value	PartyId element value
	 * 
	 * @return void
	 */
	public void setPartyId(int _seq, String _type, String _value) throws EbmsCpaException {
		try {
			PartyIdDocument.PartyId partyId = partyInfo.getPartyIdArray(_seq);
			
			if(_type != null)
				partyId.setType(_type);
			
			if(_value != null)
				partyId.setStringValue(_value);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo PartyId element  ȯ
	 * 
	 * @param _seq		PartyId sequence
	 * @param _value	PartyId element value
	 * 
	 * @return PartyId element 
	 */
	public String getPartyId(int _seq, String _value) throws EbmsCpaException {
		try {
			return partyInfo.getPartyIdArray(_seq).getStringValue();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo PartyType element  ȯ
	 * 
	 * @param _seq		PartyId sequence
	 * 
	 * @return PartyType 
	 */
	public String getPartyIdType(int _seq) throws EbmsCpaException {
		try {
			return partyInfo.getPartyIdArray(_seq).getType();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	

	/**
	 * PartyInfo PartyRef element ߰
	 * 
	 * @param _type		PartyRef attribute 'type'
	 * @param _href		PartyRef attribute 'href'
	 * 
	 * @return  PartyRef
	 */
	public PartyRefDocument.PartyRef addPartyRef(String _type, String _href) throws EbmsCpaException {
		try {
			PartyRefDocument.PartyRef partyRef = partyInfo.addNewPartyRef();
			
			partyRef.setType2(_type);
			partyRef.setHref(_href);
			
			return partyRef;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo PartyRef element 
	 * 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _seq		partyRef sequence
	 * @param _type		PartyRef attribute 'type'
	 * @param _href		PartyRef attribute 'href'
	 * 
	 * @return void
	 */
	public void setPartyRef(int _seq, String _type, String _href) throws EbmsCpaException {
		try {
			PartyRefDocument.PartyRef partyRef = partyInfo.getPartyRefArray(_seq);
			
			if(_type != null)
				partyRef.setType2(_type);
			
			if(_href != null)
				partyRef.setHref(_href);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * ̱
	 */
	public void getPartyRef() throws EbmsCpaException {
	}
	
	
	/**
	 * ̱
	 * ̹ Template xml Service element 
	 */
	public void addService() throws EbmsCpaException {
	}
	
	
	/**
	 * CollaborationProtocolAgreement Service 
	 * 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _type		Service attribute 'type'
	 * @param _name		Service attribute 'name'
	 * 
	 * @return void
	 */
	public void setService(String _type, String _name) throws EbmsCpaException {
		try {
			ServiceType serviceType = partyInfo.getCollaborationRoleArray()[0].getServiceBinding().getService();
			
			if(_type != null)
				serviceType.setType(_type);
			
			if(_name != null)
				serviceType.setStringValue(_name);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * CollaborationProtocolAgreement Service element  ȯ
	 * 
	 * @return Service element 
	 */
	public String getService() throws EbmsCpaException {
		try {
			return partyInfo.getCollaborationRoleArray()[0].getServiceBinding().getService().getStringValue();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	} 
	
	/**
	 * CollaborationProtocolAgreement Service element  ȯ
	 * 
	 * @return Service element 
	 */
	public String getServiceType() throws EbmsCpaException {
		try {
			return partyInfo.getCollaborationRoleArray()[0].getServiceBinding().getService().getType();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	} 
	
	/**
	 * PartyInfo CanSend element ߰
	 * 
	 * @param _bindingId						ThisPartyActionBinding attribute 'id'
	 * @param _action							ThisPartyActionBinding attribute 'action'
	 * @param _packageId						ThisPartyActionBinding attribute 'packageId'
	 * @param _channelId[]						ChannelIds element value
	 * @param _otherPartyActionBinding			OtherPartyActionBinding value
	 * 
	 * @return  CanSend
	 */
	public CanSend addCanSend(String _bindingId, String _action, String _packageId, String[] _channelId, String _otherPartyActionBinding) throws EbmsCpaException {
		try {
			CanSendDocument.CanSend canSend = partyInfo.getCollaborationRoleArray(0).getServiceBinding().addNewCanSend();
			
			ActionBindingType actionBindingType = canSend.addNewThisPartyActionBinding();		
			actionBindingType.setId(_bindingId);
			actionBindingType.setAction(_action);
			actionBindingType.setPackageId(_packageId);
			
			BusinessTransactionCharacteristicsDocument.BusinessTransactionCharacteristics businessTransactionCharacteristics = actionBindingType.addNewBusinessTransactionCharacteristics();
			
			businessTransactionCharacteristics.setIsNonRepudiationRequired(false);
			businessTransactionCharacteristics.setIsNonRepudiationReceiptRequired(false);
		
			for(int i = 0; i < _channelId.length; i++)
				actionBindingType.addChannelId(_channelId[i]);
			
			canSend.setOtherPartyActionBinding(_otherPartyActionBinding);
			
			return new CanSend(canSend);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo CanSend element 
	 * 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _oldActionbindingId				 ThisPartyActionBinding attribute 'id'
	 * @param _newActionbindingId				ο ThisPartyActionBinding attribute 'id'
	 * @param _action							ThisPartyActionBinding attribute 'action'
	 * @param _packageId						ThisPartyActionBinding attribute 'packageId'
	 * @param _seq								ChnnelId sequence
	 * @param _channelId						ChannelId element value
	 * @param _otherPartyActionBinding			OtherPartyActionBinding value
	 * 
	 * @return void
	 */
	public void setCanSend(String _oldActionBindingId, String _newActionBindingId, String _action, String _packageId, int _channelIdSeq, String _channelId, String _otherPartyActionBinding) throws EbmsCpaException {
		try {
			CanSend[] canSends = this.getCanSends();
			
			for(int i = 0; i < canSends.length; i++) {
				if(canSends[i].getBindingId().equals(_oldActionBindingId)) {
					if(_newActionBindingId != null) 
						setAttribute(_oldActionBindingId, _newActionBindingId);
					
					if(_action != null)
						canSends[i].setAction(_action);
					
					if(_packageId != null)
						canSends[i].setPackageId(_packageId);
					
					if(_channelId != null)
						canSends[i].setChannelId(_channelIdSeq, _channelId);
					
					if(_otherPartyActionBinding != null)
						canSends[i].setOtherPartyActionBinding(_otherPartyActionBinding);
					
					break;
				}
			}
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}	
	
	/**
	 * PartyInfo CanSend element ȯ
	 * 
	 * @return CanSend 迭
	 */
	public CanSend[] getCanSends() throws EbmsCpaException {
		try {
			CanSend[] canSend = null;
			CollaborationRoleDocument.CollaborationRole collaborationRole = null;
			CanSendDocument.CanSend[] canSend_ = null;
			
			collaborationRole = partyInfo.getCollaborationRoleArray()[0];
			
			canSend_ = collaborationRole.getServiceBinding().getCanSendArray();
			
			canSend = new CanSend[canSend_.length];
				
			for(int i = 0; i < canSend.length; i++) 
				canSend[i] = new CanSend(canSend_[i]);
			
			return canSend;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}	

	/**
	 * PartyInfo CanSend ȯ
	 * 
	 * @param _action 'Action' ̸
	 * 
	 * @return CanSend
	 */
	public CanSend getCanSend(String _action) throws EbmsCpaException {
		try {
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			String pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + getPartyName() + "']/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend[tp:ThisPartyActionBinding[@tp:action='" + _action + "']]";//tp:ThisPartyActionBinding[@tp:action='" + _action + "']";
			
			CanSendDocument.CanSend[] result_canSends = (CanSendDocument.CanSend[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			return new CanSend(result_canSends[0]);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
		
	}
	
	/**
	 * PartyInfo CanReceive element ߰
	 * 
	 * @param _bindingId						ThisPartyActionBinding attribute 'id'
	 * @param _action							ThisPartyActionBinding attribute 'action'
	 * @param _packageId						ThisPartyActionBinding attribute 'packageId'
	 * @param _channelId[]						ChannelIds element value
	 * @param _otherPartyActionBinding			OtherPartyActionBinding value
	 * 
	 * @return  CanReceive
	 */
	public CanReceive addCanReceive(String _bindingId, String _action, String _packageId, String[] _channelId, String _otherPartyActionBinding) throws EbmsCpaException {
		try {
			CanReceiveDocument.CanReceive canReceive = partyInfo.getCollaborationRoleArray(0).getServiceBinding().addNewCanReceive();
			
			ActionBindingType actionBindingType = canReceive.addNewThisPartyActionBinding();		
			actionBindingType.setId(_bindingId);
			actionBindingType.setAction(_action);
			actionBindingType.setPackageId(_packageId);
			
			BusinessTransactionCharacteristicsDocument.BusinessTransactionCharacteristics businessTransactionCharacteristics = actionBindingType.addNewBusinessTransactionCharacteristics();
			
			businessTransactionCharacteristics.setIsNonRepudiationRequired(false);
			businessTransactionCharacteristics.setIsNonRepudiationReceiptRequired(false);
		
			for(int i = 0; i < _channelId.length; i++)
				actionBindingType.addChannelId(_channelId[i]);
			
			canReceive.setOtherPartyActionBinding(_otherPartyActionBinding);
			
			return new CanReceive(canReceive);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo CanReceive element 
	 * 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _oldActionbindingId				 ThisPartyActionBinding attribute 'id'
	 * @param _newActionbindingId				ο ThisPartyActionBinding attribute 'id'
	 * @param _action							ThisPartyActionBinding attribute 'action'
	 * @param _packageId						ThisPartyActionBinding attribute 'packageId'
	 * @param _seq								ChannelId sequence
	 * @param _channelId						ChannelId element value
	 * @param _otherPartyActionBinding			OtherPartyActionBinding value
	 * 
	 * @return void
	 */
	public void setCanReceive(String _oldActionBindingId, String _newActionBindingId, String _action, String _packageId, int _channelIdSeq, String _channelId, String _otherPartyActionBinding) throws EbmsCpaException {
		try {
			CanReceive[] CanReceive = this.getCanReceives();
			
			for(int i = 0; i < CanReceive.length; i++) {
				if(CanReceive[i].getBindingId().equals(_oldActionBindingId)) {
					if(_newActionBindingId != null) 
						setAttribute(_oldActionBindingId, _newActionBindingId);
					
					if(_action != null)
						CanReceive[i].setAction(_action);
					
					if(_packageId != null)
						CanReceive[i].setPackageId(_packageId);
					
					if(_channelId != null)
						CanReceive[i].setChannelId(_channelIdSeq, _channelId);
					
					if(_otherPartyActionBinding != null)
						CanReceive[i].setOtherPartyActionBinding(_otherPartyActionBinding);
					
					break;
				}
			}
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	/**
	 * PartyInfo CanReceive element ȯ
	 * 
	 * @return CanReceive 迭
	 */
	public CanReceive[] getCanReceives() throws EbmsCpaException {
		try {
			CanReceive[] canReceive = null;
			CollaborationRoleDocument.CollaborationRole collaborationRole = null;
			CanReceiveDocument.CanReceive[] canReceive_ = null;
			
			collaborationRole = partyInfo.getCollaborationRoleArray()[0];
			
			canReceive_ = collaborationRole.getServiceBinding().getCanReceiveArray();
			
			canReceive = new CanReceive[canReceive_.length];
			
			for(int i = 0; i < canReceive.length; i++) 
				canReceive[i] = new CanReceive(canReceive_[i]);
			
			return canReceive;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo CanReceive ȯ
	 * 
	 * @param _action 'Action' ̸
	 * 
	 * @return CanReceive
	 */
	public CanReceive getCanReceive(String _action) throws EbmsCpaException {
		try {
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			String pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive[tp:ThisPartyActionBinding[@tp:action='" + _action + "']]";
			
			CanReceiveDocument.CanReceive[] result_canReceives = (CanReceiveDocument.CanReceive[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			return new CanReceive(result_canReceives[0]);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	
	/**
	 * PartyInfo Certificate element 
	 * 
	 * _x509Certificate 'null' Է  X509Certificate element  ʴ´.
	 * 
	 * @param _certId			Certificate attribute 'id'
	 * @param _keyName			Certificate keyname element value
	 * @param _x509Certificate	Certificate X509Certificate element value
	 * 
	 * @return  Certificate
	 */
	public Certificate addCertificate(String _certId, String[] _keyName, String _x509Certificate) throws EbmsCpaException {
		try {
			CertificateDocument.Certificate certificate = partyInfo.addNewCertificate();
			
			certificate.setCertId(_certId);
			
			KeyInfoType keyInfoType = certificate.addNewKeyInfo();
			
			for(int i = 0; i < _keyName.length; i++) 
				keyInfoType.addNewKeyName().setStringValue(_keyName[i]);
			
			if(_x509Certificate != null) {
				X509DataType x509DataType = keyInfoType.addNewX509Data();
				XmlBase64Binary xmlBase64Binary = x509DataType.addNewX509Certificate();
				
				BASE64Encoder encoder = new BASE64Encoder();
				String base64 = encoder.encode(_x509Certificate.getBytes());
				
				xmlBase64Binary.setStringValue(base64);
			}
			
			return new Certificate(certificate);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	
	/**
	 * PartyInfo Certificate element 
	 * 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _oldCertId		Certificate attribute 'id'
	 * @param _newCertId		Certificate attribute 'id'
	 * @param _keySeq			Key Sequence
	 * @param _keyName			Certificate keyname element value
	 * @param _certSeq			Certificate Sequence
	 * @param _x509Certificate	Certificate X509Certificate element value
	 * 
	 * @return void
	 */
	public void setCertificate(String _oldCertId, String _newCertId, int _keySeq, String _keyName, int _certSeq, String _x509Certificate) throws EbmsCpaException {
		try {
			Certificate certificate = this.getCertificate(_oldCertId);
			
			if(_newCertId != null) 
				this.setAttribute(_oldCertId, _newCertId);
			
			if(_keyName != null)
				certificate.setKeyName(_keySeq, _keyName);
			
			if(_x509Certificate != null) {
				if( _certSeq >= certificate.getX509Certificate().length ) 
					certificate.setX509Certificate(_certSeq, _x509Certificate);
			}
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	/**
	 * PartyInfo Certificate ȯ
	 * 
	 * @return Certificate 迭
	 * @throws EbmsCpaException 
	 */
	public Certificate[] getCertificates() throws EbmsCpaException {
		try {
			Certificate[] resultCertificate = null;
			CertificateDocument.Certificate[] certificateArray = partyInfo.getCertificateArray();
			
			if(certificateArray.length != 0) {
				resultCertificate = new Certificate[certificateArray.length];
				
				for(int i = 0; i < certificateArray.length; i++) 
					resultCertificate[i] = new Certificate(certificateArray[i]);
			}
			
			return resultCertificate;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	
	/**
	 * PartyInfo Certificate ȯ
	 * 
	 * @param _certId Certficate attribute 'id'
	 * 
	 * @return Certificate
	 * @throws EbmsCpaException 
	 */
	public Certificate getCertificate(String _certId) throws EbmsCpaException {
		try {
			Certificate resultCertificate = null;
			CertificateDocument.Certificate[] certificateArray = partyInfo.getCertificateArray();		
			
			for(int i = 0; i < certificateArray.length; i++) {
				if(certificateArray[i].getCertId().equals(_certId)) {
					resultCertificate = new Certificate(certificateArray[i]);
					
					break;
				}
			}
			
			return resultCertificate;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo SecurityDetails ߰
	 * 
	 * @param _securityId		SecurityDetails attribute 'securityId'
	 * @param _certId			TrustAnchors attribute 'certId'
	 * 
	 * @return  SecurityDetails
	 * @throws EbmsCpaException 
	 */
	public SecurityDetailsDocument.SecurityDetails addSecurityDetailswithTrustAnchors(String _securityId, String _certId) throws EbmsCpaException {
		try {
			SecurityDetailsDocument.SecurityDetails securityDetails = partyInfo.addNewSecurityDetails();		
			securityDetails.setSecurityId(_securityId);
			
			TrustAnchorsDocument.TrustAnchors trustAnchors = securityDetails.addNewTrustAnchors();
			CertificateRefType certificateRefType = trustAnchors.addNewAnchorCertificateRef();
			certificateRefType.setCertId(_certId);
			
			return securityDetails;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	
	/**
	 * PartyInfo SecurityDetails 
	 * 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _oldSecurityId		SecurityDetails attribute 'securityId'
	 * @param _newSecurityId		SecurityDetails attribute 'securityId'
	 * @param _certSeq				TrustAnchors Sequence
	 * @param _certId				TrustAnchors attribute 'certId'
	 * 
	 * @return void
	 * @throws EbmsCpaException 
	 */
	public void setSecurityDetailswithTrustAnchors(String _oldSecurityId, String _newSecurityId, int _certSeq, String _certId) throws EbmsCpaException {
		try {
			SecurityDetailsDocument.SecurityDetails[] securityDetails = partyInfo.getSecurityDetailsArray();
			
			for(int i = 0; i < securityDetails.length; i++) {
				if(securityDetails[i].getSecurityId().equals(_oldSecurityId)) {
					if(_newSecurityId != null) {
						this.setAttribute(_oldSecurityId, _newSecurityId);
						
						if(_certId != null) {
							CertificateRefType certificateRefType = CertificateRefType.Factory.newInstance();					
							certificateRefType.setCertId(_certId);
							
							securityDetails[i].getTrustAnchors().setAnchorCertificateRefArray(_certSeq, certificateRefType);
						}
					}
				}
			}
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}	
	
	/**
	 * PartyInfo SecurityDetails 'securityId' ȯ
	 * 
	 * @return SecurityDetails attribute 'securityId'
	 */
	public String[] getSecurityDetailsIds() throws EbmsCpaException {		
		try {
			String[] resultSecurityDetailsIds = null;
			SecurityDetailsDocument.SecurityDetails[] securityDetails = partyInfo.getSecurityDetailsArray();
			
			if(resultSecurityDetailsIds.length != 0) {
				resultSecurityDetailsIds = new String[securityDetails.length];
				
				for(int i = 0; i < resultSecurityDetailsIds.length; i++) 
					resultSecurityDetailsIds[i] = securityDetails[i].getSecurityId();
			}
			
			return resultSecurityDetailsIds;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	
	/**
	 * PartyInfo SecurityDetails-AnchorCertificateRef 'securityId' ȯ
	 * 
	 * @return  SecurityDetails-AnchorCertificateRef 'certId'
	 */
	public String[] getSecurityDetailsTrustAnchorsCertIds(String _securityId) throws EbmsCpaException {	
		try {
			String[] resultSecurityDetailsTrustAnchorsCertIds = null;		
			SecurityDetailsDocument.SecurityDetails[] securityDetails = partyInfo.getSecurityDetailsArray();
			
			for(int i = 0; i < securityDetails.length; i++) {
				if(securityDetails[i].getSecurityId().equals(_securityId)) {
					CertificateRefType[] crt = securityDetails[i].getTrustAnchors().getAnchorCertificateRefArray();
					
					if(crt.length != 0) {
						resultSecurityDetailsTrustAnchorsCertIds = new String[crt.length];
						
						for(int j = 0; j < crt.length; j++) 
							resultSecurityDetailsTrustAnchorsCertIds[j] = crt[j].getCertId();
					}
				}
			}
			
			return resultSecurityDetailsTrustAnchorsCertIds;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo DeliveryChannel ߰
	 * 
	 * @param _channelId				DeliveryChannel attribute 'channelId'
	 * @param _transportId				DeliveryChannel attribute 'transportId'
	 * @param _docExchangeId			DeliveryChannel attribute 'docExchangeId'
	 * @param _syncReplyMode			MessagingCharacteristics attribute 'syncReplyMode'
	 * @param _ackRequested				MessagingCharacteristics attribute 'ackRequested' 
	 * @param _ackSignatureRequested	MessagingCharacteristics attribute 'ackSignatureRequested'
	 * @param _duplicateElimination		MessagingCharacteristics attribute 'duplicateElimination'
	 * @param _actor					MessagingCharacteristics attribute 'actor'
	 * 
	 * @return  DeliveryChannel
	 * @throws EbmsCpaException 
	 */
	public DeliveryChannelDocument.DeliveryChannel addDeliveryChannelWithMessagingCharacteristics(String _channelId, String _transportId, String _docExchangeId, SyncReplyModeType.Enum _syncReplyMode, PerMessageCharacteristicsType.Enum _ackRequested, PerMessageCharacteristicsType.Enum _ackSignatureRequested, PerMessageCharacteristicsType.Enum _duplicateElimination, ActorType.Enum _actor) throws EbmsCpaException {
		try {
			DeliveryChannelDocument.DeliveryChannel deliveryChannel = partyInfo.addNewDeliveryChannel();
			
			deliveryChannel.setChannelId(_channelId);
			deliveryChannel.setTransportId(_transportId);
			deliveryChannel.setDocExchangeId(_docExchangeId);
			
			MessagingCharacteristicsDocument.MessagingCharacteristics messagingCharacteristics = deliveryChannel.addNewMessagingCharacteristics();
			messagingCharacteristics.setSyncReplyMode(_syncReplyMode);
			messagingCharacteristics.setAckRequested(_ackRequested);
			messagingCharacteristics.setAckSignatureRequested(_ackSignatureRequested);
			messagingCharacteristics.setDuplicateElimination(_duplicateElimination);
			messagingCharacteristics.setActor(_actor);
			
			return deliveryChannel;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo DeliveryChannel 
	 * 
	 * @param _action					Action
	 * @param _transportId				DeliveryChannel attribute 'transportId'
	 * 
	 * @return void
	 */
	public void setTransportIdUnderDeliveryChannel(String _action, String _transportId) throws EbmsCpaException {
		try {
			String channelId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			
			String pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding/tp:ChannelId";		
			ChannelIdDocument[] results_channelId = (ChannelIdDocument[])partyInfo.execQuery(tpNamespace + pathExpression);		
			channelId = results_channelId[0].getChannelId();
			
			pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DeliveryChannel[@tp:channelId='" + channelId + "']";
			
			DeliveryChannelDocument.DeliveryChannel[] results_deliveryChannel = (DeliveryChannelDocument.DeliveryChannel[])partyInfo.selectPath(tpNamespace + pathExpression);		
			
			results_deliveryChannel[0].setTransportId(_transportId);
			
			System.out.println(results_deliveryChannel[0].getTransportId());
		}
		catch(Exception e) {			
			throw new EbmsCpaException(0, 0, e); 
		}
	}
	
	/**
	 * CollaborationProtocolAgreement DeliveryChannelId ȯ
	 *  
	 * @return DeliveryChannel Id
	 */
	public String[] getDeliveryChannelIds() throws EbmsCpaException {
		try {
			String[] deliveryChannelId = null;
			DeliveryChannelDocument.DeliveryChannel[] deliveryChannel = partyInfo.getDeliveryChannelArray();
			
			deliveryChannelId = new String[deliveryChannel.length];
			
			for(int i = 0; i < deliveryChannel.length; i++) 
				deliveryChannelId[i] = deliveryChannel[i].getChannelId();
			
			return deliveryChannelId;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * CollaborationProtocolAgreement DeliveryChannel ȯ
	 *  
	 * @return DeliveryChannel
	 */
	public DeliveryChannel getDeliveryChannel(String _channelId) throws EbmsCpaException {
		try {
			DeliveryChannelDocument.DeliveryChannel[] deliveryChannel = partyInfo.getDeliveryChannelArray();
			
			for(int i = 0; i < deliveryChannel.length; i++) {
				if(deliveryChannel[i].getChannelId().equals(_channelId)) 
					return new DeliveryChannel(deliveryChannel[i]);
			}
			
			return null;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * CollaborationProtocolAgreement DeliveryChannelArray ȯ
	 *  
	 * @return DeliveryChannelArray
	 */
	public DeliveryChannel[] getDeliveryChannels() throws EbmsCpaException {
		try {
			DeliveryChannel[] deliveryChannelArray = null;
			DeliveryChannelDocument.DeliveryChannel[] deliveryChannel = partyInfo.getDeliveryChannelArray();
			
			deliveryChannelArray = new DeliveryChannel[deliveryChannel.length];
			
			for(int i = 0; i < deliveryChannel.length; i++)  {
				deliveryChannelArray[i] = new DeliveryChannel(deliveryChannel[i]);
			}
			
			return deliveryChannelArray;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	
	/**
	 * CollaborationProtocolAgreement DeliveryChannel ȯ
	 *  
	 * @return DeliveryChannel
	 */
	public DeliveryChannel getDeliveryChannelByAction(String _action) throws EbmsCpaException {
		try {
			CanSend canSend = this.getCanSend(_action);
			if(canSend != null) {
				String channelId = canSend.getChannelIds()[0];
				return this.getDeliveryChannel(channelId);
			}
			
			CanReceive canReceive = this.getCanReceive(_action);
			if(canReceive != null) {
				String channelId = canReceive.getChannelIds()[0];				
				return this.getDeliveryChannel(channelId);
			}
			
			return null;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * DocExchange MessagingCharacteristics element 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _seq		PartyId sequence
	 * @param _type		PartyId attribute 'type'
	 * @param _value	PartyId element value
	 * 
	 * @return void
	 */
	public void setMessagingCharacteristicsUnderDocExchange(PerMessageCharacteristicsType.Enum _ackRequested, PerMessageCharacteristicsType.Enum _ackSignatureRequested, SyncReplyModeType.Enum _syncReplyMode, PerMessageCharacteristicsType.Enum _duplicateElimination, ActorType.Enum _actor) throws EbmsCpaException {
		try {
			MessagingCharacteristics messagingCharacteristics = this.getMessagingCharacteristics();
			
			if(_ackRequested != null)
				messagingCharacteristics.setAckRequested(_ackRequested);
			
			if(_ackSignatureRequested != null)
				messagingCharacteristics.setAckSignatureRequested(_ackSignatureRequested);
			
			if(_syncReplyMode != null)
				messagingCharacteristics.setSyncReplyMode(_syncReplyMode);
			
			if(_duplicateElimination != null)
				messagingCharacteristics.setDuplicateElimination(_duplicateElimination);
			
			if(_actor != null)
				messagingCharacteristics.setActor(_actor);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}	
	
	/**
	 * Action شϴ Delivery channel  MessagingCharacteristics  ´.
	 * 
	 * @param _action Action
	 *  
	 * @return MessagingCharacteristics
	 */
	public MessagingCharacteristics getMessagingCharacteristics(String _action) throws EbmsCpaException {
		try {
			MessagingCharacteristics messagingCharacteristics = null;
			String channelId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
	
			String pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding/tp:ChannelId";		
			ChannelIdDocument[] results_channelId = (ChannelIdDocument[])partyInfo.execQuery(tpNamespace + pathExpression);		
			channelId = results_channelId[0].getChannelId();
						
			pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DeliveryChannel[@tp:channelId='" + channelId + "']/tp:MessagingCharacteristics";

			MessagingCharacteristicsDocument.MessagingCharacteristics[] result_messagingCharacteristics = (MessagingCharacteristicsDocument.MessagingCharacteristics[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			return new MessagingCharacteristics(result_messagingCharacteristics[0]);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}

	/**
	 * default channel  MessagingCharacteristics  ´.
	 *  
	 * @return MessagingCharacteristics
	 */
	public MessagingCharacteristics getMessagingCharacteristics() throws EbmsCpaException {
		try {
			MessagingCharacteristics messagingCharacteristics = null;
			MessagingCharacteristicsDocument.MessagingCharacteristics messagingCharacteristics_ = null;
			DeliveryChannelDocument.DeliveryChannel[] deliveryChannel = null;
			String defaultChannelId = null;
			
			defaultChannelId = partyInfo.getDefaultMshChannelId();
			
			deliveryChannel = partyInfo.getDeliveryChannelArray();
					
			for(int i = 0; i < deliveryChannel.length; i++) {
				if(defaultChannelId.equals(deliveryChannel[i].getChannelId())) {
					messagingCharacteristics_ = deliveryChannel[i].getMessagingCharacteristics();
					
					messagingCharacteristics = new MessagingCharacteristics(messagingCharacteristics_);
					
					break;
				}
			}
			
			return messagingCharacteristics;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	

	/**
	 * PartyInfo Transport ߰
	 * 
	 * @param _transportId				Transport attribute 'transportId'
	 * @param _senderProtocol			TransportSender-TransportProtocol. Sender  
	 * @param _receiverProtocol			TransportSender-TransportProtocol. Receiver  
	 * @param _uri						TransportReceiver Endpoint
	 * 
	 * @return void
	 */
	public TransportDocument.Transport addTransport(String _transportId, String _senderProtocol, String _receiverProtocol, String _uri) throws EbmsCpaException {
		try {
			TransportDocument.Transport transport = partyInfo.addNewTransport();
			
			transport.setTransportId(_transportId);
			
			TransportSenderDocument.TransportSender transportSender = transport.addNewTransportSender();
			transportSender.addNewTransportProtocol().setStringValue(_senderProtocol);		
			
			TransportReceiverDocument.TransportReceiver transportReceiver = transport.addNewTransportReceiver();
			transportReceiver.addNewTransportProtocol().setStringValue(_receiverProtocol);
					
			EndpointDocument.Endpoint endpoint = transportReceiver.addNewEndpoint();
			endpoint.setType(EndpointTypeType.ALL_PURPOSE);
			endpoint.setUri(_uri);
			
			return transport;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}

	/**
	 * PartyInfo Transport element 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _seq		PartyId sequence
	 * @param _type		PartyId attribute 'type'
	 * @param _value	PartyId element value
	 * 
	 * @return void
	 */
	public void setTransport(String _oldTransportId, String _newTransportId, String _senderProtocol, String _receiverProtocol, int _endpointSeq, String _uri) throws EbmsCpaException {
		try {
			TransportDocument.Transport[] transports = partyInfo.getTransportArray();
			
			for(int i = 0; i < transports.length; i++) {
				if(transports[i].getTransportId().equals(_oldTransportId)) {
					if(_newTransportId != null)
						this.setAttribute(_oldTransportId, _newTransportId);
					
					if(_senderProtocol != null) {
						ProtocolType pt = ProtocolType.Factory.newInstance();
						pt.setStringValue(_senderProtocol);
						transports[i].getTransportSender().setTransportProtocol(pt);
					}
					
					if(_receiverProtocol != null) {
						ProtocolType pt = ProtocolType.Factory.newInstance();
						pt.setStringValue(_receiverProtocol);
						EndpointDocument.Endpoint endpoint = EndpointDocument.Endpoint.Factory.newInstance();
						endpoint.setUri(_uri);
						
						transports[i].getTransportReceiver().setTransportProtocol(pt);
						transports[i].getTransportReceiver().setEndpointArray(_endpointSeq, endpoint);
					}
				}
			}
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo Transport element id ȯ
	 *  
	 * @return Transport element id ȯ
	 */
	public String[] getTranportIds() throws EbmsCpaException {
		try {
			String[] transport = null;
			TransportDocument.Transport[] transportArray = partyInfo.getTransportArray();
			
			transport = new String[transportArray.length];
		
			for(int i = 0; i < transportArray.length; i++) 
				transport[i] = transportArray[i].getTransportId();
			
			return transport;		
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo Transport-Endpoint 
	 * DeliveryChannelId  Endpoint 
	 * 
	 * @param _deliveryChannelId	 DeliveryChannelId
	 * @param _endpoint				ο Endpoint
	 * 
	 * @return void
	 */
	public void setEndpointwithDeliveryChannel(String _deliveryChannelId, String _endpoint) throws EbmsCpaException {
		try {
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			
			String pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:DeliveryChannel[@tp:channelId='" + _deliveryChannelId + "'] return $x/tp:DeliveryChannel";
			DeliveryChannelDocument[] results_deliveryChannels = (DeliveryChannelDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			
			DeliveryChannelDocument.DeliveryChannel deliveryChannel = results_deliveryChannels[0].getDeliveryChannel();
			
			String transportId = deliveryChannel.getTransportId();
			
			pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:Transport[@tp:transportId='" + transportId + "']/tp:TransportReceiver/tp:Endpoint";
			
			EndpointDocument.Endpoint[] results_endpoint = (EndpointDocument.Endpoint[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			results_endpoint[0].setUri(_endpoint);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo Default Endpoint ȯ
	 * 
	 * @return Default endpoint
	 */
	public String[] getEndpointsWithDefaultChannelUnderTransport() throws EbmsCpaException {
		try {
			String[] endPoint = null;
			String channelId = null;
			String transportId = null;
			
			channelId = partyInfo.getDefaultMshChannelId();
			
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			
			String pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:DeliveryChannel[@tp:channelId='" + channelId + "'] return $x/tp:Transport";
	
			TransportDocument[] results_transport = (TransportDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			
			transportId = results_transport[0].getTransport().getTransportId();
			
			pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:Transport[@tp:transportId='" + transportId + "']/tp:TransportReceiver/tp:Endpoint";

			EndpointDocument.Endpoint[] result_endpoints = (EndpointDocument.Endpoint[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			endPoint = new String[result_endpoints.length];
			
			for(int i = 0; i < result_endpoints.length; i++) 
				endPoint[i] = result_endpoints[i].getUri();
			
			return endPoint;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	

	

	/**
	 * PartyInfo Action شϴ Endpoint ȯ
	 * 
	 * @param _action Action
	 * 
	 * @return Action شϴ Endpoint
	 */
	public String[] getEndpointsUnderTransport(String _action) throws EbmsCpaException {
		try {
			String[] endPoint = null;
			String channelId = null;
			String transportId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			
			String pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive/tp:ThisPartyActionBinding/tp:ChannelId";		
			ChannelIdDocument[] results_channelId = (ChannelIdDocument[])partyInfo.execQuery(tpNamespace + pathExpression);		
			channelId = results_channelId[0].getChannelId();
			
			pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo where $x/tp:DeliveryChannel[@tp:channelId='" + channelId + "'] return $x/tp:DeliveryChannel";		
			DeliveryChannelDocument[] results_deliveryChannel = (DeliveryChannelDocument[])partyInfo.execQuery(tpNamespace + pathExpression);		
			transportId = results_deliveryChannel[0].getDeliveryChannel().getTransportId();
			
			pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:Transport[@tp:transportId='" + transportId + "']/tp:TransportReceiver/tp:Endpoint";

			EndpointDocument.Endpoint[] result_endpoints = (EndpointDocument.Endpoint[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			endPoint = new String[result_endpoints.length];
			
			for(int i = 0; i < result_endpoints.length; i++) 
				endPoint[i] = result_endpoints[i].getUri();
			
			return endPoint;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo DocExchange-ReliableMessaging element 
	 *  
	 *   ״ ϰ   ڿ 'null' Է
	 * Retries   ״ ϰ   ڿ '-1' Է
	 * 
	 * @param _action					شϴ Action
	 * @param _retries					Retry Ƚ
	 * @param _retryInterval			Retry 
	 * @param _messageOrderSemantics 	MessageOrderSemantics
	 * 
	 * @return ReliableMessaging
	 */
	public void setReliableMessagingbySenderUnderDocExchange(String _action, int _retries, GDuration _retryInterval, MessageOrderSemanticsType.Enum _messageOrderSemantics) throws EbmsCpaException {
		try {
			ReliableMessaging reliableMessaging = this.getReliableMessagebySenderUnderDocExchange(_action);
			
			if(_retries != -1)
				reliableMessaging.setRetries(_retries);
			if(_retryInterval != null)
				reliableMessaging.setRetryInterval(_retryInterval);
			if(_messageOrderSemantics != null)
				reliableMessaging.setMessageOrderSemantics(_messageOrderSemantics);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	/**
	 * PartyInfo DocExchange-ReliableMessaging element 
	 *  
	 *   ״ ϰ   ڿ 'null' Է
	 * Retries   ״ ϰ   ڿ '-1' Է
	 * 
	 * @param _action					شϴ Action
	 * @param _retries					Retry Ƚ
	 * @param _retryInterval			Retry 
	 * @param _messageOrderSemantics 	MessageOrderSemantics
	 * 
	 * @return ReliableMessaging
	 */
	public void setReliableMessagingbyReceiverUnderDocExchange(String _action, int _retries, GDuration _retryInterval, MessageOrderSemanticsType.Enum _messageOrderSemantics) throws EbmsCpaException {
		try {
			ReliableMessaging reliableMessaging = this.getReliableMessagebyReceiverUnderDocExchange(_action);
			
			if(_retries != -1)				
				reliableMessaging.setRetries(_retries);
			
			if(_retryInterval != null)				
				reliableMessaging.setRetryInterval(_retryInterval);
			
			if(_messageOrderSemantics != null)
				reliableMessaging.setMessageOrderSemantics(_messageOrderSemantics);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo DocExchange-ReliableMessaging element ´.
	 * 
	 * @param _action	شϴ Action
	 * @param _role		Sender Ǵ Receiver
	 * 
	 * @return ReliableMessaging
	 */
	public ReliableMessaging getReliableMessaing(String _action, String _role) throws EbmsCpaException {
		try {
			ReliableMessaging reliableMessaging = null;
			
			String channelId = null;		
			String docExchangeId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
	
			String pathExpression = "";
			if( _role.toLowerCase().equals("sender"))
				pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding/tp:ChannelId";
			else
				pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive/tp:ThisPartyActionBinding/tp:ChannelId";
			
			ChannelIdDocument[] results_channelId = (ChannelIdDocument[])partyInfo.execQuery(tpNamespace + pathExpression);		
			channelId = results_channelId[0].getChannelId();
	
			pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo where $x/tp:DeliveryChannel[@tp:channelId='" + channelId + "'] return $x/tp:DeliveryChannel";
			DeliveryChannelDocument[] results_deliveryChannel = (DeliveryChannelDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			docExchangeId = results_deliveryChannel[0].getDeliveryChannel().getDocExchangeId();		
	
			if( _role.toLowerCase().equals("sender") ) {
				pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLSenderBinding/tp:ReliableMessaging";
				
				ReliableMessagingDocument.ReliableMessaging[] results_reliableMessaging = (ReliableMessagingDocument.ReliableMessaging[])partyInfo.selectPath(tpNamespace + pathExpression);
				
				reliableMessaging = new ReliableMessaging(results_reliableMessaging[0]);
			}
			else if( _role.toLowerCase().equals("receiver") ) {
				pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLReceiverBinding/tp:ReliableMessaging";
				ReliableMessagingDocument.ReliableMessaging[] results_reliableMessaging = (ReliableMessagingDocument.ReliableMessaging[])partyInfo.selectPath(tpNamespace + pathExpression);
				
				reliableMessaging = new ReliableMessaging(results_reliableMessaging[0]);
			}
			
			return reliableMessaging;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo DocExchange-ebXMLSenderBinding-ReliableMessaging element ´.
	 * 
	 * @param _action	شϴ Action
	 * 
	 * @return ReliableMessaging
	 */
	public ReliableMessaging getReliableMessagebySenderUnderDocExchange(String action) throws EbmsCpaException {
		try {
			return this.getReliableMessaing(action, "sender");
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}

	/**
	 * PartyInfo DocExchange-ebXMLReceiverBinding-ReliableMessaging element ´.
	 * 
	 * @param _action	شϴ Action
	 * 
	 * @return ReliableMessaging
	 */
	public ReliableMessaging getReliableMessagebyReceiverUnderDocExchange(String action) throws EbmsCpaException {
		try {
			return this.getReliableMessaing(action, "receiver");
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo DocExchange element ߰
	 * 
	 * _senderNonRepudiation _receiverNonRepudiation 'null' ΰ element ߰ ʴ´.
	 * 
	 * @param _senderRm					ebXMLSenderBinding ReliableMessaging
	 * @param _senderPersistDuration	ebXMLSenderBinding PersistDuration
	 * @param _senderNonRepudiation		ebXMLSenderBinding SenderNonRepudiation
	 * 
	 * @param _receiverRm				ebXMLReceiverBinding ReliableMessaging
	 * @param _receiverPersistDuration	ebXMLReceiverBinding PersistDuration
	 * @param _receiverNonRepudiation	ebXMLReceiverBinding ReceiverNonRepudiation
	 * 
	 * @return  DocExchange
	 */
	public DocExchangeDocument.DocExchange addDocExchange(ReliableMessaging _senderRm, GDuration _senderPersistDuration, SenderNonRepudiation _senderNonRepudiation, ReliableMessaging _receiverRm, GDuration _receiverPersistDuration, ReceiverNonRepudiation _receiverNonRepudiation) throws EbmsCpaException {
		try {
			DocExchangeDocument.DocExchange docExchange = partyInfo.addNewDocExchange();
			
			EbXMLSenderBindingDocument.EbXMLSenderBinding senderBinding = docExchange.addNewEbXMLSenderBinding();
			senderBinding.setVersion("2.0");
			ReliableMessagingDocument.ReliableMessaging senderReliableMessaging = senderBinding.addNewReliableMessaging();
			senderReliableMessaging.setRetries(new BigInteger(new Integer(_senderRm.getRetries()).toString()));
			senderReliableMessaging.setRetryInterval(_senderRm.getRertryInterval());
			senderReliableMessaging.setMessageOrderSemantics(_senderRm.getMessageOrderSemantics());
			
			senderBinding.setPersistDuration(_senderPersistDuration);
			
			if(_senderNonRepudiation != null) {
				SenderNonRepudiationDocument.SenderNonRepudiation senderNonRepudiation = senderBinding.addNewSenderNonRepudiation();
				
				ProtocolType tmp = ProtocolType.Factory.newInstance();
				tmp.setStringValue(_senderNonRepudiation.getNonRepudiationProtocol());
				senderNonRepudiation.setNonRepudiationProtocol(tmp);
							
				senderNonRepudiation.setHashFunction(_senderNonRepudiation.getHashFunction());
				
				for(int i = 0; i < _senderNonRepudiation.getSignatureAlgorithms().length; i++) {
					SignatureAlgorithmDocument.SignatureAlgorithm signatureAlgorithm = SignatureAlgorithmDocument.SignatureAlgorithm.Factory.newInstance();
				
					signatureAlgorithm.setStringValue(_senderNonRepudiation.getSignatureAlgorithms()[i]);
					
					senderNonRepudiation.setSignatureAlgorithmArray(i, signatureAlgorithm);
				}
				
				CertificateRefType crt = CertificateRefType.Factory.newInstance();
				crt.setCertId(_senderNonRepudiation.getCertId());
			}
			
			EbXMLReceiverBindingDocument.EbXMLReceiverBinding receiverBinding = docExchange.addNewEbXMLReceiverBinding();
			receiverBinding.setVersion("2.0");
			
			ReliableMessagingDocument.ReliableMessaging receiverReliableMessaging = senderBinding.addNewReliableMessaging();
			receiverReliableMessaging.setRetries(new BigInteger(new Integer(_receiverRm.getRetries()).toString()));
			receiverReliableMessaging.setRetryInterval(_receiverRm.getRertryInterval());
			receiverReliableMessaging.setMessageOrderSemantics(_receiverRm.getMessageOrderSemantics());
			
			receiverBinding.setPersistDuration(_receiverPersistDuration);
			
			if(_receiverNonRepudiation != null) {
				ReceiverNonRepudiationDocument.ReceiverNonRepudiation receiverNonRepudiation = receiverBinding.addNewReceiverNonRepudiation();
				
				ProtocolType tmp = ProtocolType.Factory.newInstance();
				tmp.setStringValue(_senderNonRepudiation.getNonRepudiationProtocol());
				receiverNonRepudiation.setNonRepudiationProtocol(tmp);
				
				receiverNonRepudiation.setHashFunction(_receiverNonRepudiation.getHashFunction());
				
				for(int i = 0; i < _receiverNonRepudiation.getSignatureAlgorithms().length; i++) {
					SignatureAlgorithmDocument.SignatureAlgorithm signatureAlgorithm = SignatureAlgorithmDocument.SignatureAlgorithm.Factory.newInstance();
					
					signatureAlgorithm.setStringValue(_senderNonRepudiation.getSignatureAlgorithms()[i]);
					
					receiverNonRepudiation.setSignatureAlgorithmArray(i, signatureAlgorithm);
				}
				
				SecurityDetailsRefType sdrt = SecurityDetailsRefType.Factory.newInstance();
				sdrt.setSecurityId(_receiverNonRepudiation.getSecurityId());
				receiverNonRepudiation.setSigningSecurityDetailsRef(sdrt);
			}
			
			return docExchange;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}

	/**
	 * PartyInfo ebXMLReceiverBinding-ReceiverNonRepudiation element 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _action					شϴ Action
	 * @param _nonRepudiationProtocol	NonRepudiation Protocol
	 * @param _hashFunction				NonRepudiation HashFunction
	 * @param _signatureAlgorithms		NonRepudiation SignatureAlgorithm Array
	 * @param _securityId				NonRepudiation-SigningSecurityDetailsRef SecurityId
	 * 
	 * @return void
	 */
	public void setReceiverNonRepudiationUnderDocExchange (String _action, String _nonRepudiationProtocol, String _hashFunction, String[] _signatureAlgorithms, String _securityId) throws EbmsCpaException {
		try {
			ReceiverNonRepudiation receiverNonRepudiation = (ReceiverNonRepudiation)this.getNonRepudiationUnderDocExchange(_action, "receiver");
			
			if( receiverNonRepudiation != null ) {
				receiverNonRepudiation.setNonRepudiationProtocol(_nonRepudiationProtocol);
				receiverNonRepudiation.setHashFunction(_hashFunction);
				receiverNonRepudiation.setSecurityId(_securityId);
				
				for(int i = 0; i < _signatureAlgorithms.length; i++) 
					receiverNonRepudiation.setSignatureAlgorithm(i, _signatureAlgorithms[i]);
			}
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo DocExchange attribute 'id' ȯ
	 * 
	 * @return DocExchange id
	 */
	public java.lang.String[] getDocExchangeIds() throws EbmsCpaException {
		try {
			String[] docExchange = null;
			DocExchangeDocument.DocExchange[] docExchangeArray = partyInfo.getDocExchangeArray();
			
			docExchange = new String[docExchangeArray.length];
		
			for(int i = 0; i < docExchangeArray.length; i++) 
				docExchange[i] = docExchangeArray[i].getDocExchangeId();
			
			return docExchange;	
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	} 
	
	public NonRepudiation getNonRepudiationUnderDocExchangeByDocExchangeId(String _docExchange, String _role) throws EbmsCpaException {
		try {
			NonRepudiation nonRepudiation = null;
			
			String channelId = null;
			String docExchangeId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			String pathExpression = null;
			
			channelId = partyInfo.getDefaultMshChannelId();
			
			pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo where $x/tp:DeliveryChannel[@tp:channelId='" + channelId + "'] return $x/tp:DeliveryChannel";
			
			DeliveryChannelDocument[] results_deliveryChannel = (DeliveryChannelDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			docExchangeId = results_deliveryChannel[0].getDeliveryChannel().getDocExchangeId();		
			
			if( _role.toLowerCase().equals("sender") ) {
				pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLSenderBinding/tp:SenderNonRepudiation";

				SenderNonRepudiationDocument.SenderNonRepudiation[] result_senderNonRepudiation = (SenderNonRepudiationDocument.SenderNonRepudiation[])partyInfo.selectPath(tpNamespace + pathExpression);

				nonRepudiation = new SenderNonRepudiation(result_senderNonRepudiation[0]);
			}
			else if( _role.toLowerCase().equals("receiver") ) {
				pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLReceiverBinding/tp:ReceiverNonRepudiation";

				ReceiverNonRepudiationDocument.ReceiverNonRepudiation[] result_receiverNonRepudiation = (ReceiverNonRepudiationDocument.ReceiverNonRepudiation[])partyInfo.selectPath(tpNamespace + pathExpression);

				nonRepudiation = new ReceiverNonRepudiation(result_receiverNonRepudiation[0]);
			}
			
			return nonRepudiation;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	
	
	/**
	 * PartyInfo NonRepudiation element ´.
	 * 
	 * @param _action	شϴ Action
	 * @param _role		Sender Ǵ Receiver
	 * 
	 * @return NonRepudiation
	 */
	public NonRepudiation getNonRepudiationUnderDocExchange(String _action, String _role) throws EbmsCpaException {
		try {
			NonRepudiation nonRepudiation = null;
			
			String channelId = null;
			String docExchangeId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
	
			String pathExpression = "";
			if( _role.toLowerCase().equals("sender"))
				pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding/tp:ChannelId";
			else
				pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive/tp:ThisPartyActionBinding/tp:ChannelId";
			
			
			ChannelIdDocument[] results_channelId = (ChannelIdDocument[])partyInfo.execQuery(tpNamespace + pathExpression);		
			channelId = results_channelId[0].getChannelId();
			
			pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo where $x/tp:DeliveryChannel[@tp:channelId='" + channelId + "'] return $x/tp:DeliveryChannel";
			DeliveryChannelDocument[] results_deliveryChannel = (DeliveryChannelDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			docExchangeId = results_deliveryChannel[0].getDeliveryChannel().getDocExchangeId();		
			
			if( _role.toLowerCase().equals("sender") ) {
				pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLSenderBinding/tp:SenderNonRepudiation";

				SenderNonRepudiationDocument.SenderNonRepudiation[] result_senderNonRepudiation = (SenderNonRepudiationDocument.SenderNonRepudiation[])partyInfo.selectPath(tpNamespace + pathExpression);

				nonRepudiation = new SenderNonRepudiation(result_senderNonRepudiation[0]);
			}
			else if( _role.toLowerCase().equals("receiver") ) {
				pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLReceiverBinding/tp:ReceiverNonRepudiation";

				ReceiverNonRepudiationDocument.ReceiverNonRepudiation[] result_receiverNonRepudiation = (ReceiverNonRepudiationDocument.ReceiverNonRepudiation[])partyInfo.selectPath(tpNamespace + pathExpression);

				nonRepudiation = new ReceiverNonRepudiation(result_receiverNonRepudiation[0]);
			}
			
			return nonRepudiation;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}

	
	/**
	 * PartyInfo DocExchange-PersistDuration 
	 * 
	 * @param _action				Action
	 * @param _persistDuration		PersistDuration
	 * 
	 * @return void
	 */	
	public void setPersistDurationbySenderUnderDocExchange(String _action, GDuration _persistDuration) throws EbmsCpaException {
		try {
			String channelId = null;		
			String docExchangeId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			
			String pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding/tp:ChannelId";			
			ChannelIdDocument[] results_channelId = (ChannelIdDocument[])partyInfo.execQuery(tpNamespace + pathExpression);		
			channelId = results_channelId[0].getChannelId();
			
			pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo where $x/tp:DeliveryChannel[@tp:channelId='" + channelId + "'] return $x/tp:DeliveryChannel";
			DeliveryChannelDocument[] results_deliveryChannel = (DeliveryChannelDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			docExchangeId = results_deliveryChannel[0].getDeliveryChannel().getDocExchangeId();
			
			pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLSenderBinding/tp:PersistDuration";
						
			XmlDuration[] results_Duration = (XmlDuration[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			results_Duration[0].setGDurationValue(_persistDuration);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo DocExchange-PersistDuration 
	 * 
	 * @param _action				Action
	 * @param _persistDuration		PersistDuration
	 * 
	 * @return void
	 */
	public void setPersistDurationbyReceiverUnderDocExchange(String _action, GDuration _persistDuration) throws EbmsCpaException {
		try {
			String channelId = null;		
			String docExchangeId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			
			String pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding/tp:ChannelId";		
			ChannelIdDocument[] results_channelId = (ChannelIdDocument[])partyInfo.execQuery(tpNamespace + pathExpression);		
			channelId = results_channelId[0].getChannelId();
			
			pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo where $x/tp:DeliveryChannel[@tp:channelId='" + channelId + "'] return $x/tp:DeliveryChannel";
			DeliveryChannelDocument[] results_deliveryChannel = (DeliveryChannelDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			docExchangeId = results_deliveryChannel[0].getDeliveryChannel().getDocExchangeId();		
					
			pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLReceiverBinding/tp:PersistDuration";
			
			XmlDuration[] results_Duration = (XmlDuration[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			results_Duration[0].setGDurationValue(_persistDuration);			
			
			/*pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo where $x/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "'] return $x/tp:DocExchange/tp:ebXMLReceiverBinding/tp:PersistDuration";
			PersistDurationDocument[] results_persistDuration = (PersistDurationDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			
			results_persistDuration[0].setPersistDuration(_persistDuration);*/
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo DocExchange PersistDuration ´.
	 * 
	 * @param _action	شϴ Action
	 * 
	 * @return PersistDuration 
	 */
	public GDuration getPersistDurationbySender(String _action) throws EbmsCpaException {
		try {
			return this.getPersistDuration(_action, "Receiver");
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	public String getRole() throws EbmsCpaException {
		try {
			String role = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			
			String pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + getPartyName() + "']/tp:CollaborationRole/tp:Role";
			
			XmlObject[] xo = partyInfo.selectPath(tpNamespace + pathExpression);
			
			System.out.println(xo.getClass().getName());
			
			RoleDocument.Role[] results_role = (RoleDocument.Role[])partyInfo.selectPath(tpNamespace + pathExpression);
			
			role = results_role[0].getName();			
			
			return role;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo DocExchange PersistDuration ´.
	 * 
	 * @param _action	شϴ Action
	 * 
	 * @return PersistDuration 
	 */
	public GDuration getPersistDurationbyReceiver(String _action) throws EbmsCpaException {
		try {
			return this.getPersistDuration(_action, "Receiver");
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo DocExchange PersistDuration ´.
	 * 
	 * @param _action	شϴ Action
	 * @param _role		شϴ Role(ex. 'sender' or 'receiver')
	 * 
	 * @return PersistDuration 
	 */
	public GDuration getPersistDuration(String _action, String _role) throws EbmsCpaException {
		try {
			GDuration persistDuration = null;
			String channelId = null;		
			String docExchangeId = null;
			String tpNamespace = "declare namespace tp='http://www.oasis-open.org/committees/ebxml-cppa/schema/cpp-cpa-2_0.xsd';";
			
			String pathExpression = "";
			
			if( _role.toLowerCase().equals("sender"))
				pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanSend/tp:ThisPartyActionBinding/tp:ChannelId";
			else
				pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo[@tp:partyName='" + this.getPartyName() + "'] where $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive/tp:ThisPartyActionBinding[@tp:action='" + _action + "'] return $x/tp:CollaborationRole/tp:ServiceBinding/tp:CanReceive/tp:ThisPartyActionBinding/tp:ChannelId";
			

			ChannelIdDocument[] results_channelId = (ChannelIdDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			channelId = results_channelId[0].getChannelId();
			
			pathExpression = "for $x in /tp:CollaborationProtocolAgreement/tp:PartyInfo where $x/tp:DeliveryChannel[@tp:channelId='" + channelId + "'] return $x/tp:DeliveryChannel";
			DeliveryChannelDocument[] results_deliveryChannel = (DeliveryChannelDocument[])partyInfo.execQuery(tpNamespace + pathExpression);
			docExchangeId = results_deliveryChannel[0].getDeliveryChannel().getDocExchangeId();		
			
			if( _role.toLowerCase().equals("sender") ) {
				pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLSenderBinding/tp:PersistDuration";

				XmlDuration[] result_persistDurations = (XmlDuration[])partyInfo.selectPath(tpNamespace + pathExpression);
				
				persistDuration = result_persistDurations[0].getGDurationValue();
			}
			else if( _role.toLowerCase().equals("receiver") ) {
				pathExpression = "/tp:CollaborationProtocolAgreement/tp:PartyInfo/tp:DocExchange[@tp:docExchangeId='" + docExchangeId + "']/tp:ebXMLReceiverBinding/tp:PersistDuration";

				XmlDuration[] result_persistDurations = (XmlDuration[])partyInfo.selectPath(tpNamespace + pathExpression);
				
				persistDuration = result_persistDurations[0].getGDurationValue();
			}
	
			return persistDuration;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo Transport-TransportClientSecurity element ߰
	 * 
	 * @param _transportId		TransPort attribute 'id'
	 * @param _certId			CertId
	 * @param _securityId 		SecurityId
	 * 
	 * @return  TransportClientSecurity
	 */
	public TransportClientSecurityDocument.TransportClientSecurity addClientTransportSecurity(String _transportId, String _certId, String _securityId) throws EbmsCpaException {
		try {
			TransportDocument.Transport[] transportArray = partyInfo.getTransportArray();
			
			for(int i = 0; i < transportArray.length; i++) {
				if(transportArray[i].getTransportId().equals(_transportId)) {
					if(transportArray[i].getTransportSender().getTransportClientSecurity() == null) {
						TransportClientSecurityDocument.TransportClientSecurity tcs = transportArray[i].getTransportSender().addNewTransportClientSecurity();
						
						ProtocolType protocolType = tcs.addNewTransportSecurityProtocol();
						protocolType.setVersion("3.0");
						protocolType.setStringValue("SSL");
						
						tcs.addNewClientCertificateRef().setCertId(_certId);
						tcs.addNewServerSecurityDetailsRef().setSecurityId(_securityId);
						
						return tcs;
					}
				}
			}
			
			return null;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo Transport-TransportClientSecurity element 
	 * 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _transportId		TransPort attribute 'id'
	 * @param _certId			CertId
	 * @param _securityId 		SecurityId
	 * 
	 * @return void
	 */
	public void setClientTransportSecurity(String _transportId, String _certId, String _securityId) throws EbmsCpaException {
		try {
			TransportDocument.Transport[] transportArray = partyInfo.getTransportArray();
			
			for(int i = 0; i < transportArray.length; i++) {
				if(transportArray[i].getTransportId().equals(_transportId)) {
					TransportClientSecurityDocument.TransportClientSecurity tcs = transportArray[i].getTransportSender().getTransportClientSecurity();
					
					if(_certId != null)
						tcs.getClientCertificateRef().setCertId(_certId);
					
					if(_securityId != null)
						tcs.getServerSecurityDetailsRef().setSecurityId(_securityId);
					
					break;
				}
			}
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo Transport-TransportClientSecurity element 
	 * 
	 * @param _transportId		TransPort attribute 'id'
	 * 
	 * @return TransportClientSecurity ClientCertificateRef 
	 */
	public String getTransportClientSecurity(String _transportId) throws EbmsCpaException {
		try {
			TransportDocument.Transport[] transportArray = partyInfo.getTransportArray();
			
			for(int i = 0; i < transportArray.length; i++) {
				if(transportArray[i].getTransportId().equals(_transportId)) {
					TransportClientSecurityDocument.TransportClientSecurity tcs = transportArray[i].getTransportSender().getTransportClientSecurity();
					
					return tcs.getClientCertificateRef().getCertId();
				}
			}
			
			return null;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo Transport-TransportServerSecurity element ߰
	 * 
	 * @param _transportId		TransPort attribute 'id'
	 * @param _certId			CertId
	 * @param _securityId 		SecurityId
	 * 
	 * @return  TransportServerSecurity
	 */
	public TransportServerSecurityDocument.TransportServerSecurity addTransportServerSecurity(String _transportId, String _certId, String _securityId) throws EbmsCpaException {
		try {
			TransportDocument.Transport[] transportArray = partyInfo.getTransportArray();
			
			for(int i = 0; i < transportArray.length; i++) {
				if(transportArray[i].getTransportId().equals(_transportId)) {
					if(transportArray[i].getTransportReceiver().getTransportServerSecurity() == null) {
						TransportServerSecurityDocument.TransportServerSecurity transportServerSecurity = transportArray[i].getTransportReceiver().addNewTransportServerSecurity();
						
						ProtocolType protocolType = transportServerSecurity.addNewTransportSecurityProtocol();
						protocolType.setVersion("3.0");
						protocolType.setStringValue("SSL");
						
						transportServerSecurity.addNewServerCertificateRef().setCertId(_certId);
						
						transportServerSecurity.addNewClientSecurityDetailsRef().setSecurityId(_securityId);
						
						return transportServerSecurity;
					}
				}
			}
			
			return null;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	/**
	 * PartyInfo Transport-TransportServerSecurity element 
	 * 
	 *   ״ ϰ   ڿ 'null' Է
	 * 
	 * @param _transportId		TransPort attribute 'id'
	 * @param _certId			CertId
	 * @param _securityId 		SecurityId
	 * 
	 * @return void
	 */
	public void setTransportServerSecurity(String _transportId, String _certId, String _securityId) throws EbmsCpaException {
		try {
			TransportDocument.Transport[] transportArray = partyInfo.getTransportArray();
			
			for(int i = 0; i < transportArray.length; i++) {
				if(transportArray[i].getTransportId().equals(_transportId)) {
					TransportServerSecurityDocument.TransportServerSecurity tcs = transportArray[i].getTransportReceiver().getTransportServerSecurity();
					
					if(_certId != null)
						tcs.getServerCertificateRef().setCertId(_certId);
					
					if(_securityId != null)
						tcs.getClientSecurityDetailsRef().setSecurityId(_securityId);
					
					break;
				}
			}
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	/**
	 * PartyInfo Transport-TransportServerSecurity element 
	 * 
	 * @param _transportId		TransPort attribute 'id'
	 * 
	 * @return TransportServerSecurity ServerCertificateRef 
	 */
	public String getTransportServerSecurity(String _transportId) throws EbmsCpaException {
		try {
			TransportDocument.Transport[] transportArray = partyInfo.getTransportArray();
			
			for(int i = 0; i < transportArray.length; i++) {
				if(transportArray[i].getTransportId().equals(_transportId)) {
					TransportServerSecurityDocument.TransportServerSecurity tcs = transportArray[i].getTransportReceiver().getTransportServerSecurity();
					
					return tcs.getServerCertificateRef().getCertId();
				}
			}
			
			return null;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
	
	//TODO CPA ù° Certificate  ϰ .
	
	/*DocExchange ȿ ReceiverNonRepudiation/NonRepudiationProtocol/SigningSecurityDetailsRef/
	 *  securityId ù°  ֻ trust anchor certificate̴. 
	 * <tp:ReceiverNonRepudiation>
	<tp:NonRepudiationProtocol>http://www.w3.org/2000/09/xmldsig#</tp:NonRepudiationProtocol>
		<tp:HashFunction>http://www.w3.org/2000/09/xmldsig#sha1</tp:HashFunction>
		<tp:SignatureAlgorithm>http://www.w3.org/2000/09/xmldsig#dsa-sha1</tp:SignatureAlgorithm>
		<tp:SigningSecurityDetailsRef tp:securityId="CompanyA_MessageSecurity"/>
		</tp:ReceiverNonRepudiation>
		
		*/
	public X509Certificate getRootCertificate() throws EbmsCpaException {
		X509Certificate certificate = this.getCertificates()[0].getX509Certificate()[0];
		
		return certificate;
	}
	
	//TODO  ϼ getPartyCertificate()
	/*
	 *DocExchange SenderNonRepudiation/SigningCertificateRef 
	 * certId  party certification̴. 
	 <tp:SenderNonRepudiation>
	 <tp:NonRepudiationProtocol>http://www.w3.org/2000/09/xmldsig#</tp:NonRepudiationProtocol>
	 <tp:HashFunction>http://www.w3.org/2000/09/xmldsig#sha1</tp:HashFunction>
	 <tp:SignatureAlgorithm>http://www.w3.org/2000/09/xmldsig#dsa-sha1</tp:SignatureAlgorithm>
	 <tp:SigningCertificateRef tp:certId="CompanyA_SigningCert"/>
	 </tp:SenderNonRepudiation>
	 */
	
	public X509Certificate getPartyCertificate() throws EbmsCpaException {
		X509Certificate certificate = this.getCertificates()[0].getX509Certificate()[0];
		
		return certificate;
	}
}