package org.kldp.ebmsh.cpa;

import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ReceiverNonRepudiationDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SignatureAlgorithmDocument;

public class ReceiverNonRepudiation implements NonRepudiation {
	private ReceiverNonRepudiationDocument.ReceiverNonRepudiation receiverNonRepudiation;
	
	public ReceiverNonRepudiation(ReceiverNonRepudiationDocument.ReceiverNonRepudiation _receiverNonRepudiation) throws EbmsCpaException {
		this.receiverNonRepudiation = _receiverNonRepudiation;
	}
	
	public String getNonRepudiationProtocol() throws EbmsCpaException {
		try {
			return receiverNonRepudiation.getNonRepudiationProtocol().toString();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	public void setNonRepudiationProtocol(String _protocol) throws EbmsCpaException {
		try {
			receiverNonRepudiation.getNonRepudiationProtocol().setStringValue(_protocol);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setHashFunction(String _hashFunction) throws EbmsCpaException {
		try {
			receiverNonRepudiation.setHashFunction(_hashFunction);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public java.lang.String getHashFunction() throws EbmsCpaException {
		try {
			return receiverNonRepudiation.getHashFunction();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public void setSignatureAlgorithm(int _seq, String _algorithm) throws EbmsCpaException {
		try {
			SignatureAlgorithmDocument.SignatureAlgorithm signatureAlgorithm = SignatureAlgorithmDocument.SignatureAlgorithm.Factory.newInstance();
			signatureAlgorithm.setStringValue(_algorithm);
			receiverNonRepudiation.setSignatureAlgorithmArray(_seq, signatureAlgorithm);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public java.lang.String[] getSignatureAlgorithms() throws EbmsCpaException {
		try {
			String[] signatureAlgorithm = null;
			SignatureAlgorithmDocument.SignatureAlgorithm[] signatureAlgorithmArray = null;
			
			signatureAlgorithmArray = receiverNonRepudiation.getSignatureAlgorithmArray();
			
			if( signatureAlgorithmArray != null ) {
				signatureAlgorithm = new String[signatureAlgorithmArray.length];
				
				for(int i = 0; i < signatureAlgorithmArray.length; i++) 
					signatureAlgorithm[i] = signatureAlgorithmArray[i].getStringValue();
			}
			
			return signatureAlgorithm;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public void setSecurityId(String _securityId) throws EbmsCpaException {
		try {
			receiverNonRepudiation.getSigningSecurityDetailsRef().setSecurityId(_securityId);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public java.lang.String getSecurityId() throws EbmsCpaException {
		try {
			return receiverNonRepudiation.getSigningSecurityDetailsRef().getSecurityId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
}