package org.kldp.ebmsh.cpa;

import java.math.BigInteger;

import org.apache.xmlbeans.GDuration;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.MessageOrderSemanticsType;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.ReliableMessagingDocument;

public class ReliableMessaging {
	ReliableMessagingDocument.ReliableMessaging reliableMessaging = null;
	
	public ReliableMessaging(ReliableMessagingDocument.ReliableMessaging _reliableMessaging) {
		this.reliableMessaging = _reliableMessaging;
	}
	
	public MessageOrderSemanticsType.Enum getMessageOrderSemantics() throws EbmsCpaException {
		try {
			return reliableMessaging.getMessageOrderSemantics();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public int getRetries() throws EbmsCpaException {
		try {
			return reliableMessaging.getRetries().intValue();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	public GDuration getRertryInterval() throws EbmsCpaException {
		try {
			return reliableMessaging.getRetryInterval();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setMessageOrderSemantics(MessageOrderSemanticsType.Enum _messageOrder) throws EbmsCpaException {
		try {
			reliableMessaging.setMessageOrderSemantics(_messageOrder);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public void setRetries(int _retries) throws EbmsCpaException {
		try {
			reliableMessaging.setRetries(new BigInteger(new Integer(_retries).toString()));
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	public void setRetryInterval(GDuration _interval) throws EbmsCpaException {
		try {
			reliableMessaging.setRetryInterval(_interval);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
}