package org.kldp.ebmsh.cpa;

import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SenderNonRepudiationDocument;
import org.oasisOpen.committees.ebxmlCppa.schema.cppCpa20.SignatureAlgorithmDocument;

public class SenderNonRepudiation implements NonRepudiation {
	SenderNonRepudiationDocument.SenderNonRepudiation senderNonRepudiation;
	
	public SenderNonRepudiation(SenderNonRepudiationDocument.SenderNonRepudiation senderNonRepudiation) {
		this.senderNonRepudiation = senderNonRepudiation;
	}
	
	public String getNonRepudiationProtocol() throws EbmsCpaException {
		try {
			return senderNonRepudiation.getNonRepudiationProtocol().getStringValue();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}

	
	public void setNonRepudiationProtocol(String _protocol) throws EbmsCpaException {
		try {
			senderNonRepudiation.getNonRepudiationProtocol().setStringValue(_protocol);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	
	public void setHashFunction(String _hashFunction) throws EbmsCpaException {
		try {
			senderNonRepudiation.setHashFunction(_hashFunction);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public java.lang.String getHashFunction() throws EbmsCpaException {
		try {
			return senderNonRepudiation.getHashFunction();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}

	
	public void setSignatureAlgorithm(int _seq, String _algorithm) throws EbmsCpaException {
		try {
			SignatureAlgorithmDocument.SignatureAlgorithm signatureAlgorithm = SignatureAlgorithmDocument.SignatureAlgorithm.Factory.newInstance();
			signatureAlgorithm.setStringValue(_algorithm);
			senderNonRepudiation.setSignatureAlgorithmArray(_seq, signatureAlgorithm);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}
	
	public java.lang.String[] getSignatureAlgorithms() throws EbmsCpaException {
		try {
			String[] signatureAlgorithm = null;
			SignatureAlgorithmDocument.SignatureAlgorithm[] signatureAlgorithmArray = null;
			
			signatureAlgorithmArray = senderNonRepudiation.getSignatureAlgorithmArray();
			
			if( signatureAlgorithmArray != null ) {
				signatureAlgorithm = new String[signatureAlgorithmArray.length];
				
				for(int i = 0; i < signatureAlgorithmArray.length; i++) 
					signatureAlgorithm[i] = signatureAlgorithmArray[i].getStringValue();
			}
			
			return signatureAlgorithm;
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}

	
	public void setCertId(String _certId) throws EbmsCpaException {
		try {
			senderNonRepudiation.getSigningCertificateRef().setCertId(_certId);
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
		}
	}

	
	public java.lang.String getCertId() throws EbmsCpaException {
		try {
			return senderNonRepudiation.getSigningCertificateRef().getCertId();
		}
		catch(Exception e) {
			throw new EbmsCpaException(0, 0, e);
			
			
		}
	}
}