//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\AckRequested.java

package org.kldp.ebmsh.message.packaging;


import javax.xml.soap.SOAPException;

/**
@author pio
@version 0.0
@since 2003.1.1
6.3.1 AckRequested Element 
The AckRequested element is an OPTIONAL extension to the SOAP Header used by 
the Sending MSH 
to request a Receiving MSH, acting in the role of the actor URI identified in 
the SOAP actor attribute, 
returns an Acknowledgment Message. 
The AckRequested element contains the following: 
. a id attribute (see section 2.3.7 for details) 
. a version attribute (see section 2.3.8 for details) 
. a SOAP mustUnderstand attribute with a value of "1" (see section 2.3.9 for 
details) 
. a SOAP actor attribute 
. a signed attribute 
This element is used to indicate to a Receiving MSH, acting in the role 
identified by the SOAP actor attribute, whether an Acknowledgment Message is 
expected, and if so, whether the message should be signed by the Receiving MSH. 
An ebXML Message MAY have zero, one, or two instances of an AckRequested 
element. A single MSH node SHOULD only insert one AckRequested element. If 
there are two AckRequested elements present, they MUST have different values 
for their respective SOAP actor attributes. At most one AckRequested element 
can be targeted at the actor URI meaning Next MSH (see section 2.3.10) and at 
most one AckRequested element can be targeted at the actor URI meaning To Party 
MSH (see section 2.3.11) for any given message.
 */
public interface AckRequested extends EbxmlHeaderElement 
{
   
   /**
   @since 2003.1.1
   @param sign
   @throws javax.xml.soap.SOAPException
   @roseuid 40051A8F0046
    */
   public void setSigned(boolean sign) throws SOAPException;
   
   /**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 40051AAE0217
    */
   public boolean getSigned() throws SOAPException;
}
