//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\CPAId.java

package org.kldp.ebmsh.message.packaging;


/**
@author pio
@version 0.0
@since 2003.1.1
3.1.2 CPAId Element 
The REQUIRED CPAId element is a string that identifies the parameters governing 
the exchange of messages between the parties. The recipient of a message MUST 
be able to resolve the CPAId to an individual set of parameters, taking into 
account the sender of the message. 

The value of a CPAId element MUST be unique within a namespace mutually agreed 
by the two parties. 
This could be a concatenation of the From and To PartyId values, a URI prefixed 
with the Internet domain name of one of the parties, or a namespace offered and 
managed by some other naming or registry service. It is RECOMMENDED that the 
CPAId be a URI. 
The CPAId MAY reference an instance of a CPA as defined in the ebXML 
Collaboration Protocol Profile and Agreement Specification [ebCPP]. An example 
of the CPAId element follows: 
<eb:CPAId>http://example.com/cpas/ourcpawithyou.xml</eb:CPAId> 
The messaging parameters are determined by the appropriate elements from the 
CPA, as identified by the CPAId element. 
If a receiver determines that a message is in conflict with the CPA, the 
appropriate handling of this conflict is undefined by this specification. 
Therefore, senders SHOULD NOT generate such messages unless they have prior 
knowledge of the receiver's capability to deal with this conflict. If a 
Receiving MSH detects an inconsistency, then it MUST report it with an 
errorCode of Inconsistent and a severity of Error. If the CPAId is not 
recognized, then it MUST report it with an errorCode of NotRecognized and a 
severity of Error.
CPAId  õ cpa  ޴ ʿ  (conflict  ؼ 䱸) 
޽ 
ó   ߻ؾ Ѵ.
 */
public interface CPAId extends EbxmlElement 
{
}
