//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\ErrorList.java

package org.kldp.ebmsh.message.packaging;

import java.util.Iterator;

import javax.xml.soap.SOAPException;

/**
@author pio
@version 0.0
@since 2003.1.1
4.2.3 ErrorList Element 1283
The existence of an ErrorList extension element within the SOAP Header element 
indicates the message identified by the RefToMessageId in the MessageHeader 
element has an error. 
The ErrorList element consists of: 
. id attribute (see section 2.3.7 for details) 
. a version attribute (see section 2.3.8 for details) 
. a SOAP mustUnderstand attribute with a value of "1" (see section 2.3.9 for 
details) 
. highestSeverity attribute 
. one or more Error elements 
If there are no errors to be reported then the ErrorList element MUST NOT be 
present.
An example of an ErrorList element is given below. 
<eb:ErrorList eb:id="3490sdo", eb:highestSeverity="error" eb:version="2.0" 
SOAP:mustUnderstand="1"> 
<eb:Error eb:errorCode="SecurityFailure" eb:severity="Error" 
eb:location="URI_of_ds:Signature"> 
<eb:Description xml:lang="en-US">Validation of signature failed<eb:Description> 
</eb:Error> 
<eb:Error ...> ... </eb:Error> 
</eb:ErrorList>
 */
public interface ErrorList extends EbxmlHeaderElement 
{
   
   /**
   4.2.3.1 highestSeverity attribute 
   The highestSeverity attribute contains the highest severity of any of the Error 
   elements. Specifically, if any of the Error elements have a severity of Error, 
   highestSeverity MUST be set to Error; otherwise, highestSeverity MUST be set to 
   Warning.
   @since 2003.1.1
   @param serverity
   @throws javax.xml.soap.SOAPException
   @roseuid 3FFF721D0087
    */
   public void setHighestSeverity(String serverity) throws SOAPException;
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 3FFF72BF0293
    */
   public String getHighestServerity() throws SOAPException;
   
   /**
   Error  ߰Ѵ.
   @since 2003.1.1
   @return ErrorElement
   @throws javax.xml.soap.SOAPException
   @roseuid 3FFF7328033E
    */
   public ErrorElement addErrorElement() throws SOAPException;
   
   /**
   Error  ´.
   @since 2003.1.1
   @return java.util.Iterator
   @throws javax.xml.soap.SOAPException
   @roseuid 3FFF73B1009C
    */
   public Iterator getErrorElements() throws SOAPException;
}
