//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\MessageHeader.java

package org.kldp.ebmsh.message.packaging;

import javax.xml.soap.SOAPException;

/**
@author pio
@version 0.0
@since 2003.1.1
3.1 MessageHeader Element 
The MessageHeader element is REQUIRED in all ebXML Messages. It MUST be present 
as a child element of the SOAP Header element. 
The MessageHeader element is a composite element comprised of the following 
subordinate elements: 
. an id attribute (see section 2.3.7 for details) 
. a version attribute (see section 2.3.8 for details) 
. a SOAP mustUnderstand attribute with a value of "1" (see section 2.3.9 for 
details) 
. From element 
. To element 
. CPAId element 
. ConversationId element 
. Service element 
. Action element 
. MessageData element 
. DuplicateElimination element 
. Description element
 */
public interface MessageHeader extends EbxmlHeaderElement 
{
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.From
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3990225
    */
   public From addFrom() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.From
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3A0003A
    */
   public From getFrom() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.To
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3AC00BA
    */
   public To addTo() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.To
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3B30092
    */
   public To getTo() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.CPAId
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3BF027A
    */
   public CPAId addCPAId() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.CPAId
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3C6014D
    */
   public CPAId getCPAId() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.ConversationId
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3CE0090
    */
   public ConversationId addConversationId() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.ConversationId
   @roseuid 4004F3DA02E7
    */
   public ConversationId getConversationId() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Service
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3E50152
    */
   public Service addService() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Service
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3ED015D
    */
   public Service getService() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Action
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3F700CB
    */
   public Action addAction() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Action
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F3FD03D7
    */
   public Action getAction() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.MessageData
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F41800DD
    */
   public MessageData addMessageData() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.MessageData
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F42100E0
    */
   public MessageData getMessageData() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.DuplicateElimination
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F42A0237
    */
   public DuplicateElimination addDuplicateElimenation() throws SOAPException;
   
   
   public boolean hasDuplicateElimination() throws SOAPException ;
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.DuplicateElimination
   @throws javax.xml.soap.SOAPException
   @roseuid 4004F4390379
    */
   public DuplicateElimination getDuplicateElimenation() throws SOAPException;
}
