//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\Reference.java

package org.kldp.ebmsh.message.packaging;

import java.util.Iterator;

import javax.xml.soap.SOAPException;

/**
@author pio
@version 0.0
@since 2003.1.1
3.2.1 Reference Element 
The Reference element is a composite element consisting of the following 
subordinate elements: 
. zero or more Schema elements . information about the schema(s) that define 
the instance document identified in the parent Reference element 
. zero or more Description elements . a textual description of the payload 
object referenced by the parent Reference element 
The Reference element itself is a simple link [XLINK]. It should be noted that 
the use of XLINK in this context is chosen solely for the purpose of providing 
a concise vocabulary for describing an association. 
Use of an XLINK processor or engine is NOT REQUIRED, but may prove useful in 
certain 
implementations. 
The Reference element has the following attribute content in addition to the 
element content described above: 
. id . an XML ID for the Reference element, 
. xlink:type . this attribute defines the element as being an XLINK simple 
link. It has a fixed value of 'simple', 
. xlink:href . this REQUIRED attribute has a value that is the URI of the 
payload object referenced. It SHALL conform to the XLINK [XLINK] specification 
criteria for a simple link. 
. xlink:role . this attribute identifies some resource that describes the 
payload object or its purpose. If present, then it SHALL have a value that is a 
valid URI in accordance with the [XLINK] specification, 
. Any other namespace-qualified attribute MAY be present. A Receiving MSH MAY 
choose to ignore any foreign namespace attributes other than those defined 
above. 
The designer of the business process or information exchange using ebXML 
Messaging decides what payload data is referenced by the Manifest and the 
values to be used for xlink:role.

<eb:Reference eb:id="pay01" 
xlink:href="cid:payload-1" 
xlink:role="http://regrep.org/gci/purchaseOrder"> 
<eb:Schema eb:location="http://regrep.org/gci/purchaseOrder/po.xsd" 
eb:version="2.0"/> 
<eb:Description xml:lang="en-US">Purchase Order for 100,000 
widgets</eb:Description>
</eb:Reference> 
</eb:Manifest>
 */
public interface Reference extends EbxmlElement 
{
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Schema
   @throws javax.xml.soap.SOAPException
   @roseuid 40052D980288
    */
   public Schema addSchema() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 40052DA30139
    */
   public boolean hasSchema() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return java.util.Iterator
   @throws javax.xml.soap.SOAPException
   @roseuid 40052DAA0270
    */
   public Iterator getSchemas() throws SOAPException;
   
   /**
   @since 2003.1.1
   @param xlinkref
   @throws javax.xml.soap.SOAPException
   @roseuid 40052DB302C3
    */
   public void setXlinkRef(String xlinkref) throws SOAPException;
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 40052DD60205
    */
   public String getXlinkRef() throws SOAPException;
   
   /**
   @since 2003.1.1
   @param xlinkrole
   @throws javax.xml.soap.SOAPException
   @roseuid 40052DDF008B
    */
   public void setXlinkRole(String xlinkrole) throws SOAPException;
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 40052DE900FE
    */
   public String getXlinkRole() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Description
   @throws javax.xml.soap.SOAPException
   @roseuid 40052DF50231
    */
   public Description addDescription() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Description
   @throws javax.xml.soap.SOAPException
   @roseuid 40052E0E01DD
    */
   public Description getDescriptions() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 40052E170303
    */
   public boolean hasDescriptions() throws SOAPException;
}
