//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\SequenceNumber.java

package org.kldp.ebmsh.message.packaging;

import javax.xml.soap.SOAPException;

/**
@author pio
@version 0.0
@since 2003.1.1
9.1.1 SequenceNumber Element 
The REQUIRED SequenceNumber element indicates the sequence a Receiving MSH MUST 
process messages. The SequenceNumber is unique within the ConversationId and 
MSH. The From Party MSH and the To Party MSH each set an independent 
SequenceNumber as the Sending MSH within the ConversationId. It is set to zero 
on the first message from that MSH within a conversation and then incremented 
by one for each subsequent message sent. 
A MSH that receives a message with a SequenceNumber element MUST NOT pass the 
message to an application until all the messages with a lower SequenceNumber 
have been passed to the application. 

If the implementation defined limit for saved out-of-sequence messages is 
reached, then the Receiving MSH MUST indicate a delivery failure to the Sending 
MSH with errorCode set to DeliveryFailure and severity set to Error (see 
section 4.1.5). 
The SequenceNumber element is an integer value incremented by the Sending MSH 
(e.g. 0, 1, 2, 3, 4...) for each application-prepared message sent by that MSH 
within the ConversationId. The next value after 99999999 in the increment is 
0". The value of SequenceNumber consists of ASCII numerals in the range 
0-99999999. In following cases, SequenceNumber takes the value 0": 
1. First message from the Sending MSH within the conversation 
2. First message after resetting SequenceNumber information by the Sending MSH 
3. First message after wraparound (next value after 99999999) 
The SequenceNumber element has a single attribute, status. This attribute is an 
enumeration, which SHALL have one of the following values: 
. Reset . the SequenceNumber is reset as shown in 1 or 2 above 
. Continue . the SequenceNumber continues sequentially (including 3 above) 
When the SequenceNumber is set to 0" because of 1 or 2 above, the Sending MSH 
MUST set the 
status attribute of the message to Reset. In all other cases, including 3 
above, the status attribute MUST be set to Continue. The default value of the 
status attribute is Continue. 
A Sending MSH MUST wait before resetting the SequenceNumber of a conversation 
until it has received 
confirmation of all the messages previously sent for the conversation. Only 
when all the sent Messages are accounted for, can the Sending MSH reset the 
SequenceNumber.
 */
public interface SequenceNumber extends EbxmlElement 
{
   
   /**
   @since 2003.1.1
    */
   public static String Reset = "Reset";
   
   /**
   @since 2003.1.1
    */
   public static String Continue = "Continue";
   
   /**
   @since 2003.1.1
   @param status
   @throws javax.xml.soap.SOAPException
   @roseuid 4005031C0171
    */
   public void setStatus(String status) throws SOAPException;
   
   /**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 4005032D026F
    */
   public boolean hasStatus() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 400503350267
    */
   public String getStatus() throws SOAPException;
}
