//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\Service.java

package org.kldp.ebmsh.message.packaging;

import javax.xml.soap.SOAPException;

/**
@author pio
@version 0.0
@since 2003.1.1
3.1.4 Service Element 
The REQUIRED Service element identifies the service that acts on the message 
and it is specified by the designer of the service. The designer of the service 
may be: 
. a standards organization, or . an individual or enterprise 
Note: In the context of an ebXML business process model, an action equates to 
the lowest possible role based activity in the Business Process [ebBPSS] 
(requesting or responding role) and a service is a set of related actions for 
an authorized role within a party. 
An example of the Service element follows: 
<eb:Service>urn:services:SupplierOrderProcessing</eb:Service> 
Note: URIs in the Service element that start with the namespace 
urn:oasis:names:tc:ebxml-msg:service are reserved for use by this 
specification. 
The Service element has a single type attribute.
 */
public interface Service extends EbxmlElement 
{
   
   /**
   @since 2003.1.1
   
   3.1.4.1 type attribute 
   If the type attribute is present, it indicates the parties sending and 
   receiving the message know, by some other means, how to interpret the content 
   of the Service element. The two parties MAY use the value of the type attribute 
   to assist in the interpretation. 
   If the type attribute is not present, the content of the Service element MUST 
   be a URI [RFC2396]. If it is not a URI then report an error with errorCode of 
   Inconsistent and severity of Error (see section 4.1.5).
   type   ݵ URI   Ѵ.
   @param type
   @throws javax.xml.soap.SOAPException
   @roseuid 4004E3070275
    */
   public void setType(String type) throws SOAPException;
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4004E54C0194
    */
   public String getType() throws SOAPException;
}
