//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\StatusResponse.java

package org.kldp.ebmsh.message.packaging;

import javax.xml.soap.SOAPException;

/**
@author pio
@version 0.0
@since 2003.1.1
7.3 StatusResponse Element 
The OPTIONAL StatusResponse element is an immediate child of a SOAP Body and is 
used by one MSH to describe the status of processing of a message. 
The StatusResponse element consists of the following elements and attributes: 
. an id attribute (see section 2.3.7 for details) 
. a version attribute (see section 2.3.8 for details) 
. a RefToMessageId element 
. a Timestamp element 
. a messageStatus attribute

7.3.4 StatusResponse Sample 
An example of the StatusResponse element is given below: 
<eb:StatusResponse eb:version="2.0" eb:messageStatus="Received"> 
<eb:RefToMessageId>323210:e52151ec74:-7ffc@xtacy</eb:RefToMessageId> 
<eb:Timestamp>2001-03-09T12:22:30</eb:Timestamp> 
</eb:StatusResponse>
 */
public interface StatusResponse extends EbxmlBodyElement 
{
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.RefToMessageId
   @throws javax.xml.soap.SOAPException
   @roseuid 40053440038C
    */
   public RefToMessageId addRefToMessageId() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.RefToMessageId
   @throws javax.xml.soap.SOAPException
   @roseuid 4005345B020F
    */
   public RefToMessageId getRefToMessageId() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Timestamp
   @throws javax.xml.soap.SOAPException
   @roseuid 400534640121
    */
   public Timestamp addTimestamp() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Timestamp
   @throws javax.xml.soap.SOAPException
   @roseuid 4005347501F8
    */
   public Timestamp getTimestamp() throws SOAPException;
   
   /**
   @since 2003.1.1
   @param mesageStatus
   @throws javax.xml.soap.SOAPException
   @roseuid 400534820297
    */
   public void setMessageStatus(String mesageStatus) throws SOAPException;
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4005348D03C9
    */
   public String getMessageStatus() throws SOAPException;
}
