//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\SyncReply.java

package org.kldp.ebmsh.message.packaging;

import javax.xml.soap.SOAPException;

/**
@author pio
@version 0.0
@since 2003.1.1

4.3.1 SyncReply Element 
The SyncReply element MAY be present as a direct child descendant of the SOAP 
Header element. It consists of: 
. an id attribute (see section 2.3.7 for details) 
. a version attribute (see section 2.3.8 for details) 
. a SOAP actor attribute with the REQUIRED value of 
"http://schemas.xmlsoap.org/soap/actor/next" 
. a SOAP mustUnderstand attribute with a value of "1" (see section 2.3.9 for 
details) 
If present, this element indicates to the receiving SOAP or ebXML MSH node the 
connection over which the message was received SHOULD be kept open in 
expectation of a response message to be returned via the same connection. This 
element MUST NOT be used to override the value of syncReplyMode in the CPA. If 
the value of syncReplyMode is none and a SyncReply element is present, the 
Receiving MSH should issue an error with errorCode of Inconsistent and a 
severity of Error (see section 4.1.5). 
An example of a SyncReply element: 
<eb:SyncReply eb:id="3833kkj9" eb:version="2.0" SOAP:mustUnderstand="1" 
SOAP:actor="http://schemas.xmlsoap.org/soap/actor/next"/>

6.4.7 syncReplyMode 
The syncReplyMode parameter from the CPA is used only if the data 
communications protocol is synchronous (e.g. HTTP). If the communications 
protocol is not synchronous, then the value of syncReplyMode is ignored. If the 
syncReplyMode attribute is not present, it is semantically equivalent to its 
presence with a value of none. If the syncReplyMode parameter is not none, a 
SyncReply element MUST be present and the MSH must return any response from the 
application or business process in the payload of the synchronous reply 
message, as specified in the CPA. Valid values of syncReplyMode are 
mshSignalsOnly, signalsOnly, signalsAndRespose, responseOnly, and none. 
See also the description of syncReplyMode in the CPPA [ebCPP] specification
 */
public interface SyncReply extends EbxmlHeaderElement 
{
   
   /**
   @since 2003.1.1
    */
   public String mshSignalsOnly = "mshSignalsOnly";
   
   /**
   @since 2003.1.1
    */
   public String none = "none";
   
   /**
   @since 2003.1.1
    */
   public String responseOnly = "responseOnly";
   
   /**
   @since 2003.1.1
    */
   public String signalsAndRespose = "signalsAndRespose";
   
   /**
   @since 2003.1.1
    */
   public String signalsOnly = "signalsOnly";
   
   /**
   @since 2003.1.1
   6.4.7 syncReplyMode 
   The syncReplyMode parameter from the CPA is used only if the data 
   communications protocol is synchronous (e.g. HTTP). If the communications 
   protocol is not synchronous, then the value of syncReplyMode is ignored. If the 
   syncReplyMode attribute is not present, it is semantically equivalent to its 
   presence with a value of none. If the syncReplyMode parameter is not none, a 
   SyncReply element MUST be present and the MSH must return any response from the 
   application or business process in the payload of the synchronous reply 
   message, as specified in the CPA. Valid values of syncReplyMode are 
   mshSignalsOnly, signalsOnly, signalsAndRespose, responseOnly, and none. See 
   also the description of syncReplyMode in the CPPA [ebCPP] specification
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4004FDE60321
    */
   public String setMode() throws SOAPException;
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4004FDF20292
    */
   public String getMode() throws SOAPException;
}
