//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\AckRequestedImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeaderElement;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.AckRequested;
import org.kldp.util.log.LogUtil;



/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class AckRequestedImpl extends EbxmlHeaderElementImpl implements AckRequested 
{

	private static Log log = LogFactory.getLog(AckRequestedImpl.class); 
   
   /**
   @since 2003.1.1
   @roseuid 4006740703C8
    */
   public AckRequestedImpl() 
   {
    
   }
   
   /**
   @since 2003.1.1
   @param env
   @param soapHeaderElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FDB50142
    */
   public AckRequestedImpl(SOAPEnvelope env, SOAPHeaderElement soapHeaderElement) throws SOAPException 
   {
    super(env,soapHeaderElement);
    this.setId("AckRequested");
   }
   
   /**
   @since 2003.1.1
   @param sign
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FDD201BC
    */
   public void setSigned(boolean sign) throws SOAPException 
   {
   	
    this.setEbxmlAttribute( "signed",new Boolean(sign).toString());
   }
   
   /**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FDD20271
    */
   public boolean getSigned() throws SOAPException 
   {

  
 	String signed  = this.getEbxmlAttribute("signed");
 	if(signed !=  null)
    {
		return Boolean.valueOf(signed).booleanValue();
    }else return false;
    	 
    
   }
   /* Section: Append more methods to fill fully Ebxml functions
	   * @Date: 2004-Sep-15 
	   * @author QuangHung
	   */
	//serve Soap:actor attribute in AckRequested 
	public void setActor(String urn)
	{
	//	if((urn.trim().equals("urn:oasis:names:tc:ebxml-msg:actor:nextMSH")) ||
	//	(urn.trim().equals("urn:oasis:names:tc:ebxml-msg:actor:toPartyMSH"))){
		
			try{
				this.setSoapAttribute ( "actor",urn);	
			}catch(SOAPException e){
					log.fatal( LogUtil.stackTraceToString(e));
			}
	//	}
	}
   
	public String getActor()
	{
		String actor = null;
		try{
			actor = this.getEbxmlAttribute("actor");	
		}catch(SOAPException e){
			
		}
		finally{
			return actor;  	
		}
	}
   
   
	//moved from EbxmlHeaderElement
	/**
	 ebxml version soapheader ߰Ҷ  version=2.0
	 @since 2003.1.1
	 @param version
	 @throws javax.xml.soap.SOAPException
	 @roseuid 3FFF61A90117
	 */
	public void setVersion(String version) throws SOAPException
	{
		this.setEbxmlAttribute( "version",version);
	}
   
	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @throws javax.xml.soap.SOAPException
	 @roseuid 3FFF625603B5
	 */
	public String getVersion() throws SOAPException
	{
		return this.getEbxmlAttribute("eb:version");
	}
	/*
	 * End of Section
	 */

}
