//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\AcknowledgmentMessage.java




package org.kldp.ebmsh.message.packaging.impl;


/**
@author pio
@version 0.0
@since 2003.1.1
 */
/*
 * 
 * @author pio1
 *

 * 6.5.3 Generating an Acknowledgment Message 1688
An Acknowledgment Message MUST be generated whenever a message is received with an 1689
AckRequested element having a SOAP actor URI targeting the Receiving MSH node. 1690
As a minimum, it MUST contain an Acknowledgment element with a RefToMessageId containing the 1691
same value as the MessageId element in the message being acknowledged. This message MUST be 1692
placed in persistent storage with the same PersistDuration as the original message. 1693
The Acknowledgment Message can be sent at the same time as the response to the received message. 1694
In this case, the values for the MessageHeader elements of the Acknowledgment Message are 1695
determined by the Service and Action associated with the business response. 1696
If an Acknowledgment Message is being sent on its own, then the value of the MessageHeader elements 1697
MUST be set as follows: 1698
? The Service element MUST be set to: urn:oasis:names:tc:ebxml-msg:service 
? The Action element MUST be set to Acknowledgment. 
? The From element MAY be populated with the To element extracted from the message received and all 
child elements from the To element received SHOULD be included in this From element. 
? The To element MAY be populated with the From element extracted from the message received and all 
child elements from the From element received SHOULD be included in this To element. 
? The RefToMessageId element MUST be set to the MessageId of the message received.

10.1.2 Acknowledgment Sample 2093
An example of the Acknowledgment element targeted at the NextMSH is given below:
<eb:Acknowledgment SOAP:mustUnderstand="1" eb:version="2.0" 
SOAP:actor="urn:oasis:names:tc:ebxml-msg:actor:nextMSH"> 
<eb:Timestamp>2001-03-09T12:22:30</eb:Timestamp> 
<eb:RefToMessageId>323210:e52151ec74:-7ffc@xtacy</eb:RefToMessageId> 
<eb:From> <eb:PartyId>uri:www.example.com</eb:PartyId> </eb:From> 
</eb:Acknowledgment>

 */

import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.Acknowledgment;
import org.kldp.ebmsh.message.packaging.EbxmlHeader;
import org.kldp.ebmsh.message.packaging.EbxmlMessageFactory;
import org.kldp.ebmsh.message.packaging.From;
import org.kldp.ebmsh.message.packaging.RefToMessageId;
import org.kldp.ebmsh.message.packaging.Timestamp;
import org.kldp.util.log.LogUtil;


public class AcknowledgmentMessage extends EbxmlMessageImpl 
{


	private static Log log = LogFactory.getLog(AcknowledgmentMessage.class); 

	/**
   @since 2003.1.1
   @roseuid 401491F601E8
	 */
	public AcknowledgmentMessage(SOAPMessage message,EbxmlMessageFactory factory) throws SOAPException 
	{

		super(message,factory);


	}

	public  void setAcknowledgment(String refToMessageId, String from, String timestamp) throws SOAPException 
	{
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			Acknowledgment ack = ebh.addAcknowledgment();
//			ack.setActor(EbxmlConstants.partyMsh);	
			Timestamp time  = ack.addTimestamp() ;
			time.setValue(timestamp);
			RefToMessageId ref = ack.addRefToMesssagId() ;
			ref.setValue(refToMessageId);
			From fr = ack.addFrom() ;

			//Section: QuangHung add Sep-22-2004
			PartyIdImpl partyId = (PartyIdImpl) fr.addPartyId();
			partyId.setType("urn:oasis:names:tc:ebxml-cppa:partyid-type:duns");
			partyId.setValue(from);
			//Section: End

			//fr.ad

			ebh.getMessageHeader().getMessageData().addRefToMessageId().setValue(refToMessageId);

		}catch(SOAPException e)
		{

			log.fatal( LogUtil.stackTraceToString(e)) ;
		}




	}

	public Acknowledgment getAcknowledgment() throws SOAPException
	{

		EbxmlHeader ebh = this.getEbxmlHeader() ;
		return ebh.getAcknowledgment() ;

	}




}
