//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\DescriptionImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.Description;
import org.kldp.ebmsh.message.packaging.EbxmlConstants;
import org.kldp.util.log.LogUtil;

/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class DescriptionImpl extends EbxmlElementImpl implements Description 
{
   
   private static Log log = LogFactory.getLog(DescriptionImpl.class);
   /**
   @since 2003.1.1
   @roseuid 4003549F021F
    */
   public DescriptionImpl() 
   {
    
   }
   
   /**
   @since 2003.1.1
   @param env
   @param soapElement
   @throws javax.xml.soap.SOAPException
   @roseuid 400201DC0192
    */
   public DescriptionImpl(SOAPEnvelope env, SOAPElement soapElement) throws SOAPException 
   {
    super(env,soapElement);
   }
   
   /**
   @since 2003.1.1
   @param lang
   @throws javax.xml.soap.SOAPException
   @roseuid 400202060355
    */
   public void setLang(String lang) throws SOAPException 
   {
   	try{
   	
   	Name name = env.createName( "lang","xml",EbxmlConstants.msgHeaderName);
   	
    addAttribute(name,EbxmlConstants.enUs);
   	}catch(SOAPException e)
   	{
   			log.fatal( LogUtil.stackTraceToString(e)) ;
   		
   	}
    
   }
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @roseuid 400202070053
    */
   public String getLang() 
   {
	String lang =null;
	try{
	
    	lang = getEbxmlAttribute("lang");
	}catch(SOAPException e)
	{
			log.fatal( LogUtil.stackTraceToString(e)) ;	
	}
	
	return lang;
   }
}
