//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\EbxmlBodyImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import javax.xml.soap.Name;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPBodyElement;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPFault;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.EbxmlBody;
import org.kldp.ebmsh.message.packaging.EbxmlConstants;
import org.kldp.ebmsh.message.packaging.Manifest;
import org.kldp.ebmsh.message.packaging.StatusRequest;
import org.kldp.ebmsh.message.packaging.StatusResponse;




/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class EbxmlBodyImpl extends EbxmlElementImpl implements EbxmlBody 
{

	/**
   @since 2003.1.1
	 */
	private SOAPBody soapBody;
	private static Log log = LogFactory.getLog( EbxmlBodyImpl.class);	

	/**
   @since 2003.1.1
   @roseuid 4007755602FB
	 */
	public EbxmlBodyImpl() 
	{

	}

	/**
   @since 2003.1.1
   @param env
   @param soapBody
   @throws javax.xml.soap.SOAPException
   @roseuid 40060F8E02AB
	 */
	public EbxmlBodyImpl(SOAPEnvelope env, SOAPBody soapBody) throws SOAPException 
	{
		super(env,soapBody);
		this.soapBody = soapBody;

	}

	/**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Manifest
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126B03D1
	 */
	public Manifest addManifest() throws SOAPException 
	{

		Name bodyName = env.createName("Manifest",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);

		SOAPBodyElement sb = this.soapBody.addBodyElement(bodyName);





		ManifestImpl manifest = new  ManifestImpl(env,sb);
		manifest.setVersion("2.0");


		return manifest;
	}

	/**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Manifest
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126C00D0
	 */
	public Manifest getManifest() throws SOAPException 
	{
		SOAPElement se = this.getFirstChildElement("Manifest");
		return new ManifestImpl(env,(SOAPBodyElement)se);

	}

	/**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126C01D4
	 */
	public boolean hasManifest() throws SOAPException 
	{
		if(this.hasElement("Manifest"))
		{
			return true;
		}else return false;
	}

	/**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.StatusRequest
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126C02A6
	 */
	public StatusRequest addStautsRequest() throws SOAPException 
	{


		Name bodyName = env.createName("StatusRequest",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);

		SOAPBodyElement sb = this.soapBody.addBodyElement(bodyName);







		StatusRequestImpl statusrequest = new  StatusRequestImpl(env,sb);
		statusrequest.setVersion("2.0");

		return statusrequest;

	}

	/**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.StatusRequest
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126C0365
	 */
	public StatusRequest getStatusRequest() throws SOAPException 
	{
		SOAPElement se = this.getFirstChildElement("StatusRequest");
		return new StatusRequestImpl(env,(SOAPBodyElement)se);

	}

	/**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126D0031
	 */
	public boolean hasStatusRequest() throws SOAPException 
	{
		if(this.hasElement("StatusRequest"))
		{
			return true;
		}else return false;
	}

	/**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.StatusResponse
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126D00EF
	 */
	public StatusResponse addStatusResponse() throws SOAPException 
	{


		Name bodyName = env.createName("StatusResponse",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);

		SOAPBodyElement sb = this.soapBody.addBodyElement(bodyName);





		StatusResponseImpl statusreponse = new  StatusResponseImpl(env,sb);
		statusreponse.setVersion("2.0");
		return statusreponse;
	}

	/**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.StatusResponse
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126D01E9
	 */
	public StatusResponse getStatusResponse() throws SOAPException 
	{
		SOAPElement se = this.getFirstChildElement("StatusResponse");
		return new StatusResponseImpl(env,(SOAPBodyElement)se);
	}

	/**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126D02A8
	 */
	public boolean hasStatusResponse() throws SOAPException 
	{
		if(this.hasElement("StatusRequest"))
		{
			return true;
		}else return false;
	}

	/**
   @since 2003.1.1
   @return javax.xml.soap.SOAPFault
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126D0398
	 */
	public SOAPFault addFault() throws SOAPException 
	{
		return soapBody.addFault();
	}

	/**
   @since 2003.1.1
   @return boolean
   @roseuid 4006126E0050
	 */
	public boolean hasFault() 
	{
		return soapBody.hasFault();
	}

	/**
   @since 2003.1.1
   @return javax.xml.soap.SOAPFault
   @roseuid 4006126E010F
	 */
	public SOAPFault getFault() 
	{
		return soapBody.getFault();
	}

	/**
   @since 2003.1.1
   @param arg0
   @return javax.xml.soap.SOAPBodyElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4006126E0209
	 */
	public SOAPBodyElement addBodyElement(Name arg0) throws SOAPException 
	{
		return soapBody.addBodyElement(arg0);
	}
}
