//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\EbxmlElementImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import java.util.Iterator;

import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.Text;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.EbxmlConstants;
import org.kldp.ebmsh.message.packaging.EbxmlElement;


/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class EbxmlElementImpl implements EbxmlElement 
{
   
   /**
   NameSpace  SoapEnvelope ʿϴ.
   @since 2003.1.1
	*/
   protected SOAPEnvelope env = null;
   private static Log log = LogFactory.getLog( EbxmlElementImpl.class);	
	  
   /**
   @since 2003.1.1
	*/
   protected SOAPElement soapElement;
   
   /**
   @since 2003.1.1
   @roseuid 4000B19101CC
	*/
   public EbxmlElementImpl() 
   {
    
   }
   
   /**
    Ѱܹ SOAPEnvelope ,SOAPElement class  Ҵ Ѵ.
   this.env = env ; this.soapElement = soapElement
   @since 2003.1.1
   @param env
   @param soapElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0C5025F
	*/
   public EbxmlElementImpl(SOAPEnvelope env, SOAPElement soapElement) throws SOAPException 
   {
	this.env  = env;
	this.soapElement = soapElement;
   }
   
   /**
   text ִٸ װ  text Ѵ.
   Iterator it = getChildElements();
   while( it.hasNext()){
   Text text = (Text)it.next();
   text.detachNode();
   }
   ׸ Text ߰Ѵ. addTextNode(value)
   @since 2003.1.1
   @param value
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D30273
	*/
   public void setValue(String value) throws SOAPException 
   {
	
	Iterator it = getChildElements();
	while( it.hasNext()){
	Text text = (Text)it.next();
	text.detachNode();
	}
	if(soapElement == null)
	{
		log.info("soap Element is null");
	}
   	
	soapElement.addTextNode(value);
   }
   
   /**
   @since 2003.1.1
   @param name
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D30331
	*/
   public SOAPElement addChildElement(Name name) throws SOAPException 
   {
	return soapElement.addChildElement(name);
   }
   
   /**
   @since 2003.1.1
   @param localName
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D3038B
	*/
   public SOAPElement addChildElement(String localName) throws SOAPException 
   {
	return soapElement.addChildElement(localName);
   }
   
   /**
   @since 2003.1.1
   @param localName
   @param prefix
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D303E5
	*/
   public SOAPElement addChildElement(String localName, String prefix) throws SOAPException 
   {
	return soapElement.addChildElement(localName,prefix);
   }
   
   /**
   @since 2003.1.1
   @param localName
   @param prefix
   @param uri
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D400A8
	*/
   public SOAPElement addChildElement(String localName, String prefix, String uri) throws SOAPException 
   {
	   return soapElement.addChildElement(localName,prefix,uri);
   }
   
   /**
   @since 2003.1.1
   @param element
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D40184
	*/
   public SOAPElement addChildElement(SOAPElement element) throws SOAPException 
   {
	return soapElement.addChildElement(element);
   }
   
   /**
   @since 2003.1.1
   @param text
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D401DE
	*/
   public SOAPElement addTextNode(String text) throws SOAPException 
   {
	return soapElement.addTextNode( text);
   }
   
   /**
   @since 2003.1.1
   @param name
   @param arg1
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D4024C
	*/
   public SOAPElement addAttribute(Name name, String arg1) throws SOAPException 
   {
	return soapElement.addAttribute(name,arg1);
   }
   
   /**
   @since 2003.1.1
   @param prefix
   @param uri
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D402E3
	*/
   public SOAPElement addNamespaceDeclaration(String prefix, String uri) throws SOAPException 
   {
	return soapElement.addNamespaceDeclaration( prefix,uri);
   }
   
   /**
   @since 2003.1.1
   @param name
   @return java.lang.String
   @roseuid 4000B0D40383
	*/
   public String getAttributeValue(Name name) 
   {
	return soapElement.getAttributeValue(name);
   }
   
   /**
   @since 2003.1.1
   @return java.util.Iterator
   @roseuid 4000B0D403E7
	*/
   public Iterator getAllAttributes() 
   {
	return soapElement.getAllAttributes();
   }
   
   /**
   @since 2003.1.1
   @param arg0
   @return java.lang.String
   @roseuid 4000B0D50045
	*/
   public String getNamespaceURI(String arg0) 
   {
	return soapElement.getNamespaceURI(arg0);
   }
   
   /**
   @since 2003.1.1
   @return java.util.Iterator
   @roseuid 4000B0D500A9
	*/
   public Iterator getNamespacePrefixes() 
   {
	return soapElement.getNamespacePrefixes();
   }
   
   /**
   @since 2003.1.1
   @return javax.xml.soap.Name
   @roseuid 4000B0D500E5
	*/
   public Name getElementName() 
   {
	return soapElement.getElementName();
   }
   
   /**
   @since 2003.1.1
   @param name
   @return boolean
   @roseuid 4000B0D50117
	*/
   public boolean removeAttribute(Name name) 
   {
	return soapElement.removeAttribute( name);
   }
   
   /**
   @since 2003.1.1
   @param prefix
   @return boolean
   @roseuid 4000B0D5017B
	*/
   public boolean removeNamespaceDeclaration(String prefix) 
   {
	return soapElement.removeNamespaceDeclaration(prefix);
   }
   
   /**
   @since 2003.1.1
   @return java.util.Iterator
   @roseuid 4000B0D50208
	*/
   public Iterator getChildElements() 
   {
	if(soapElement == null)
	{
		log.info("soapElement is null");
	}
	
	return soapElement.getChildElements();
   }
   
   /**
   @since 2003.1.1
   @param name
   @return java.util.Iterator
   @roseuid 4000B0D50230
	*/
   public Iterator getChildElements(Name name) 
   {
	return soapElement.getChildElements(name);
   }
   
   /* get child element with given name */
   public Iterator getChildElements(String localName) throws SOAPException 
   {
   	
	Name name = env.createName( 
	localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
	Iterator i = getChildElements(name);//getAllAttributes();
	return i;
   }
   
   /**
   @since 2003.1.1
   @param encodingStyle
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D5029E
	*/
   public void setEncodingStyle(String encodingStyle) throws SOAPException 
   {
	soapElement.setEncodingStyle(encodingStyle);
   }
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @roseuid 4000B0D5030C
	*/
   public String getEncodingStyle() 
   {
	return soapElement.getEncodingStyle();
   }
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @roseuid 4000B0D50348
	*/
   public String getValue() 
   {
	return soapElement.getValue() ;
   }
   
   /**
   @since 2003.1.1
   @param element
   @throws javax.xml.soap.SOAPException
   @roseuid 4000B0D50370
	*/
   public void setParentElement(SOAPElement element) throws SOAPException 
   {
	soapElement.setParentElement( element);
   }
   
   /**
   @since 2003.1.1
   @return javax.xml.soap.SOAPElement
   @roseuid 4000B0D503DE
	*/
   public SOAPElement getParentElement() 
   {
	return soapElement.getParentElement() ;
   }
   
   /**
   @since 2003.1.1
   @roseuid 4000B0D60028
	*/
   public void detachNode() 
   {
	soapElement.detachNode() ;
   }
   
   /**
   @since 2003.1.1
   @roseuid 4000B0D6006E
	*/
   public void recycleNode() 
   {
	soapElement.recycleNode() ;
   }
   
   /**
   ebxml prefix eb header name space ϴ Element .
   addChildElement( 
   localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
   @since 2003.1.1
   @param localName
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000D1530136
	*/
   public SOAPElement addEbxmlChildElement(String localName) throws SOAPException 
   {
	return addChildElement(localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
   }
   
   /**
     Element ִ üũϰ ߰Ѵ.
   checkDuplicateElement(localName);
   addChildElement(localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
   @since 2003.1.1
   @param localName
   @return SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4000D302032B
	*/
   public SOAPElement addUniqueEbxmlChildElement(String localName) throws SOAPException 
   {
   
		checkDuplicateElement(localName);
	  return addChildElement(localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
   }
   
   /**
   hasElement() ؼ Ʈ ϴ ˾ƺ  EbxmlException 
   ߻Ų.
   if(hasElement(localName))
   throw new EbxmlException("Element already Exists. ̹ Ʈ մϴ. 
   :" + localName);
   @since 2003.1.1
   @param localName
   @throws javax.xml.soap.SOAPException
   @roseuid 4000D42200EA
	*/
   public void checkDuplicateElement(String localName) throws SOAPException 
   {
	 if(hasElement(localName))
		throw new  SOAPException("Element already Exists. ̹ Ʈ մϴ." + localName);
     
   }
   
   /**
   Iterator i = getChildElements();
   SOAPElement element = null;
   while( i.hasNext())
   {
   element = (SOAPElement)i.next();
   if( element.getElementName().getLocalName().equals(localName))
   {
   return true;
   }else return false;
   @since 2003.1.1
   @param localName
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 4000D56E00F1
	*/
   
   
   public boolean hasElement(String localName) throws SOAPException 
   {
		Iterator i = getChildElements();
		SOAPElement element = null;
		
		while( i.hasNext())
		{
		 Object o  =i.next();
		 
		 if( o instanceof com.sun.xml.messaging.saaj.soap.dom4j.TextImpl)
		 {
			com.sun.xml.messaging.saaj.soap.dom4j.TextImpl text = (com.sun.xml.messaging.saaj.soap.dom4j.TextImpl)o;
			
		 }
		 
		 //Section: QuangHung add Sep-17-2004
		 if(o instanceof SOAPElement){
			element = (SOAPElement)o;
		
			if( element.getElementName().getLocalName().equals(localName))
			 {
				 return true;
			 }
		 }
		 //Section: End
		}
		
		return false;    
   }
   
   /**
     ̸ ϴ attribute  ߰Ѵ.
   removeAttribute(name);
   addAttribute(name,value);
   @since 2003.1.1
   @param name
   @param value
   @throws javax.xml.soap.SOAPException
   @roseuid 4000D8130203
	*/
   public void setEbxmlAttribute(Name name, String value) throws SOAPException 
   {
	removeAttribute(name);
	addAttribute(name,value);
   }
   
   /**
   ̸   ְ setEbxmlAttribute(Name ,..)  attribute ߰Ѵ.
   Name name =  
   env.createName(localName,EbxmlConstants.prefixEb,EbxmlContants.msgHeader.Name);
   setEbxmlAttribute(name,value);
   @since 2003.1.1
   @param localName
   @param value
   @throws javax.xml.soap.SOAPException
   @roseuid 4000D8E00262
	*/
   public void setEbxmlAttribute(String localName, String value) throws SOAPException 
   {
	//Name name =  
	 // env.createName(localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
	  //setEbxmlAttribute(name,value);
    
	Name name
			= (env.createName
			   (localName, "eb",
			"http://www.oasis-open.org/committees/ebxml-msg/schema/msg-header-2_0.xsd"));
		setEbxmlAttribute(name, value);
   }
  
   public void setSoapAttribute(String localName, String value) throws SOAPException 
	 {
	  //Name name =  
	   // env.createName(localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
		//setEbxmlAttribute(name,value);
    
	  Name name
			  = (env.createName
				 (localName, "soap-env",
			  "http://schemas.xmlsoap.org/soap/envelope/"));
		  setEbxmlAttribute(name, value);
	 }
   
   /**
   getAttribute(Name) ؼ attribute ´.
   Name name = env.createName( 
   localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
   getAttribute(name);
   @since 2003.1.1
   @param localName
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4000DA160204
	*/
   public String getEbxmlAttribute(String localName) throws SOAPException 
   {
	Name name = env.createName( 
	localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
	return getAttributeValue(name);

   }
   
   /**
   Ｎ  ó ڽ element  ´.
   @since 2003.1.1
   @param localName
   @return javax.xml.soap.SOAPElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4001FFC2038D
	*/
   public SOAPElement getFirstChildElement(String localName) throws SOAPException 
   {
	Name name = env.createName( 
	localName,EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
	Iterator i = getChildElements(name);//getAllAttributes();
	SOAPElement soap =null;
	if(i != null)
		if(i.hasNext())
		{
			soap = (SOAPElement)i.next();
		}
	return soap;
   }
}
