//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\EbxmlHeaderElementImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import javax.xml.soap.Name;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeaderElement;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.EbxmlConstants;
import org.kldp.ebmsh.message.packaging.EbxmlHeaderElement;
import org.kldp.util.log.LogUtil;



/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class EbxmlHeaderElementImpl extends EbxmlElementImpl implements EbxmlHeaderElement 
{
   
   /**
   @since 2003.1.1
    */
   protected SOAPHeaderElement soapHeaderElement = null;
   private static Log log = LogFactory.getLog(EbxmlHeaderElementImpl.class);
   /**
   @since 2003.1.1
   @roseuid 4001F0240334
    */
   public EbxmlHeaderElementImpl() 
   {
    
   }
   
   /**
   SOAPHeader Ȯ   ü SOAPHeader  鼭 ⿡ 
   ߰ϴ ϵ Ѵ.
   @since 2003.1.1
   @param env
   @param soapHeaderElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4001EE6D0224
    */
   public EbxmlHeaderElementImpl(SOAPEnvelope env, SOAPHeaderElement soapHeaderElement) throws SOAPException 
   {
    super(env,soapHeaderElement);
    this.soapHeaderElement = soapHeaderElement;
   }
   
   /**
   @since 2003.1.1
   @param version
   @throws javax.xml.soap.SOAPException
   @roseuid 4001EE9B0270
    */
   public void setVersion(String version) throws SOAPException 
   {
	Name name = env.createName( 
		"version",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
		
    soapHeaderElement.addAttribute(name,"2.0" );
   }
   
   /**
	 @since 2003.1.1
	 @param version
	 @throws javax.xml.soap.SOAPException
	 @roseuid 4001EE9B0270
	  */
	 public void setId(String id) throws SOAPException 
	 {
	  Name name = env.createName( 
		  "id",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
		
	  soapHeaderElement.addAttribute(name,id );
	 }
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4001EE9B02DF
    */
   public String getVersion() throws SOAPException 
   {
	Name name = env.createName( 
			"version",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
   	return soapHeaderElement.getAttributeValue(name);
   
   }
   /**
	 @since 2003.1.1
	 @return java.lang.String
	 @throws javax.xml.soap.SOAPException
	 @roseuid 4001EE9B02DF
	  */
	 public String getId() throws SOAPException 
	 {
	  Name name = env.createName( 
			  "id",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
	  return soapHeaderElement.getAttributeValue(name);
   
	 }
   
   /**
   Sets the actor associated with this SOAPHeaderElement object to the specified 
   actor. 
   @since 2003.1.1
   @param actorUri
   @roseuid 4001EE9B0375
    */
   public void setActor(String actorUri) 
   {
   	soapHeaderElement.setActor(actorUri); 
   }
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @roseuid 4001EE9B03E3
    */
   public String getActor() 
   {
	return soapHeaderElement.getActor();
   }
   
   /**
   @since 2003.1.1
   @param mustUnderstand
   @roseuid 4001EE9C0037
    */
   public void setMustUnderstand(boolean mustUnderstand) 
   {
	//soapHeaderElement.setMustUnderstand(mustUnderstand);
	//TODO we are suffuring from the  duplicated namespaces like "soap-env","SOAP","soap"
	//for the test (actually korbit) ..we want fix the namespace to "soap-env"
	
	try{
	
	Name name
				 = env.createName("mustUnderstand", "soap-env",
				 "http://schemas.xmlsoap.org/soap/envelope/");
				 
	//soapHeaderElement.addAttribute(name,"1");
	this.setEbxmlAttribute(name,"1");
	}catch(SOAPException e)
	{
		log.fatal( LogUtil.stackTraceToString(e)) ;	
	}
	
   }
   
   /**
   @since 2003.1.1
   @return boolean
   @roseuid 4001EE9C00B9
    */
   public boolean getMustUnderstand() 
   {
	return soapHeaderElement.getMustUnderstand() ;
   
   }
}
