//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\EbxmlHeaderImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import java.util.Iterator;

import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPHeaderElement;

import org.kldp.ebmsh.message.packaging.AckRequested;
import org.kldp.ebmsh.message.packaging.Acknowledgment;
import org.kldp.ebmsh.message.packaging.Action;
import org.kldp.ebmsh.message.packaging.CPAId;
import org.kldp.ebmsh.message.packaging.ConversationId;
import org.kldp.ebmsh.message.packaging.EbxmlConstants;
import org.kldp.ebmsh.message.packaging.EbxmlHeader;
import org.kldp.ebmsh.message.packaging.ErrorList;
import org.kldp.ebmsh.message.packaging.From;
import org.kldp.ebmsh.message.packaging.MessageData;
import org.kldp.ebmsh.message.packaging.MessageHeader;
import org.kldp.ebmsh.message.packaging.MessageOrder;
import org.kldp.ebmsh.message.packaging.Service;
import org.kldp.ebmsh.message.packaging.SyncReply;
import org.kldp.ebmsh.message.packaging.To;


/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class EbxmlHeaderImpl extends EbxmlElementImpl implements EbxmlHeader 
{
   
   /**
   @since 2003.1.1
    */
   protected SOAPHeader soapHeader = null;
   
   /**
   @since 2003.1.1
   @roseuid 4001FBFF01C5
    */
   public EbxmlHeaderImpl() 
   {
    
   }
   
   /**
   @since 2003.1.1
   @param env
   @param soapHeader
   @throws javax.xml.soap.SOAPException
   @roseuid 4001FB310147
    */
   public EbxmlHeaderImpl(SOAPEnvelope env, SOAPHeader soapHeader) throws SOAPException 
   {
    super(env,soapHeader);
    this.soapHeader = soapHeader;
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.MessageHeader
   @throws javax.xml.soap.SOAPException
   @roseuid 400B63B20128
   MessageHeader 鶧 from,to,cpaId,ConversationId,Service,Action,MessageData  Ѿ Ѵ.
	*/
   public MessageHeader addMessageHeader() throws SOAPException 
   {
	
	 Name hdrName = env.createName("MessageHeader",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
		
	 SOAPHeaderElement she = soapHeader.addHeaderElement(hdrName);
	
	 MessageHeaderImpl messageHeader = new MessageHeaderImpl(env, she);
	
	 messageHeader.setVersion("2.0");
	 messageHeader.setMustUnderstand(true);
	 From from
		 = messageHeader.addFrom();
	 To to = messageHeader.addTo();
	 CPAId cpaId
		 = messageHeader.addCPAId();
	 ConversationId conversationId
		 = messageHeader.addConversationId();
	 Service service
		 = messageHeader.addService();
	 Action action
		 = messageHeader.addAction();
	 MessageData messageData
		 = messageHeader.addMessageData();
	 return messageHeader;
	 
	 
   }
   
   
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.MessageHeader
   @throws javax.xml.soap.SOAPException
   @roseuid 400B63C70236
	*/
   public MessageHeader getMessageHeader() throws SOAPException 
   {
	SOAPElement soe =  this.getFirstChildElement( "MessageHeader");
	return new MessageHeaderImpl(env,(SOAPHeaderElement)soe);
   }
   
   
   /**
   @since 2003.1.1
   @return boolean
   @roseuid 400B8976033D
	*/
   public boolean hasMessageHeader() throws SOAPException
   {
	if(this.hasElement("MessageHeader"))
	{
		return true;
	}else return false;
   }

   /**
   @since 2003.1.1
   @return ErrorList
   @throws javax.xml.soap.SOAPException
   @roseuid 4001FB43026F
    */
   public ErrorList addErrorList() throws SOAPException 
   {
   	

	Name hdrName = env.createName("ErrorList",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
		
	SOAPHeaderElement she = soapHeader.addHeaderElement(hdrName);
	
	
	

   	ErrorListImpl errList = new ErrorListImpl(env,she);
   	errList.setVersion("2.0");
   	errList.setMustUnderstand( true);
    return errList;
   }
   
   /**
   @since 2003.1.1
   @return ErrorList
   @throws javax.xml.soap.SOAPException
   @roseuid 4001FB43028D
    */
   public ErrorList getErrorList() throws SOAPException 
   {
   	
	   SOAPElement se = this.getFirstChildElement("ErrorList");
	   return new ErrorListImpl(env,(SOAPHeaderElement)se);
   }
   /**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.SyncReply
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C60256
	  */
   public SyncReply addSyncReply() throws SOAPException 
   {
	   
	   
	   Name hdrName = env.createName("SyncReply",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
	   
	   SOAPHeaderElement she = soapHeader.addHeaderElement(hdrName);
	   
	   
	   
	   
	   
	   
	   SyncReplyImpl sync = new SyncReplyImpl(env,she);
	   java.util.Random r = new java.util.Random();
	   
	   
	   sync.setId( String.valueOf(r.nextLong()));
	   sync.setVersion("2.0");
	   sync.setMustUnderstand(true);
	   sync.setActor(EbxmlConstants.next);
	   
	   return sync;
   }
   
	 /**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.SyncReply
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C602D8
	  */
	 public SyncReply getSyncReply() throws SOAPException 
	 {
		SOAPElement se = this.getFirstChildElement("SyncReply");
			return new SyncReplyImpl(env,(SOAPHeaderElement)se);
	 }
   
	 /**
	 @since 2003.1.1
	 @return boolean
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C60382
	  */
	 public boolean hasSyncReply() throws SOAPException 
	 {
	 	
		return this.hasElement("SyncReply");
	 
	 }
   
	 /**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.Acknowledgment
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C7006C
	  */
	 public Acknowledgment addAcknowledgment() throws SOAPException 
	 {
		 Name hdrName = env.createName("Acknowledgment",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
		 
		 SOAPHeaderElement she = soapHeader.addHeaderElement(hdrName);
		 
		 
		 AcknowledgmentImpl ack = new AcknowledgmentImpl(env,she);
		 ack.setVersion( "2.0");
		 ack.setMustUnderstand( true);
		 return ack;
	 }
   
	 /**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.Acknowledgment
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C70094
	  */
	 public Acknowledgment getAcknowledgment() throws SOAPException 
	 {
		SOAPElement se = this.getFirstChildElement("Acknowledgment");
		return new AcknowledgmentImpl(env,(SOAPHeaderElement)se);
	 }
   
	 /**
	 @since 2003.1.1
	 @return boolean
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C7010D
	  */
	 public boolean hasAcknowledgment() throws SOAPException 
	 {
		if(this.hasElement("Acknowledgment"))
		{
			return true;
		}else return false;

	 }
	 
	 
	public boolean hasErrorList() throws SOAPException 
	{
	   if(this.hasElement("ErrorList"))
	   {
		   return true;
	   }else return false;

	}
   
	 /**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.AckRequested
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C7018F
	  */
	 public AckRequested addAckRequested() throws SOAPException 
	 {
		
		SOAPElement se = this.addUniqueEbxmlChildElement( "AckRequested");
		AckRequestedImpl ack = new AckRequestedImpl(env,(SOAPHeaderElement)se);
		ack.setVersion( "2.0");
		ack.setMustUnderstand( true);
		return ack;
	 }
   
	 /**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.AckRequested
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C70239
	  */
	 public AckRequested getAckRequested() throws SOAPException 
	 {
		 	
		
		/*
		Name hdrName = env.createName("AckRequested",EbxmlConstants.prefixEb,EbxmlConstants.msgHeaderName);
		
		SOAPHeaderElement she = soapHeader.addHeaderElement(hdrName);
	
	
		AckRequestedImpl ack = new AckRequestedImpl(env,she);

		ack.setVersion("2.0");
		ack.setMustUnderstand( true);
	
		*/
		SOAPElement se = this.getFirstChildElement("AckRequested");
			return new AckRequestedImpl(env,(SOAPHeaderElement)se);
	
	
	 }
   
	 /**
	 @since 2003.1.1
	 @return boolean
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400612C7027F
	  */
	 public boolean hasAckRequested() throws SOAPException 
	 {
		if(this.hasElement("AckRequested"))
		{
			return true;
		}else return false;
	 }
	 
	
   
//	   add MessageOrder
	public MessageOrder addMessageOrder() throws SOAPException	
	{
		SOAPElement se = this.addUniqueEbxmlChildElement( "MessageOrder");
		MessageOrderImpl order = new MessageOrderImpl(env,(SOAPHeaderElement)se);
		order.setVersion( "2.0");
		order.setMustUnderstand( true);
		return order;
		
	}


	public MessageOrder getMessageOrder() throws SOAPException 
	{
		SOAPElement se = this.getFirstChildElement("MessageOrder");
		return new MessageOrderImpl(env,(SOAPHeaderElement)se);
	}
   
	public boolean hasMessageOrder() throws SOAPException
	{
		if(this.hasElement("MessageOrder"))
				{
					return true;
				}else return false;
		}
   
   
	
   /**
   @since 2003.1.1
   @param arg0
   @return javax.xml.soap.SOAPHeaderElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4001FB4302BF
    */
   public SOAPHeaderElement addHeaderElement(Name arg0) throws SOAPException 
   {
    return this.soapHeader.addHeaderElement( arg0);
   }
   
   /**
   @since 2003.1.1
   @param arg0
   @return java.util.Iterator
   @roseuid 4001FB43032E
    */
   public Iterator examineHeaderElements(String arg0) 
   {
    return soapHeader.examineHeaderElements( arg0);
   }
   
   /**
   @since 2003.1.1
   @param arg0
   @return java.util.Iterator
   @roseuid 4001FB43039C
    */
   public Iterator extractHeaderElements(String arg0) 
   {
    return soapHeader.extractHeaderElements(arg0);
   }
   
}
