//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\EbxmlMessageFactoryImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import java.io.IOException;
import java.io.InputStream;
import java.util.Date;
import java.util.Iterator;

import javax.xml.soap.MessageFactory;
import javax.xml.soap.MimeHeaders;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.EbxmlMessageFactory;
import org.kldp.util.log.LogUtil;




/**
 @author pio
 @version 0.0
 @since 2003.1.1
 */
public class EbxmlMessageFactoryImpl extends EbxmlMessageFactory 
{

	/**
	 @since 2003.1.1
	 */
	private MessageFactory factory = null;
	private static Log log = LogFactory.getLog(EbxmlMessageFactoryImpl.class);

	private void init() {
		try {
			factory =  MessageFactory.newInstance();
		}
		catch(SOAPException e) {
			log.fatal("MessageFactory   ϴ.");
		}
	}


	/**
	 @since 2003.1.1
	 @roseuid 40023E150118
	 */
	public EbxmlMessageFactoryImpl() 
	{		
		init();
	}


	/**
	 @since 2003.1.1
	 @return javax.xml.soap.SOAPMessage
	 @roseuid 400392DE022C
	 */
	public SOAPMessage createMessage() 
	{


		EbxmlMessageImpl em = null;
		try{



			SOAPMessage sm = MessageFactory.newInstance().createMessage() ;
			em = new EbxmlMessageImpl(sm,this);
		}catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}
		return (SOAPMessage)em;

	}

	/**
	 @since 2003.1.1
	 @param arg0
	 @param arg1
	 @return javax.xml.soap.SOAPMessage
	 @throws java.io.IOException
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400392DF02CE
	 */
	public SOAPMessage createMessage(MimeHeaders arg0, InputStream arg1) throws IOException, SOAPException 
	{
		return factory.createMessage(arg0,arg1);
		//return null;
	}



}
