//Source file: 4c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\EbxmlMessageImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Iterator;

import javax.activation.DataHandler;
import javax.xml.soap.AttachmentPart;
import javax.xml.soap.MimeHeaders;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.EbxmlBody;
import org.kldp.ebmsh.message.packaging.EbxmlConstants;
import org.kldp.ebmsh.message.packaging.EbxmlElement;
import org.kldp.ebmsh.message.packaging.EbxmlHeader;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.packaging.EbxmlMessageFactory;
import org.kldp.ebmsh.message.packaging.Manifest;
import org.kldp.ebmsh.message.packaging.MessageData;
import org.kldp.ebmsh.message.packaging.MessageHeader;
import org.kldp.ebmsh.message.packaging.PartyId;
import org.kldp.ebmsh.message.packaging.Reference;
import org.kldp.ebmsh.message.packaging.Schema;
import org.kldp.ebmsh.message.security.SecurityUtils;
import org.kldp.util.log.LogUtil;

import com.sun.org.apache.xml.internal.serialize.OutputFormat;
import com.sun.org.apache.xml.internal.serializer.DOMSerializer;
import com.sun.org.apache.xml.internal.serializer.SerializerFactory;




/**
 @author pio
 @version 0.0
 @since 2003.1.1
 */
public class EbxmlMessageImpl extends EbxmlMessage 
{

	private static Log log = LogFactory.getLog(EbxmlMessageImpl.class); 

	/**
	 @since 2003.1.1
	 */
	private EbxmlMessageFactory messageFactory = null;

	/**
	 @since 2003.1.1
	 */
	private SOAPMessage message = null;

	/**
	 @since 2003.1.1
	 @roseuid 400235130036
	 */
	public EbxmlMessageImpl() 
	{

	}

	/**
	 @since 2003.1.1
	 @param message
	 @param messageFactory
	 @throws javax.xml.soap.SOAPException
	 @roseuid 40022DB70236
	 */
	public EbxmlMessageImpl(SOAPMessage message,EbxmlMessageFactory factory) throws SOAPException 
	{
		this.message = message;
		this.messageFactory  = factory;
	}

	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 40022DCA025B
	 */
	public String getContentDescription() 
	{
		return null;
	}

	/**
	 @since 2003.1.1
	 @param arg0
	 @roseuid 40022DCB037F
	 */
	public void setContentDescription(String arg0) 
	{

	}

	/**
	 @since 2003.1.1
	 @return javax.xml.soap.SOAPPart
	 @roseuid 40022DCC00CD
	 */
	public SOAPPart getSOAPPart() 
	{
		return message.getSOAPPart();
	}

	/**
	 @since 2003.1.1
	 @roseuid 40022DCC0182
	 */
	public void removeAllAttachments() 
	{
		message.removeAllAttachments() ;
	}

	/**
	 @since 2003.1.1
	 @return int
	 @roseuid 40022DCC0272
	 */
	public int countAttachments() 
	{
		return message.countAttachments() ;

	}

	/**
	 @since 2003.1.1
	 @return java.util.Iterator
	 @roseuid 40022DCC0380
	 */
	public Iterator getAttachments() 
	{
		return message.getAttachments();
	}

	/**
	 @since 2003.1.1
	 @param arg0
	 @return java.util.Iterator
	 @roseuid 40022DCD00CF
	 */
	public Iterator getAttachments(MimeHeaders arg0) 
	{
		return message.getAttachments(arg0);
	}

	/**
	 @since 2003.1.1
	 @param arg0
	 @roseuid 40022DCD0328
	 */
	public void addAttachmentPart(AttachmentPart arg0) 
	{

		message.addAttachmentPart( arg0);
	}

	/* adding payload */

	public  void addPayload(DataHandler dh,String contentid)
	{
		final AttachmentPart attachment = 	   message.createAttachmentPart(dh);

		String cid4mime = "<" + contentid + ">";
		attachment.setContentId(cid4mime);
		//TODO 켱 ÷  type  text/xml  Ѵ.

		attachment.setContentType("text/xml");
		try{


			EbxmlBody eb = this.getEbxmlBody() ;
			Manifest mf = null;
			if(!eb.hasManifest())
			{


				mf = 	eb.addManifest();
			}else
			{
				mf = eb.getManifest() ;
			}

			Reference rf = mf.addReference() ;

			rf.setXlinkRef("cid:"+contentid );

			this.addAttachmentPart( attachment);
		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}



	}

	/* adding payload */

	public  void addPayload(DataHandler dh,String contentid,String role)
	{
		final AttachmentPart attachment = 	   message.createAttachmentPart(dh);

		String cid4mime = "<" + contentid + ">";
		attachment.setContentId(cid4mime);

		//TODO 켱 ÷  type  text/xml  Ѵ.

		attachment.setContentType("text/xml");
		try{

			EbxmlBody eb = this.getEbxmlBody() ;
			Manifest mf = null;
			if(!eb.hasManifest())
			{

				mf = 	eb.addManifest();
			}else
			{
				mf = eb.getManifest() ;
			}

			Reference rf = mf.addReference() ;

			rf.setXlinkRef("cid:"+contentid );
			rf.setXlinkRole(role);


			this.addAttachmentPart( attachment);
		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}



	}
	public  void addPayload(DataHandler dh,String contentid,String role,String schema)
	{
		final AttachmentPart attachment = 	   message.createAttachmentPart(dh);

		String cid4mime = "<" + contentid + ">";
		attachment.setContentId(cid4mime);

		//TODO 켱 ÷  type  text/xml  Ѵ.

		attachment.setContentType("text/xml");
		try{

			EbxmlBody eb = this.getEbxmlBody() ;
			Manifest mf = null;
			if(!eb.hasManifest())
			{


				mf = 	eb.addManifest();
			}else
			{
				mf = eb.getManifest() ;
			}

			Reference rf = mf.addReference() ;

			rf.setXlinkRef("cid:"+contentid );
			rf.setXlinkRole(role);
			Schema sm = rf.addSchema();

			sm.setSchemaLocation(schema);
			//rf.set

			this.addAttachmentPart( attachment);
		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}



	}

	/** geting paylod*/
	public DataHandler getPayload(String contentId)
	{

		DataHandler dh=null;
		Iterator itManifest = this.getAttachments();
		//log.info("geting content id = " + itManifest.hasNext() );
		while(itManifest.hasNext())
		{

			try{

				AttachmentPart apart = ((AttachmentPart)itManifest.next());
				String cid = apart.getContentId();
				//log.info("geting content id = " + cid);

				if(cid.startsWith( "<"))
				{
					cid = cid.substring(1,cid.length()-1);
				}

				if(cid.equals(contentId))
				{
					log.info("compare "+ cid + " == " + contentId);

					dh = apart.getDataHandler();

				}


			}catch(Exception e)
			{
				log.fatal( LogUtil.stackTraceToString(e)) ;
			}
		}

		return dh;
	}


	/** geting paylod*/
	public DataHandler getPayload(int index)
	{

		int i_index = 0;
		DataHandler dh=null;
		Iterator itManifest = this.getAttachments();
		//log.info("geting content id = " + itManifest.hasNext() );
		while(itManifest.hasNext())
		{

			i_index++;
			try{

				AttachmentPart apart = ((AttachmentPart)itManifest.next());
				String cid = apart.getContentId();
				//log.info("geting content id = " + cid);

				if(cid.startsWith( "<"))
				{
					cid = cid.substring(1,cid.length()-1);
				}

				if(index == i_index)
				{

					dh = apart.getDataHandler();

				}


			}catch(Exception e)
			{
				log.fatal( LogUtil.stackTraceToString(e)) ;
			}
		}

		return dh;
	}
	/** geting paylod*/
	public String getPayloadAsString(int index)
	{

		int i_index = 0;
		String payload = null;
		Iterator itManifest = this.getAttachments();
		//log.info("geting content id = " + itManifest.hasNext() );
		while(itManifest.hasNext())
		{

			i_index++;
			try{

				AttachmentPart apart = ((AttachmentPart)itManifest.next());
				String cid = apart.getContentId();
				//log.info("geting content id = " + cid);

				if(cid.startsWith( "<"))
				{
					cid = cid.substring(1,cid.length()-1);
				}

				if(index == i_index)
				{

					DataHandler dh = apart.getDataHandler();


					Object  o = dh.getContent();
					log.info("÷  type  " +  dh.getContentType() + " Դϴ " );
					if(dh.getContentType().equals("text/xml") && o instanceof String)
					{
						payload = (String)o;
						log.info("xml  ÷ι  ɴϴ.");
					}else{
						log.info(" ° xml ƴϾ ü ϴ. ");
					}

				}


			}catch(Exception e)
			{
				log.fatal( LogUtil.stackTraceToString(e)) ;
			}
		}

		return payload;
	}


	//KorBit test mime message  body part ϳ
	//ϴٺ  ebxml message ϴ
	// ȴ.
	// soapEnvelope soap message Ѵ
	// payload ߰ϴ  
	//  payload ߰ϸ鼭 Mainfest 
	// ߰ ߴµ  ׷ Ҽ .
	public  void addPayloadforKorBit(DataHandler dh,String contentid)
	{

		final AttachmentPart attachment = 	   message.createAttachmentPart(dh);

		attachment.setContentId(contentid);

		//  attachment.setContentType("text/xml");

		this.addAttachmentPart( attachment);




	}



	/**
	 @since 2003.1.1
	 @return javax.xml.soap.AttachmentPart
	 @roseuid 40022DCE00A8
	 */
	public AttachmentPart createAttachmentPart() 
	{
		return message.createAttachmentPart() ;

	}

	/**
	 @since 2003.1.1
	 @return javax.xml.soap.MimeHeaders
	 @roseuid 40022DCE01F3
	 */
	public MimeHeaders getMimeHeaders() 
	{
		return message.getMimeHeaders() ;
	}

	/**
	 @since 2003.1.1
	 @throws javax.xml.soap.SOAPException
	 @roseuid 40022DCE030B
	 */
	public void saveChanges() throws SOAPException 
	{
		message.saveChanges() ;
	}

	/**
	 @since 2003.1.1
	 @return boolean
	 @roseuid 40022DCF006D
	 */
	public boolean saveRequired() 
	{
		return message.saveRequired() ;

	}

	/**
	 @since 2003.1.1
	 @param arg0
	 @throws javax.xml.soap.SOAPException
	 @throws java.io.IOException
	 @roseuid 40022DCF0172
	 */
	public void writeTo(OutputStream arg0) throws SOAPException, IOException 
	{
		message.writeTo( arg0); 
	}

	public String toString()
	{
		try{
			ByteArrayOutputStream bo = new ByteArrayOutputStream();
			writeTo(bo);
			bo.flush();
			
			return new String(bo.toByteArray());
		}
		catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;  	 
			return null;
		}
	}
	/**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.EbxmlMessageFactory
	 @throws javax.xml.soap.SOAPException
	 @roseuid 40023600011D
	 */
	public EbxmlMessageFactory getMessageFactory() throws SOAPException 
	{
		return this.messageFactory ;
	}

	/**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.EbxmlHeader
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400352640105
	 */
	public EbxmlHeader getEbxmlHeader() throws SOAPException 
	{
		SOAPPart sp = getSOAPPart();
		SOAPEnvelope envelope = sp.getEnvelope();
		SOAPHeader sh = envelope.getHeader() ;
		EbxmlHeaderImpl eh = new EbxmlHeaderImpl(envelope,sh);
		return eh;

	}


	/**
	 @since 2003.1.1
	 @return com.softmeca.ebmsh.message.packaging.EbxmlBody
	 @throws javax.xml.soap.SOAPException
	 @roseuid 400B5F620076
	 */
	public EbxmlBody getEbxmlBody() throws SOAPException 
	{
		SOAPPart sp = getSOAPPart();
		SOAPEnvelope envelope = sp.getEnvelope();
		SOAPBody sb = envelope.getBody();//.getHeader() ;
		EbxmlBodyImpl eb = new EbxmlBodyImpl(envelope,sb);
		return eb;
	}



	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FA00238
	 */
	public String getMessageId() 
	{
		String msgId = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			msgId = mh.getMessageData().getMessagId().getValue() ;

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return msgId;
	}

	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FA90028
	 */
	public String getTimestamp() 
	{
		String timestamp = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			timestamp = mh.getMessageData().getTimestamp().getValue() ;

		}
		catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return timestamp;
	}
	
	public String getTimeToLive() {
		String timeToLive = null;
		
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			timeToLive = mh.getMessageData().getTimeToLive().getValue();
		}
		catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return timeToLive;
	}

	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FB300B9
	 */
	public String getCPAId() 
	{
		String cpaId = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			cpaId = mh.getCPAId().getValue();

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return cpaId;
	}

	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FBD02EE
	 */
	public String getFrom() 
	{
		String from = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			//TODO partyId   type   쿡   ; Ѵ.
			//from = mh.getFrom ().getP
			Iterator partyids = mh.getFrom().getPartyIds() ;
			PartyIdImpl pid = (PartyIdImpl)partyids.next() ;
			from = pid.getValue(); 
		}catch(SOAPException e)
		{
			// log.fatal( LogUtil.stackTraceToString(e));
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return from;
	}



	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FC50259
	 */
	public String getTo() 
	{
		String to = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			//TODO partyId   type   쿡   ; Ѵ.
			//  to = mh.getTo().getValue ();
			Iterator partyids = mh.getTo().getPartyIds() ;
			PartyIdImpl pid = (PartyIdImpl)partyids.next() ;
			to = pid.getValue(); 
		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return to;
	}

	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FCD02DD
	 */
	public String getConversationId() 
	{
		String convId = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			convId  = mh.getConversationId().getValue ();
		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return convId;
	}

	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FD501B2
	 */
	public String getService() 
	{
		String service = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			service  = mh.getService().getValue ();
		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return service;

	}

	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FDC0357
	 */
	public String getAction() 
	{
		String action = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			action  = mh.getAction().getValue ();
		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return action;
	}

	/**
	 @since 2003.1.1
	 @return java.lang.String
	 @roseuid 400B5FE30234
	 */
	public String getRefToMessageId() 
	{
		String refToMessageId = null;
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;
			MessageHeader mh = ebh.getMessageHeader() ;
			refToMessageId = mh.getMessageData().getRefToMessageId().getValue() ;

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

		return refToMessageId;

	}
	/**
	 @since 2003.1.1
	 @param messageId
	 @roseuid 400CBD13005D
	 */
	public void setMessageId(String messageId) 
	{

		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			MessageData md = mh.getMessageData() ;


			md.getMessagId().setValue(messageId);

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}



	}

	/**
	 @since 2003.1.1
	 @param timestamp
	 @roseuid 400CBDF50185
	 */
	public void setTimestamp(String timestamp) 
	{

		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			MessageData md = mh.getMessageData() ;

			md.getTimestamp().setValue(timestamp);

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}



	}



	/**
	 @since 2003.1.1
	 @param conversationId
	 @roseuid 400B7ABF037C
	 */
	public void setConversationId(String conversationId) 
	{

		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			mh.getConversationId().setValue( conversationId);


		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

	}

	/**
	 @since 2003.1.1
	 @param capId
	 @roseuid 400B7B370053
	 */
	public void setCPAId(String cpaId) 
	{

		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			mh.getCPAId().setValue( cpaId);


		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

	}

	/**
	 @since 2003.1.1
	 @param from
	 @roseuid 400B7B400056
	 */
	public void setFrom(String from) 
	{

		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			//Section: QuangHung add 
			((EbxmlElement)mh.getFrom ().getPartyIds().next()).setValue( from);
			//Section: End



		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}
	}

	/**
	 @since 2003.1.1
	 @param String partyId,String type
	 @roseuid 400B7B400056
	 */
	public void setFrom(String partyId,String type) 
	{

		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;

			PartyId pid = mh.getFrom ().addPartyId();
			pid.setType(type);
			pid.setValue( partyId);
			//mh.getFrom().setType

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}
	}
	/**
	 @since 2003.1.1
	 @param to
	 @roseuid 400B7B4901FE
	 */
	public void setTo(String to) 
	{
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
//			Section: QuangHung add 
			((EbxmlElement)mh.getTo().getPartyIds().next()).setValue(to);
			//Section: End
			//mh.getTo().setValue( to);

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

	}

	public void setTo(String toPartyId,String type) 
	{
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			PartyId pid = mh.getTo().addPartyId() ;
			pid.setType( type);
			pid.setValue( toPartyId);


		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

	}

	/**
	 @since 2003.1.1
	 @param service
	 @roseuid 400B7B5B00F5
	 */
	public void setService(String service,String type) 
	{
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			mh.getService().setValue( service);
			mh.getService().setType(type);

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

	}



	/**
	 @since 2003.1.1
	 @param service
	 @roseuid 400B7B5B00F5
	 */
	public void setService(String service) 
	{
		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			mh.getService().setValue( service);
			//	mh.getService().setType(type);

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}

	}


	/**
	 @since 2003.1.1
	 @param action
	 @roseuid 400B7B630061
	 */
	public void setAction(String action) 
	{

		try{

			EbxmlHeader ebh = this.getEbxmlHeader() ;

			if(!ebh.hasMessageHeader())
			{
				log.info("initMessageHeader()   ȣؼ MessageHeader ʱȭ ּ.");
			}
			MessageHeader mh = ebh.getMessageHeader() ;
			mh.getAction().setValue( action);

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}
	}


	/**
	 @since 2003.1.1
	 @roseuid 400B881C01AE



	 */
	public void initMessageHeader() 
	{
		try{



			EbxmlHeader ebh = this.getEbxmlHeader() ;


			MessageHeader mh = ebh.addMessageHeader() ;

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;
		}


	}

	/**
	 @since 2003.1.1
	 envelope soapHeader  ʱȭ Ѵ. Ʒ  

	 <SOAP:Envelope xmlns:xlink="http://www.w3.org/1999/xlink" 
	 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	 xmlns:SOAP="http://schemas.xmlsoap.org/soap/envelope/" 
	 xsi:schemaLocation="http://schemas.xmlsoap.org/soap/envelope/ 
	 http://www.oasis-open.org/committees/ebxml-msg/schema/envelope.xsd">


	 @roseuid 400C8B78000D
	 */
	public void initNameSpace() 
	{
		try{

			SOAPPart sp = message.getSOAPPart();
			SOAPEnvelope env = sp.getEnvelope() ;

			env.addNamespaceDeclaration( "xlink","http://www.w3.org/1999/xlink" );
			env.addNamespaceDeclaration( "xsi","http://www.w3.org/2001/XMLSchema-instance" );
			env.addNamespaceDeclaration( "soap-env","http://schemas.xmlsoap.org/soap/envelope/");
			Name name	= env.createName("schemaLocation", "xsi", "http://www.w3.org/2001/XMLSchema-instance");
			env.addAttribute( name,"http://schemas.xmlsoap.org/soap/envelope/ http://www.oasis-open.org/committees/ebxml-msg/schema/envelope.xsd");

			SOAPHeader header = env.getHeader();

			header.addNamespaceDeclaration(EbxmlConstants.prefixEb,"http://www.oasis-open.org/committees/ebxml-msg/schema/msg-header-2_0.xsd");


			Name name2	= env.createName("schemaLocation", "xsi", "http://www.w3.org/2001/XMLSchema-instance");

			header.addAttribute( name2,"http://www.oasis-open.org/committees/ebxml-msg/schema/msg-header-2_0.xsd http://www.oasis-open.org/committees/ebxml-msg/schema/msg-header-2_0.xsd");

			SOAPBody body  = env.getBody() ;

			Name name3	= env.createName("schemaLocation", "xsi", "http://www.w3.org/2001/XMLSchema-instance");


			body.addNamespaceDeclaration(EbxmlConstants.prefixEb,"http://www.oasis-open.org/committees/ebxml-msg/schema/msg-header-2_0.xsd");
			body.addAttribute( name3,"http://www.oasis-open.org/committees/ebxml-msg/schema/msg-header-2_0.xsd http://www.oasis-open.org/committees/ebxml-msg/schema/msg-header-2_0.xsd");

		}catch(SOAPException e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;	
		}


	}

	/**
	 @since 2003.1.1
	 @return boolean
	 @roseuid 4014B9C10128
	 */
	/*public boolean validateMsgItself() throws EbxmlValidationException, EbxmlMessageException
	{		
		EbxmlMessageValidator validator = new EbxmlMessageValidator();

		validator.validate(this);

		return true;
	}*/

	/**
	 @since 2003.1.1
	 @return boolean
	 @roseuid 4014B9CD01CF
	 */
	public boolean validateTimestamp() 
	{
		return true;
	}

	/**
	 * Method to get the ebXML MessageHeader as string
	 * @return String 
	 */
	public String getMsgHeaderAsString()
	throws IOException,  SOAPException
	{

		SecurityUtils sutil = new SecurityUtils();
		return new String(sutil.SOAPPartTOBytes(this)); 

	}

	public byte[] getMsgHeaderAsBytes()
	throws IOException,  SOAPException
	{
		String message = getMsgHeaderAsString();
		if (message == null)
		{
			return null;
		}
		return message.getBytes();
	}
	
	
	public String getMsgAsString()
	throws IOException,  SOAPException
	{
		try{
			ByteArrayOutputStream bo = new ByteArrayOutputStream();
			writeTo(bo);
			bo.flush();
			
			return new String(bo.toByteArray());
		}
		catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;  	 
			return null;
		}

	}

	public byte[] getMsgAsBytes()
	throws IOException,  SOAPException
	{
		try{
			ByteArrayOutputStream bo = new ByteArrayOutputStream();
			writeTo(bo);
			bo.flush();
			
			return bo.toByteArray();
		}
		catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e)) ;  	 
			return null;
		}
	}
}
