//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\ErrorListImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import java.util.ArrayList;
import java.util.Iterator;

import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeaderElement;

import org.kldp.ebmsh.message.packaging.ErrorElement;
import org.kldp.ebmsh.message.packaging.ErrorList;



/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class ErrorListImpl extends EbxmlHeaderElementImpl implements ErrorList 
{
   
   /**
   @since 2003.1.1
    */
   public String highestSeverity = "highestSeverity";
   
   /**
   @since 2003.1.1
   @roseuid 40037ECD01F4
    */
   public ErrorListImpl() 
   {
    
   }
   
   /**
   @since 2003.1.1
   @param env
   @param soapElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4002022601FC
    */
   public ErrorListImpl(SOAPEnvelope env, SOAPHeaderElement she) throws SOAPException 
   {
    super(env,she);
    this.setId("ErrorList");
   }
   
   /**
   @since 2003.1.1
   @param severity
   @throws javax.xml.soap.SOAPException
   @roseuid 4002023D0079
    */
   public void setHighestSeverity(String severity) throws SOAPException 
   {
		
		setEbxmlAttribute(this.highestSeverity ,severity);
   }
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4002023D012D
    */
   public String getHighestServerity() throws SOAPException 
   {
	return getEbxmlAttribute(this.highestSeverity );
    
   }
   
   /**
   @since 2003.1.1
   @return ErrorElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4002023D0173
    */
   public ErrorElement addErrorElement() throws SOAPException 
   {
	
	SOAPElement se = this.addEbxmlChildElement("Error");
	ErrorElementImpl err = new ErrorElementImpl(env,se);
	return err;
   }
   
   /**
   @since 2003.1.1
   @return java.util.Iterator
   @throws javax.xml.soap.SOAPException
   @roseuid 4002023D01CD
    */
   public Iterator getErrorElements() throws SOAPException 
   {
   	
	ArrayList al = new ArrayList();
	Iterator i = getChildElements("Error");
	while(i.hasNext())
	{
		ReferenceImpl r = new ReferenceImpl(env,(SOAPElement)i.next() );
		al.add(r);
	}
	return al.iterator();
    
   }
   
  
}
