//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\MessageHeaderImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeaderElement;

import org.kldp.ebmsh.message.packaging.Action;
import org.kldp.ebmsh.message.packaging.CPAId;
import org.kldp.ebmsh.message.packaging.ConversationId;
import org.kldp.ebmsh.message.packaging.DuplicateElimination;
import org.kldp.ebmsh.message.packaging.From;
import org.kldp.ebmsh.message.packaging.MessageData;
import org.kldp.ebmsh.message.packaging.MessageHeader;
import org.kldp.ebmsh.message.packaging.Service;
import org.kldp.ebmsh.message.packaging.To;


/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class MessageHeaderImpl extends EbxmlHeaderElementImpl implements MessageHeader 
{
   
   /**
   @since 2003.1.1
   @roseuid 40077B9A0199
    */
   public MessageHeaderImpl() 
   {
    
   }
   
   /**
   @since 2003.1.1
   @param env
   @param soapHeaderElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD88031E
    */
   public MessageHeaderImpl(SOAPEnvelope env, SOAPHeaderElement soapHeaderElement) throws SOAPException 
   {
    super(env,soapHeaderElement);
    this.setId("MessageHeader");
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.From
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD880379
    */
   public From addFrom() throws SOAPException 
   {
   	SOAPElement soe = this.addEbxmlChildElement( "From");//this.addUniqueEbxmlChildElement( )
    return new FromImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.From
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD8803BF
    */
   public From getFrom() throws SOAPException 
   {
   	SOAPElement soe = this.getFirstChildElement( "From");
    return new FromImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.To
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD890009
    */
   public To addTo() throws SOAPException 
   {
   	SOAPElement soe = this.addEbxmlChildElement ( "To");
    return new ToImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.To
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD89003B
    */
   public To getTo() throws SOAPException 
   {
   	SOAPElement soe =  this.getFirstChildElement( "To");
    return new ToImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.CPAId
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD890081
    */
   public CPAId addCPAId() throws SOAPException 
   {
   	SOAPElement soe = this.addUniqueEbxmlChildElement( "CPAId");
    return new CPAIdImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.CPAId
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD8900BD
    */
   public CPAId getCPAId() throws SOAPException 
   {
   	SOAPElement soe = this.getFirstChildElement( "CPAId");
    return new CPAIdImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.ConversationId
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD8900F9
    */
   public ConversationId addConversationId() throws SOAPException 
   {
   	SOAPElement soe = this.addUniqueEbxmlChildElement( "ConversationId");
    return new ConversationIdImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.ConversationId
   @roseuid 4005FD890135
    */
   public ConversationId getConversationId() throws SOAPException
   {
   	SOAPElement soe = this.getFirstChildElement( "ConversationId");
    return new ConversationIdImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Service
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD890185
    */
   public Service addService() throws SOAPException 
   {
   	SOAPElement soe = this.addUniqueEbxmlChildElement( "Service");
    return new ServiceImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Service
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD8901D5
    */
   public Service getService() throws SOAPException 
   {
   	
   	SOAPElement soe = this.getFirstChildElement( "Service");
    return new ServiceImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Action
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD89023A
    */
   public Action addAction() throws SOAPException 
   {
   	SOAPElement soe = this.addUniqueEbxmlChildElement( "Action");
    return new ActionImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Action
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD890294
    */
   public Action getAction() throws SOAPException 
   {
   	SOAPElement soe = this.getFirstChildElement( "Action");
    return new ActionImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.MessageData
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD8902E4
    */
   public MessageData addMessageData() throws SOAPException 
   {
   	SOAPElement soe = this.addUniqueEbxmlChildElement( "MessageData");
	MessageDataImpl md = new MessageDataImpl(env,soe);
	md.addMessageId() ;
	md.addTimestamp();
    return md;
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.MessageData
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD890316
    */
   public MessageData getMessageData() throws SOAPException 
   {
   	SOAPElement soe = this.getFirstChildElement( "MessageData");
   	
    return new MessageDataImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.DuplicateElimination
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD890348
    */
   public DuplicateElimination addDuplicateElimenation() throws SOAPException 
   {
   	SOAPElement soe = this.addUniqueEbxmlChildElement( "DuplicateElimination");
    return new DuplicateEliminationImpl(env,soe);
   }
   
 
   public boolean hasDuplicateElimination() throws SOAPException 
	   {
		  if(this.hasElement("DuplicateElimination"))
		  {
			  return true;
		  }else return false;
	   }


   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.DuplicateElimination
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FD890384
    */
   public DuplicateElimination getDuplicateElimenation() throws SOAPException 
   {


	
	SOAPElement soe = this.getFirstChildElement( "DuplicateElimination");
   	
	return new DuplicateEliminationImpl(env,soe);
   }
}

