//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\packaging\\impl\\ReferenceImpl.java

package org.kldp.ebmsh.message.packaging.impl;

import java.util.Iterator;

import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;

import org.kldp.ebmsh.message.packaging.Description;
import org.kldp.ebmsh.message.packaging.Reference;
import org.kldp.ebmsh.message.packaging.Schema;


/**
@author pio
@version 0.0
@since 2003.1.1
 */
public class ReferenceImpl extends EbxmlElementImpl implements Reference 
{
   
   /**
   @since 2003.1.1
   @roseuid 40079320010C
    */
   public ReferenceImpl() 
   {
    
   }
   
   /**
   @since 2003.1.1
   @param env
   @param soapElement
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FEDB00FF
    */
   public ReferenceImpl(SOAPEnvelope env, SOAPElement soapElement) throws SOAPException 
   {
    super(env,soapElement);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Schema
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF1502ED
    */
   public Schema addSchema() throws SOAPException 
   {
   	SOAPElement soe = this.addUniqueEbxmlChildElement( "Schema");
    return new SchemaImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF150329
    */
   public boolean hasSchema() throws SOAPException 
   {
   	if(this.hasElement("Schema"))
   	{
   		return true;
   		
   	}else  return false;
   	
   }
   
   /**
   @since 2003.1.1
   @return java.util.Iterator
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF150365
    */
   public Iterator getSchemas() throws SOAPException 
   {
   	return this.getChildElements(env.createName("Schema"));
    
   }
   
   /**
   @since 2003.1.1
   @param xlinkref
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF1503B5
    */
   public void setXlinkRef(String xlinkref) throws SOAPException 
   {
    //this.setEbxmlAttribute( "xlink:href",xlinkref);
	//env.addNamespaceDeclaration( "xlink","http://www.w3.org/1999/xlink" );
//	Name name = envelope.createName("href", "xlink","http://www.w3.org/1999/xlink");
//	setEbxmlAttribute(name, xlinkRef)
	Name name = env.createName(     "href", "xlink","http://www.w3.org/1999/xlink" );
	this.setEbxmlAttribute( name,xlinkref);
   }
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF1600A0
    */
   public String getXlinkRef() throws SOAPException 
   {
//	Name name = env.createName("href", "xlink","http://www.w3.org/1999/xlink");
	//	return getAttributeValue(name);
	Name name = env.createName("href", "xlink","http://www.w3.org/1999/xlink" );
  	return  	this.getAttributeValue(name);
  
    //return null;
   }
   
   /**
   @since 2003.1.1
   @param xlinkrole
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF1600E6
    */
   public void setXlinkRole(String xlinkrole) throws SOAPException 
   {
   // this.setEbxmlAttribute("xlink:role",xlinkrole);
    
   Name name = env.createName(     "role", "xlink","http://www.w3.org/1999/xlink" );
	this.setEbxmlAttribute( name,xlinkrole);
   }
   
   /**
   @since 2003.1.1
   @return java.lang.String
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF1601A4
    */
   public String getXlinkRole() throws SOAPException 
   {
   	
	Name name = env.createName(     "role", "xlink","http://www.w3.org/1999/xlink" );
	
    return this.getAttributeValue(name);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Description
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF1601E0
    */
   public Description addDescription() throws SOAPException 
   {
    SOAPElement soe = this.addEbxmlChildElement( "Description");
    return new DescriptionImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return com.softmeca.ebmsh.message.packaging.Description
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF160230
    */
   public Description getDescriptions() throws SOAPException 
   {
   	SOAPElement soe = this.getFirstChildElement( "Description");
    return new DescriptionImpl(env,soe);
   }
   
   /**
   @since 2003.1.1
   @return boolean
   @throws javax.xml.soap.SOAPException
   @roseuid 4005FF16026C
    */
   public boolean hasDescriptions() throws SOAPException 
   {
   	if(this.hasElement("Description"))
   	{
   		return true;
   	}else    return false;
   }
}
