package org.kldp.ebmsh.message.persistant;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;


/**
 * " + Environment.bizboxDatabaseName + "DuplicateMessage DAO
 * 
 * @author Sirius
 * @since 2007-03-30
 */
public class DuplicateMessageDAO {
	/**
	 * ڷ Ѿ EbxmlMessage  ð  ߺ üũ մϴ.
	 * 
	 * @param ebxmlMessage
	 * @param nowTime
	 * @return
	 * @throws EbmsPersistantException
	 */
	/*public boolean duplicatePrevention(EbxmlMessage ebxmlMessage, long nowTime) throws EbxmlPersistantException {
		try {
			DuplicateMessage duplicateMessage = null;
			
			String messageId = ebxmlMessage.getMessageId();
			
			final String queryStr = "select * from " + Environment.bizboxDatabaseName + "DuplicateMessage where MessageId = ?";
			
			final Object[] parameters = new Object[1];
			parameters[0] = messageId; // [0] MessageId
			
			DbTemplate dbTemplate = new DbTemplate();
			
			duplicateMessage = (DuplicateMessage)dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbxmlPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanHandler(DuplicateMessage.class);
							
							DuplicateMessage duplicateMessage = null;
							
							try {
								duplicateMessage = (DuplicateMessage)runner.query(_conn, queryStr, parameters, resultSetHandler);
							}
							catch (SQLException e) {
								throw new EbxmlPersistantException(1, 0, e);
							}
							
							return duplicateMessage;
						}
					});
			
			Timestamp checkEndTime = duplicateMessage.getCheckEndTime();
			Timestamp nowTimeTimestamp = new Timestamp(nowTime);
	
			if( checkEndTime.after(nowTimeTimestamp) ) 
				return true;
			else 
				return false;
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(0, 0, e);
		}
	}*/
	
	
	public boolean duplicatePrevention(EbxmlMessage ebxmlMessage, long nowTime) throws EbmsPersistantException {
		try {
			DuplicateMessage duplicateMessage = null;
			
			String messageId = ebxmlMessage.getMessageId();
			Timestamp nowTimeTimestamp = new Timestamp(nowTime);
			
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "DuplicateMessage where MessageId =? and CheckEndTime >= ?";
			
			final Object[] parameters = new Object[2];
			parameters[0] = messageId; // [0] messageId
			parameters[1] = nowTimeTimestamp; // [1] nowTime
			
			DbTemplate dbTemplate = new DbTemplate();
			
			duplicateMessage = (DuplicateMessage)dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanHandler(DuplicateMessage.class);
							
							DuplicateMessage duplicateMessage = null;
							
							try {
								duplicateMessage = (DuplicateMessage)runner.query(_conn, queryStr, parameters, resultSetHandler);
							}
							catch (SQLException e) {
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}
							
							return duplicateMessage;
						}
					});
			
			if( duplicateMessage == null )
				return false;
			else
				return true;
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
	
	
	/**
	 * ߺ ޽  մϴ.
	 * 
	 * @param ebxmlMessage
	 * @param checkEndTime
	 * @throws EbmsPersistantException
	 */
	public void insertDuplicateMessage(EbxmlMessage ebxmlMessage, long checkEndTime) throws EbmsPersistantException {
		try {
			String messageId = ebxmlMessage.getMessageId();
			Timestamp checkEndTimeTimestamp = new Timestamp(checkEndTime);
			
			final String queryStr = "insert into " + EbmsConstants.bizboxDatabaseHeaderName + "DuplicateMessage(MessageId, CheckEndTime) values(?, ?)";
			
			final Object[] parameters = new Object[2];
			parameters[0] = messageId; // [0] MessageId
			parameters[1] = checkEndTimeTimestamp; // [1] CheckEndTime
			
			DbTemplate dbTemplate = new DbTemplate();
			dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();
							
							try {
								runner.update(_conn, queryStr, parameters);
							} catch (SQLException e) {
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}
							
							return null;
						}
					}
				);
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
	
	
	
	/**
	 * ߺ ޽  Ʈմϴ.
	 * 
	 * @param ebxmlMessage
	 * @param checkEndTime
	 * @throws EbmsPersistantException
	 */
	public void updateDuplicateMessage(EbxmlMessage ebxmlMessage, long checkEndTime) throws EbmsPersistantException {
		try {
			String messageId = ebxmlMessage.getMessageId();
			Timestamp checkEndTimeTimestamp = new Timestamp(checkEndTime);
			
			final String queryStr = "update " + EbmsConstants.bizboxDatabaseHeaderName + "DuplicateMessage set CheckEndTime=? where MessageId=?";
			
			final Object[] parameters = new Object[2];
			parameters[0] = checkEndTimeTimestamp; // [0] CheckEndTime
			parameters[1] = messageId; // [1] MessageId
			
			
			DbTemplate dbTemplate = new DbTemplate();
			dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();
							
							try {
								runner.update(_conn, queryStr, parameters);
							} catch (SQLException e) {
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}
							
							return null;
						}
					}
				);
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
}
