package org.kldp.ebmsh.message.persistant;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.message.packaging.EbmsEbxmlMessageException;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.util.Serializer;
import org.kldp.util.io.FileIoUtil;


/**
 * Bizbox Ǵ FileDAO
 * 
 * @author Sirius
 * @since 2007-03-30
 */
public class FileDAO {
	private final static Log log = LogFactory.getLog(FileDAO.class);
	
	
	/**
	 * Constructor
	 */
	FileDAO() {
	}
	
	
	/**
	 *  θ ָ EbxmlMessage ؼ մϴ.
	 * 
	 * @param filePath
	 * @return
	 * @throws EbmsPersistantException
	 */
	EbxmlMessage getEbxmlMessageFromFile(String filePath) throws EbmsPersistantException {
		EbxmlMessage msg = null;
		FileInputStream fin = null;

		try{
			fin = new FileInputStream(new File(filePath));
			msg = Serializer.deserialize(fin);

			fin.close();
		}
		catch(FileNotFoundException e)
		{
			throw new EbmsPersistantException(1, 0, " ã ϴ", e); 	
		}
		catch(IOException e)
		{
			throw new EbmsPersistantException(1, 0, "Ͽ ޽   ϴ", e); 	
		}
		catch(EbmsEbxmlMessageException e)
		{
			throw new EbmsPersistantException(1, 0, "Ͽ ޽   ϴ", e); 	
		}
		finally {
			if( fin != null )
				try {
					fin.close();
				}
				catch(Exception ignore) { }
		}

		return msg;
	}
	
	
	/**
	 * EbxmlMessage մϴ.
	 * 
	 * @param msg
	 * @param filePath
	 * @return
	 * @throws EbmsPersistantException
	 */
	void storeEbxmlMessageToFile(EbxmlMessage msg, String filePath) throws EbmsPersistantException 
	{	
		log.info("Ͽ ޽  մϴ");
		
		try
		{
			Date date = new Date();
			
			SimpleDateFormat sd = new SimpleDateFormat("yyyy-MM-dd");
			String dateDirectoryName = sd.format(date);
			
			// ʿ 丮 ִ ˻մϴ.  ڵ մϴ.
			checkMessageDirectory(dateDirectoryName);
			
			File file = new File(filePath);

			if(file.exists())
				log.info(" ̸ ޽ ̹ մϴ.  ϴ.");
			
			FileOutputStream fo = new FileOutputStream(file);

			log.info(" : " + file.getAbsolutePath());
			
			Serializer.serialize(msg, fo);
			
			fo.flush();
			fo.close();
		}
		catch(IOException e)
		{
			throw new EbmsPersistantException(1, 0, "EbxmlMessage Ͽ ϴµ  Ͽϴ. -> storeEbxmlMessage()", e); 
		}
		catch(EbmsEbxmlMessageException e)
		{
			throw new EbmsPersistantException(1, 0, "EbxmlMessage Serializeϴµ  Ͽϴ.  -> storeEbxmlMessage()", e); 
		}
	}
	
	
	/**
	 *  ¥ Էϸ شϴ ¥ ebxml message directory   ڵ Ѵ.
	 */
	private void checkMessageDirectory(String dateDirectoryName) {
		/*FileIoUtil.directoryCreateOrNone(Environment.messagePath);
		
		FileIoUtil.directoryCreateOrNone(Environment.messagePath + "fmessage");
		
		FileIoUtil.directoryCreateOrNone(Environment.messagePath + "fmessagepayload");
		
		FileIoUtil.directoryCreateOrNone(Environment.messagePath + "ackmessage");
		
		FileIoUtil.directoryCreateOrNone(Environment.messagePath + "ackpayload");*/

		FileIoUtil.directoryCreateOrNone(EbmsConstants.messagePath + FileIoUtil.fileSeparatorAddOrNone("incoming") + dateDirectoryName);
		
		FileIoUtil.directoryCreateOrNone(EbmsConstants.messagePath + FileIoUtil.fileSeparatorAddOrNone("outgoing") + dateDirectoryName);

		//FileIoUtil.directoryCreateOrNone(Environment.messagePath + FileIoUtil.fileSeparatorAddOrNone(dateDirectoryName));
		
		//FileIoUtil.directoryCreateOrNone(Environment.messagePath + FileIoUtil.fileSeparatorAddOrNone(dateDirectoryName) + "payload");
		
		//FileIoUtil.directoryCreateOrNone(EbmsConstants.messagePath + FileIoUtil.fileSeparatorAddOrNone("incoming"));
		
		//FileIoUtil.directoryCreateOrNone(EbmsConstants.messagePath + FileIoUtil.fileSeparatorAddOrNone("outgoing"));
		
		FileIoUtil.directoryCreateOrNone(EbmsConstants.messagePath + FileIoUtil.fileSeparatorAddOrNone("outgoing") + "ackmessage");
	}
}
