package org.kldp.ebmsh.message.persistant;

import java.sql.Connection;
import java.sql.SQLException;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;



public class MessageStatusDAO {
	private final static Log log = LogFactory.getLog(MessageStatusDAO.class);
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbmsPersistantException
	 */
	public void insertMessageStatus(String messageId, int messageStatus, String statusDesc) throws EbmsPersistantException {
		try {
			final String queryStr = "insert into " + EbmsConstants.bizboxDatabaseHeaderName + "MessageStatus(MessageId, Status, StatusDesc) values(?, ?, ?)";
			
			int status = messageStatus;
			
			final Object[] parameters = new Object[3];
			parameters[0] = messageId; // [0] MessageId
			parameters[1] = new Integer(status); // [1] Status
			parameters[2] = statusDesc; // [2] StatusDesc
			
			DbTemplate dbTemplate = new DbTemplate();
			dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();
							
							try {
								runner.update(_conn, queryStr, parameters);
							} catch (SQLException e) {
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}
							
							return null;
						}
					}
				);
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbmsPersistantException
	 */
	public void insertMessageStatus(EbxmlMessage ebxmlMessage, int messageStatus, String statusDesc) throws EbmsPersistantException {
		try {
			final String queryStr = "insert into " + EbmsConstants.bizboxDatabaseHeaderName + "MessageStatus(MessageId, Status, StatusDesc) values(?, ?, ?)";
			
			String messageId = ebxmlMessage.getMessageId();
			int status = messageStatus;
			
			final Object[] parameters = new Object[3];
			parameters[0] = messageId; // [0] MessageId
			parameters[1] = new Integer(status); // [1] Status
			parameters[2] = statusDesc; // [2] StatusDesc
			
			
			DbTemplate dbTemplate = new DbTemplate();
			dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();
							
							try {
								runner.update(_conn, queryStr, parameters);
							} catch (SQLException e) {
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}
							
							return null;
						}
					}
				);
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
	
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbmsPersistantException
	 */
	public void updateMessageStatus(EbxmlMessage ebxmlMessage, int messageStatus, String statusDesc) throws EbmsPersistantException {
		try {
			final String queryStr = "update " + EbmsConstants.bizboxDatabaseHeaderName + "MessageStatus set Status=?, StatusDesc=? where MessageId=?";
			
			String messageId = ebxmlMessage.getMessageId();
			int status = messageStatus;
			
			final Object[] parameters = new Object[3];
			parameters[0] = new Integer(status); // [0] Status
			parameters[1] = statusDesc; // [1] StatusDesc
			parameters[2] = messageId; // [2] MessageId
			
			
			DbTemplate dbTemplate = new DbTemplate();
			dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();
							
							try {
								runner.update(_conn, queryStr, parameters);
							} catch (SQLException e) { 
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}
							
							return null;
						}
					}
				);
			
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
	
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbmsPersistantException
	 */
	public void updateMessageStatus(String messageId, int messageStatus, String statusDesc) throws EbmsPersistantException {
		try {
			final String queryStr = "update " + EbmsConstants.bizboxDatabaseHeaderName + "MessageStatus set Status=?, StatusDesc=? where MessageId=?";
			
			int status = messageStatus;
			
			final Object[] parameters = new Object[3];
			parameters[0] = new Integer(status); // [0] Status
			parameters[1] = statusDesc; // [1] StatusDesc
			parameters[2] = messageId; // [2] MessageId
			
			
			DbTemplate dbTemplate = new DbTemplate();
			dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();
							
							try {
								runner.update(_conn, queryStr, parameters);
							} catch (SQLException e) { 
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}
							
							return null;
						}
					}
				);
			
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
}