package org.kldp.ebmsh.message.persistant;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;

import javax.xml.soap.SOAPException;

import org.apache.commons.dbutils.QueryRunner;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.packaging.impl.AcknowledgmentMessage;


class OutgoingMessageDAO {
	/**
	 * OutGoing Message մϴ.
	 * 
	 * @param ebxmlMessage
	 * @param sendTime
	 * @param status
	 * @throws EbmsPersistantException
	 */
	
	public void insertOutgingMessage(EbxmlMessage ebxmlMessage, long sendTime, int status, String msgFilePath) throws EbmsPersistantException {
		try {
			String refToMessageId = null;
			
			if( ebxmlMessage.getEbxmlHeader().hasAcknowledgment() )
				refToMessageId = ebxmlMessage.getEbxmlHeader().getAcknowledgment().getRefToMessageId().getValue();
			else
				refToMessageId = ebxmlMessage.getRefToMessageId();
			
			String messageId = ebxmlMessage.getMessageId();
			Timestamp sendTimeTimestamp = new Timestamp(sendTime);

			final String queryStr = "insert into " + EbmsConstants.bizboxDatabaseHeaderName + "OutgoingMessage(RefToMessageId, MessageId, SendTime, Status, MSGFilePath) values(?, ?, ?, ?, ?)";

			final Object[] parameters = new Object[5];
			parameters[0] = refToMessageId; // [0] RefToMessageId
			parameters[1] = messageId; // [1] MessageId
			parameters[2] = sendTimeTimestamp; // [2] SendTime
			parameters[3] = new Integer(status); // [3] Status
			parameters[4] = msgFilePath; //[4] MSGFilePath

			DbTemplate dbTemplate = new DbTemplate();
			dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();

							try {
								runner.update(_conn, queryStr, parameters);
							} catch (SQLException e) {
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}

							return null;
						}
					}
			);
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
		catch(SOAPException e) {
			throw new EbmsPersistantException(1, 0, e);
		}
	}
}