//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\rm\\RMMessageProcessor.java

package org.kldp.ebmsh.message.persistant;



import java.text.SimpleDateFormat;
import java.util.Date;


import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xmlbeans.GDuration;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.cpa.CpaManagerFactory;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.util.MessageBuilderUtil;
import org.kldp.ebmsh.message.util.MessageUtil;
import org.kldp.util.io.FileIoUtil;



/**
	@author pio
	@version 0.0
	
	@since 2005.1.26
	
	޽ ϴ 뵵  class Դϴ. 
*/
public class PersistantStorage 
{
	private static Log log = LogFactory.getLog(PersistantStorage.class); 

	

	/**
	 @since 2003.1.1
	 @roseuid 401468EA0148
	 */
	public PersistantStorage()
	{
	}


	/**
	 @since 2005.1.26
	 ޽ մϴ.( Ÿ  database    ޽ Ͽ )
	 @param msg
	 @return com.softmeca.ebmsh.message.packaging.EbxmlMessage
	 @roseuid 401482700266
	 Ÿ    ߻ϸ ٸ 丮 Ͽ Ͽ  ޽ մϴ.
	 */
	public void saveIncomingMessageDbAndFile(EbxmlMessage msg) throws EbmsPersistantException {
		IncomingMessageDAO incomingMessageDAO = new IncomingMessageDAO();
		
		log.info(" ޽  մϴ");
		
		Date date = new Date();
		SimpleDateFormat sd = new SimpleDateFormat("yyyy-MM-dd");
		String dateDirectoryName = sd.format(date);
		
		String messageFilePath = FileIoUtil.fileSeparatorAddOrNone("incoming") + FileIoUtil.fileSeparatorAddOrNone(dateDirectoryName)+ msg.getMessageId();
		
		try {
			incomingMessageDAO.insertIncomingMessage(msg, date.getTime(), messageFilePath);
		}
		catch(EbmsPersistantException e) {
			if( e.getErrorCode() == EbmsConstants.duplicateErrorCode ) 
				incomingMessageDAO.updateIncomingMessage(msg, date.getTime(), messageFilePath);
			else 
				throw e;
		}
		
		FileDAO fileDAO = new FileDAO();
		
		fileDAO.storeEbxmlMessageToFile(msg, EbmsConstants.messagePath + messageFilePath);
	}
	
	
	public void saveFailMessageToFile(EbxmlMessage ebxmlMessage) {
		log.info(" ޽  մϴ");
		
		String messageFilePath = FileIoUtil.fileSeparatorAddOrNone("fail") + ebxmlMessage.getMessageId();
		
		FileDAO fileDAO = new FileDAO();
		
		fileDAO.storeEbxmlMessageToFile(ebxmlMessage, EbmsConstants.messagePath + messageFilePath);
	}
	
	
	
	public void saveMessageStore(EbxmlMessage ebxmlMessage) throws EbmsPersistantException {
		try {
			MessageStoreDAO messageStoreDAO = new MessageStoreDAO();
			
			log.info(" ޽ META  մϴ.");
			log.info("insert(MessageId,TimeStamp,CPAId,FromPartyId,toParyId,ConversationId,Service,Action,MsgFileName,State.gotGeneralMsg) to MessageStore Table");
			messageStoreDAO.insertMessageStore(ebxmlMessage);
		}
		catch(EbmsPersistantException e) {
			if( e.getErrorCode() == EbmsConstants.duplicateErrorCode )			
				new MessageStoreDAO().updateMessageStore(ebxmlMessage);
			else 
				throw e;
		}
	}
	
	/*public void insertMessageStore(EbxmlMessage msg) throws EbxmlPersistantException {
		try {
			MessageStoreDAO messageStoreDAO = new MessageStoreDAO();
			
			log.info(" ޽ META  մϴ.");
			log.info("insert(MessageId,TimeStamp,CPAId,FromPartyId,toParyId,ConversationId,Service,Action,MsgFileName,State.gotGeneralMsg) to MessageStore Table");
			messageStoreDAO.insertMessageStore(msg);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/
	
	//  ޽  
	/*public void saveFailFile(EbxmlMessage message)  {
		try {
			log.info("޽ Ͽ մϴ." );
			
			String messageFilePath = Environment.messagePath + FileIoUtil.fileSeparatorAddOrNone("fmessage") + message.getMessageId();
			String payloadFilePath = Environment.messagePath + FileIoUtil.fileSeparatorAddOrNone("fmessage") + FileIoUtil.fileSeparatorAddOrNone("payload") + message.getMessageId() + ".xml";
			
			file.storeEbxmlMessage(message, messageFilePath);
			
			if(message.getEbxmlBody().hasManifest())
			{
				log.info("÷ι մϴ.");
				file.storePayload(message, payloadFilePath);
			}
		}
		catch(Exception e) {
			log.fatal( MessageUtil.stackTraceToString(e) );
		}
	}*/


	public void saveIncomingMessageToFile(EbxmlMessage msg) throws EbmsPersistantException {
		log.info("޽ Ͽ մϴ." );
		
		Date date = new Date();
		
		SimpleDateFormat sd = new SimpleDateFormat("yyyy-MM-dd");
		String dateDirectoryName = sd.format(date);
		
		String messageFilePath = EbmsConstants.messagePath + FileIoUtil.fileSeparatorAddOrNone("incoming") + FileIoUtil.fileSeparatorAddOrNone(dateDirectoryName)+ msg.getMessageId();
		
		FileDAO fileDAO = new FileDAO();
		
		fileDAO.storeEbxmlMessageToFile(msg, messageFilePath);
	}
	
	
	/**
	 * Outgoing ޽ Ͽ ϴ 
	 * @param msg
	 * @throws EbmsPersistantException
	 */
	public void saveOutgoingMessageToFile(EbxmlMessage ebxmlMessage) throws EbmsPersistantException {
		log.info("޽ Ͽ մϴ." );
		
		Date date = new Date();
		
		SimpleDateFormat sd = new SimpleDateFormat("yyyy-MM-dd");
		String dateDirectoryName = sd.format(date);
		
		String messageFilePath = EbmsConstants.messagePath + FileIoUtil.fileSeparatorAddOrNone("outgoing") + FileIoUtil.fileSeparatorAddOrNone(dateDirectoryName)+ ebxmlMessage.getMessageId();
		
		FileDAO fileDAO = new FileDAO();
		
		fileDAO.storeEbxmlMessageToFile(ebxmlMessage, messageFilePath);
	}
	
	public void saveAckMessageInfo(EbxmlMessage ackMessage) throws EbmsPersistantException {
		try {
			AckMessageDAO ackMessageDAO = new AckMessageDAO();
			
			ackMessageDAO.insertAckMessage(ackMessage);
		}
		catch(EbmsPersistantException e) {
			if( e.getErrorCode() == EbmsConstants.duplicateErrorCode )			
				new AckMessageDAO().updateAckMessage(ackMessage);
			else 
				throw e;
		}
	}

	/*
	 * Ack޽ Ͽ ϴ 
	 */
	public void saveAckMessageToFile(EbxmlMessage msg) throws EbmsPersistantException {
		log.info("store message to filesystem." );
		
		String messageFilePath = EbmsConstants.messagePath + FileIoUtil.fileSeparatorAddOrNone("outgoing") + FileIoUtil.fileSeparatorAddOrNone("ackmessage") + msg.getMessageId();
		
		FileDAO fileDAO = new FileDAO();
		
		fileDAO.storeEbxmlMessageToFile(msg, messageFilePath);
	}
	
	/**
	 * TrackerKey MessageId  ϴ 
	 * @param trackerKey
	 * @param messageId
	 * @throws EbmsPersistantException
	 */
	/*public void saveMessageIdAndDocumentId(String documentId, String messageId) throws EbxmlPersistantException {
		try {
			new MessageIdAndDocumentIdDAO().insertMessageIdAndDocumentId(messageId, documentId);
		}
		catch(EbxmlPersistantException e) {
			if( e.getErrorCode() == Environment.duplicateErrorCode )
				new MessageIdAndDocumentIdDAO().updateMessageIdAndDocumentId(messageId, documentId);
			else 
				throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/
	
	/*public void insertMessageIdAndDocumentId(String documentId, String messageId) throws EbxmlPersistantException {
		try {
			TrackerDAO trackerDAO = new TrackerDAO();
			
			trackerDAO.insertMessageIdAndDocumentId(messageId, documentId);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/
	
	public void insertTrackerDetail(String messageId, String state, String information) throws EbmsPersistantException {
		TrackerDAO trackerDAO = new TrackerDAO();
		
		trackerDAO.insertTracker(messageId, new Date().getTime(), state, information);
	}



	/**
	  @since 2005.1.26
	   ޽ մϴ.( Ÿ  database    ޽ Ͽ )
	  @param msg
	  @return com.softmeca.ebmsh.message.packaging.EbxmlMessage
	  @roseuid 401482700266
	 */
	/*public void storeToFile(EbxmlMessage msg) throws EbxmlPersistantException  
	{	
		try {
			log.info("޽ մϴ.");
	
			file.store(msg);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/


	/**
	   @since 2005.1.26
		޽ մϴ.( Ÿ  database    ޽ Ͽ )
	   @param msg
	   @return com.softmeca.ebmsh.message.packaging.EbxmlMessage
	   @roseuid 401482700266
	 */
	/*public void storePayloadToFile(EbxmlMessage msg) throws EbxmlPersistantException  
	{	
		try {
			log.info("޽ մϴ.");
	
			file.storePayload(msg);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/
	
	
	/**
		 @since 2005.1.26
		  ޽ մϴ.( Ÿ  database    ޽ Ͽ )
		  鼭  ޽(Ÿ 忡  ޽)  
		 @param msg
		 @return com.softmeca.ebmsh.message.packaging.EbxmlMessage
		 @roseuid 401482700266
	 */
	/*public void storebySender(EbxmlMessage msg) throws SOAPException  
	{
		log.info( "޽ մϴ.");

		try{
			log.info( "insert(MessageId,TimeStamp,CPAId,FromPartyId,toParyId,ConversationId,Service,Action,MsgFileName,State.gotGeneralMsg) to MessageStore Table");
			db.insertMessageStore(msg);

			//2-5
			log.info(  "2-5 insert (MessageId,new Date()) to IncommingMessageInfo Table");
			db.insertIncomming(msg.getMessageId() ,new Date());
			//2-6
			log.info("2-6 store M1 to  filesystem." ); 
			//file.store( msg);
			if(msg.getEbxmlBody().hasManifest())
			{

				file.storePayload(msg);
			}
			//2-7

			//2-7-1
			log.info("2-7-1  ebxml message ¸ Status.gotGeneralMsg մϴ. ");

			db.insertOutgoing(msg.getMessageId());
			db.updateState(Status.sentGeneralMsg,msg.getMessageId() );

		}catch(PersistStoreFailureException e)
		{
			file.store(msg);
		}
	}*/

	public boolean isDuplicated(EbxmlMessage ebxmlMessage) throws EbmsPersistantException {
		boolean result = false;
		DuplicateMessageDAO duplicateMessageDAO = new DuplicateMessageDAO();

		if(duplicateMessageDAO.duplicatePrevention(ebxmlMessage, new Date().getTime())) 
			result = true;

		return result;
	}

	/*public boolean isDuplicated(EbxmlMessage ebxmlMessage) {
		boolean result = false;
		MessageId messageId = null;

		try {	
			messageId = ebxmlMessage.getEbxmlHeader().getMessageHeader().getMessageData().getMessagId();

			if(db.duplicatePrevention(messageId.getValue())) 
				result = true;

		}
		catch(PersistStoreFailureException e) {
			log.fatal( com.softmeca.ebmsh.message.util.MessageUtil.stackTraceToString(e));
		}
		catch(SOAPException e) {
			log.fatal( com.softmeca.ebmsh.message.util.MessageUtil.stackTraceToString(e));
		}

		return result;
	}*/


	public EbxmlMessage getMessage(String messageId) throws EbmsPersistantException {
		IncomingMessageDAO incomingMessageDAO = new IncomingMessageDAO();
		FileDAO fileDAO = new FileDAO();
		
		IncomingMessage incomingMessage = incomingMessageDAO.getInComingMessage(messageId);

		String filePath = EbmsConstants.messagePath + incomingMessage.getMSGFilePath();

		EbxmlMessage ebxmlMessage = fileDAO.getEbxmlMessageFromFile(filePath);

		return ebxmlMessage;
	}

	public EbxmlMessage getAckMessage(String messageId) throws EbmsPersistantException {
		AckMessageDAO ackMessageDAO = new AckMessageDAO();
		FileDAO fileDAO = new FileDAO();
		EbxmlMessage ebxmlMessage = null;

		AckMessage ackMessage = ackMessageDAO.getAckMessageByRefToMessageId(messageId);
		
		String filePath = EbmsConstants.messagePath + ackMessage.getACKFileName();

		ebxmlMessage = fileDAO.getEbxmlMessageFromFile(filePath);

		return ebxmlMessage;
	}

	
	
	public void saveDuplicateMessage(EbxmlMessage ebxmlMessage) throws EbmsPersistantException {
		GDuration persistDuration = new CpaManagerFactory().createInstance().getCpa(ebxmlMessage.getCPAId()).getPartyInfo(ebxmlMessage.getTo()).getPersistDurationbyReceiver(ebxmlMessage.getAction());
		long persistDurationLong = MessageUtil.gdurationToLong(persistDuration);		
		
		long checkEndTime = new Date().getTime() + persistDurationLong;
		
		try {
			new DuplicateMessageDAO().insertDuplicateMessage(ebxmlMessage, checkEndTime);
		}
		catch(EbmsPersistantException e) {
			if( e.getErrorCode() == EbmsConstants.duplicateErrorCode )
				new DuplicateMessageDAO().updateDuplicateMessage(ebxmlMessage, checkEndTime);
			else
				throw e;
		}
	}
	
	
	public void saveMessageStatus(EbxmlMessage ebxmlMessage, int messageStatus, String messageStatusDesc) throws EbmsPersistantException {
		try {
			new MessageStatusDAO().insertMessageStatus(ebxmlMessage, messageStatus, messageStatusDesc);
		}
		catch(EbmsPersistantException e) {
			if( e.getErrorCode() == EbmsConstants.duplicateErrorCode ) {
				new MessageStatusDAO().updateMessageStatus(ebxmlMessage, messageStatus, messageStatusDesc);
			}
			else
				throw e;
		}
	}
	
	
	public void saveMessageStatus(String messageId, int messageStatus, String messageStatusDesc) throws EbmsPersistantException {
		try {
			new MessageStatusDAO().insertMessageStatus(messageId, messageStatus, messageStatusDesc);
		}
		catch(EbmsPersistantException e) {
			if( e.getErrorCode() == EbmsConstants.duplicateErrorCode ) {
				new MessageStatusDAO().updateMessageStatus(messageId, messageStatus, messageStatusDesc);
			}
			else
				throw e;
		}
	}
	
	/*public void insertMessageStatus(EbxmlMessage ebxmlMessage, int messageStatus, String messageStatusDesc) throws EbxmlPersistantException {
		try {
			new MessageStatusDAO().insertMessageStatus(ebxmlMessage, messageStatus, messageStatusDesc);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}
	
	public void updateMessageStatus(EbxmlMessage ebxmlMessage, int messageStatus, String messageStatusDesc) throws EbxmlPersistantException {
		try {
			new MessageStatusDAO().updateMessageStatus(ebxmlMessage, messageStatus, messageStatusDesc);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/
	
	public void updateMessageStatus(String messageId, int messageStatus, String messageStatusDesc) throws EbmsPersistantException {
		try {
			new MessageStatusDAO().updateMessageStatus(messageId, messageStatus, messageStatusDesc);
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
	
	public void saveOutgoingMessageDbAndFile(EbxmlMessage ebxmlMessage, int status) throws EbmsPersistantException {
		try {
			log.info(" ޽  մϴ.");
			
			Date date = new Date();
			SimpleDateFormat sd = new SimpleDateFormat("yyyy-MM-dd");
			String dateDirectoryName = sd.format(date);
			
			String messageFilePath = FileIoUtil.fileSeparatorAddOrNone("outgoing") + FileIoUtil.fileSeparatorAddOrNone(dateDirectoryName)+ ebxmlMessage.getMessageId();
			
			log.info("Ͽ ޽  մϴ." );
			FileDAO fileDAO = new FileDAO();
			fileDAO.storeEbxmlMessageToFile(ebxmlMessage, EbmsConstants.messagePath + messageFilePath);
			
			log.info("DB OutgoingMessage   մϴ.");
			new OutgoingMessageDAO().insertOutgingMessage(ebxmlMessage, new Date().getTime(), status, messageFilePath);
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	// MessageOrder  
	//  
	/////////////////////////////////////////////////////////////////////////////////////////////////
	/*public void insertMessageOrder(EbxmlMessage ebxmlMessage) throws EbxmlPersistantException {
		try {
			db.insertMessageOrder(ebxmlMessage.getEbxmlHeader().getMessageHeader().getConversationId().getValue(), Integer.parseInt(ebxmlMessage.getEbxmlHeader().getMessageOrder().getSequenceNumber().getValue()), ebxmlMessage.getMessageId(), "Not Yet");
		}
		catch(SOAPException e) {
			throw new EbxmlPersistantException(1, 0, "޽  -> insertMessageOrder()", e);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/




	/*public EbxmlMessage getMONextMessage(EbxmlMessage ebxmlMessage) throws EbxmlPersistantException {
		try {
			EbxmlMessage nextEbxmlMessage = null;
			
			String conversationId = ebxmlMessage.getEbxmlHeader().getMessageHeader().getConversationId().getValue();
			int sequenceNumber = Integer.parseInt(ebxmlMessage.getEbxmlHeader().getMessageOrder().getSequenceNumber().getValue());
			String nextMessageId = db.getMONextMessageId(conversationId, sequenceNumber);

			//  ó ޽  
			if( nextMessageId != null)
				nextEbxmlMessage = this.getMessage(nextMessageId);
			
			return nextEbxmlMessage;
		}
		catch(SOAPException e) {
			throw new EbxmlPersistantException(1, 0, "޽  -> getMONextMessage()", e);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}		
	}*/


	/*public boolean isMOFirstMessage(EbxmlMessage ebxmlMessage) throws EbxmlPersistantException {
		
		try {
			boolean result = false;
			
			String conversationId = ebxmlMessage.getEbxmlHeader().getMessageHeader().getConversationId().getValue();
			result = db.hasConversationId(conversationId);
			
			return !result;
		}
		catch(SOAPException e) {
			throw new EbxmlPersistantException(1, 0, "޽  -> getMONextMessage()", e);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/


	/*public void insertInComingGroup(EbxmlMessage ebxmlMessage) throws EbxmlPersistantException {
		try {
			db.insertInComingGroup(ebxmlMessage.getEbxmlHeader().getMessageHeader().getConversationId().getValue(), -1);
		}
		catch(SOAPException e) {
			throw new EbxmlPersistantException(1, 0, "޽  -> insertInComingGroup()", e);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/

	/*public void deleteMessageOrderInfo(EbxmlMessage ebxmlMessage) throws EbxmlPersistantException {
		try {
			String conversationId = ebxmlMessage.getEbxmlHeader().getMessageHeader().getConversationId().getValue();

			if( db.hasConversationId(conversationId) ) {
				this.deleteInComingGroup(conversationId);
				this.deleteMessageOrder(conversationId);
			}
		}
		catch(SOAPException e) {
			throw new EbxmlPersistantException(1, 0, "޽  -> deleteMessageOrderInfo()", e);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/

	/*public void deleteInComingGroup(String conversationId) throws BizboxEbxmlMessageException, EbxmlPersistantException {
		try {
			db.deleteInComingGroup(conversationId);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	} */

	/*public void deleteMessageOrder(String conversationId) throws BizboxEbxmlMessageException, EbxmlPersistantException {
		try {
			db.deleteMessageOrder(conversationId);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/

	/*public int getMessageOrderLastSequenceNumber(EbxmlMessage ebxmlMessage) throws EbxmlPersistantException {
		try {
			int lastSequenceNumber = -1;
			String conversationId = ebxmlMessage.getEbxmlHeader().getMessageHeader().getConversationId().getValue();
			lastSequenceNumber = db.getMessageOrderLastSequenceNumber(conversationId);
			
			return lastSequenceNumber;
		}
		catch(SOAPException e) {
			throw new EbxmlPersistantException(1, 0, "޽  -> getMessageOrderLastSequenceNumber()", e);
		}	
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/

	/*public void updateIncomingGroupLastNumber(EbxmlMessage ebxmlMessage) throws EbxmlPersistantException {
		try {
			String conversationId = ebxmlMessage.getEbxmlHeader().getMessageHeader().getConversationId().getValue();

			db.updateIncomingGroupLastNumber(conversationId);
		}
		catch(SOAPException e) {
			throw new EbxmlPersistantException(1, 0, "޽  -> updateIncomingGroupLastNumber()", e);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/

	/*public void updateMessageOrderStatusOk(EbxmlMessage ebxmlMessage) throws EbxmlPersistantException {
		try {
			String conversationId = ebxmlMessage.getEbxmlHeader().getMessageHeader().getConversationId().getValue();
			String messageId = ebxmlMessage.getMessageId();

			db.updateMessageOrderStatusOk(conversationId, messageId);
		}
		catch(SOAPException e) {
			throw new EbxmlPersistantException(1, 0, "޽  -> updateMessageOrderStatusOk()", e);
		}
		catch(EbxmlPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new EbxmlPersistantException(1, 0, e);
		}
	}*/
	/////////////////////////////////////////////////////////////////////////////////////////////////
}