package org.kldp.ebmsh.message.persistant;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;

import org.apache.commons.dbutils.QueryRunner;
import org.kldp.ebmsh.config.EbmsConstants;



/**
 * " + Environment.bizboxDatabaseName + "Tracker " + Environment.bizboxDatabaseName + "Tracker_Detail DAO
 * 
 * @author Sirius
 * @since 2007-03-30
 * 
 */
public class TrackerDAO {
	/**
	 * " + Environment.bizboxDatabaseName + "Tracker_Detail  մϴ.
	 * 
	 * @param trackerKey
	 * @param trackingTime
	 * @param state
	 * @param information
	 * @throws EbmsPersistantException
	 */
	public void insertTracker(String messageId, long trackingTime, String state, String information) throws EbmsPersistantException {
		try {
			final String queryStr = "insert into " + EbmsConstants.bizboxDatabaseHeaderName + "Tracker(MessageId, TrackingTime, State, Information) values (?, ?, ?, ?)";
			
			final Object[] parameters = new Object[4];
			parameters[0] = messageId; // [0] MessageId
			parameters[1] = new Timestamp(trackingTime); // [1] TrackingTime
			//parameters[2] = new String(state.getBytes("euc-kr"), "8859_1"); // [2] State
			parameters[2] = state; // [2] State
			
			// TODO  ޽ ڸ
			if( information != null && information.length() > 100 ) 
				information = information.substring(0, 100);
			
			//parameters[3] = new String(information.getBytes("euc-kr"), "8859_1"); // [3] Inforamtion
			
			parameters[3] = information; // [3] Inforamtion
			
			
			DbTemplate dbTemplate = new DbTemplate();
			dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws EbmsPersistantException {
							QueryRunner runner = new QueryRunner();
							
							try {
								runner.update(_conn, queryStr, parameters);
							} catch (SQLException e) {
								throw new EbmsPersistantException(1, e.getErrorCode(), e);
							}
							
							return null;
						}
					}
				);
		}
		catch(EbmsPersistantException e) {
			throw e;
		}
	}
}