package org.kldp.ebmsh.message.processer.http;

import java.io.IOException;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.httpclient.HttpStatus;
import org.kldp.ebmsh.application.EbmsApplicationProcesserException;
import org.kldp.ebmsh.application.NonBlockingApplicationProcesser;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.packaging.validation.EbmsEbxmlValidationException;
import org.kldp.ebmsh.message.persistant.MessageStatusConstraints;
import org.kldp.ebmsh.message.processer.EbmsMessageProcesserException;
import org.kldp.ebmsh.message.processer.MessageProcesser;
import org.kldp.ebmsh.message.transport.EbxmlMessageSender;
import org.kldp.ebmsh.message.transport.EbmsTransportException;
import org.kldp.ebmsh.message.util.MessageBuilderUtil;
import org.kldp.ebmsh.message.util.MessageUtil;



/**
 * File name   - SyncMessageProcesser.java
 * Create date - May 18, 2007
 * Update time - May 18, 2007
 * Version     - v1.0
 *
 * Author      - Sirius
 * 
 * MshSignalsOnly  ۵Ǿϴ.
 * 
 * //TODO  sync mode ؼ ó ʿ.
 */
public class SyncMessageProcesser extends MessageProcesser {
	private HttpServletResponse response;
	
	/**
	 * Constructor
	 */
	public SyncMessageProcesser() {
	}
	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 *
	 * Author      - Sirius
	 *
	 * @param ebxmlMessage
	 * @param response
	 */
	public void process(EbxmlMessage ebxmlMessage, HttpServletResponse response) {
		this.response = response;
		
		ebXMLMessageProcess(ebxmlMessage);
	}

	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 *
	 * Author      - Sirius
	 *
	 * @param ebxmlMessage
	 * 
	 * AckRequested ִ ޽ óմϴ.
	 * 
	 * - Acknowledgment ޽ մϴ.
	 */
	protected boolean AckRequested(EbxmlMessage ebxmlMessage) throws EbmsMessageProcesserException {
		log.info("Acknowledgment ebXML ޽ մϴ.");
		
		// Acknoweldgment 
		log.info("Acknowledgment ebXML ޽ մϴ.");
		EbxmlMessage ackMessage = MessageBuilderUtil.buildAcknowledgmentMessage(ebxmlMessage);
		
		// Acknowledgment ޽ 
		log.info("Acknowledgment ebXML ޽ մϴ.");
		EbxmlMessageSender sender = new EbxmlMessageSender();				
		sender.sendMessageRedirect(ackMessage, response);
		
		return true;
	}

	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 *
	 * @Author      - Sirius
	 *
	 * @param ebxmlMessage
	 * 
	 * DuplicateElimination ִ ޽ óմϴ.
	 * 
	 * - ߺ  ִ  ޽ ó  մϴ.
	 */
	protected boolean DuplicateElimination(EbxmlMessage ebxmlMessage) throws EbmsMessageProcesserException {
		log.info("ߺ ޽ ˻մϴ.");
		
		if( persistantStorage.isDuplicated(ebxmlMessage) ) {
			log.info("ߺ ޽ Դϴ. ޽ ó  մϴ.");
			
			this.flushBuffer(response, HttpStatus.SC_OK);
			
			// ޽ ¸ Success 
			persistantStorage.saveMessageStatus(ebxmlMessage, MessageStatusConstraints.Success, "");
			
			return false;
		}
		else {
			log.info("ߺ ޽ ƴմϴ.");
			
			// ߺ ޽  
			log.info("ߺ ޽  մϴ.");
			persistantStorage.saveDuplicateMessage(ebxmlMessage);
			
			this.flushBuffer(response, HttpStatus.SC_OK);
			
			return true;
		}
	}

	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 *
	 * Author      - Sirius
	 *
	 * @param ebxmlMessage
	 * 
	 * DuplicateElimination, AckRequested ִ ޽ óմϴ.
	 * 
	 * - ߺ  ִ  ޽ ó  մϴ.
	 * - Acknowledgment ޽ մϴ.
	 */
	protected boolean DuplicateElimination_AckRequested(EbxmlMessage ebxmlMessage) throws EbmsMessageProcesserException {
		log.info("ߺ ޽ ˻մϴ.");
		
		if( persistantStorage.isDuplicated(ebxmlMessage) ) {
			log.info("ߺ ޽ Դϴ.");
			
			// Acknowledgment ޽ մϴ.
			log.info("PersistantStoreκ Acknowledgment ebXML ޽ մϴ.");
			EbxmlMessage ackMessage = persistantStorage.getAckMessage(ebxmlMessage.getMessageId());
			
			// Acknowledgment ޽ 
			log.info("Acknowledgment ebXML ޽ մϴ.");
			EbxmlMessageSender sender = new EbxmlMessageSender();				
			sender.sendMessageRedirect(ackMessage, response);
			
			// ޽ ¸ Success 
			persistantStorage.saveMessageStatus(ebxmlMessage, MessageStatusConstraints.Success, "");
			
			return false;
		}
		else {
			log.info("ߺ ޽ ƴմϴ.");
			
			// ߺ ޽  
			log.info("ߺ ޽  մϴ.");
			persistantStorage.saveDuplicateMessage(ebxmlMessage);
			
			// Acknoweldgment 
			log.info("Acknowledgment ebXML ޽ մϴ.");
			EbxmlMessage ackMessage = MessageBuilderUtil.buildAcknowledgmentMessage(ebxmlMessage);
			
			// Acknowledgment ޽  
			log.info("Acknowledgment ebXML ޽  մϴ.");
			
			persistantStorage.saveAckMessageToFile(ackMessage);
			
			persistantStorage.saveAckMessageInfo(ackMessage);
			
			// Acknowledgment ޽ 
			log.info("Acknowledgment ebXML ޽ մϴ.");
			EbxmlMessageSender sender = new EbxmlMessageSender();				
			sender.sendMessageRedirect(ackMessage, response);
			
			return true;
		}
	}

	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 *
	 * Author      - Sirius
	 *
	 * @param ebxmlMessage
	 */
	protected boolean Normal(EbxmlMessage ebxmlMessage) throws EbmsMessageProcesserException {
		this.flushBuffer(response, HttpStatus.SC_OK);
		
		return true;
	}

	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 *
	 * Author      - Sirius
	 *
	 * @param response
	 * @throws EbmsTransportException
	 */
	protected EbxmlMessage applicationLevelMessageProcess(EbxmlMessage ebxmlMessage) throws EbmsApplicationProcesserException {
		log.info("Non blocking application processer մϴ.");
		
		new NonBlockingApplicationProcesser().process(ebxmlMessage);
		
		return null;
	}

	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 *
	 * Author      - Sirius
	 *
	 * @param response
	 * @throws EbmsTransportException
	 */
	protected void sendResponseEbxmlMessage(EbxmlMessage responseEbxmlMessage) throws EbmsTransportException {
		EbxmlMessageSender sender = new EbxmlMessageSender();
		
		if( MessageUtil.isSystemLevelActionMessage(responseEbxmlMessage) )
			sender.sendMessageWithoutAction(responseEbxmlMessage);
		else
			sender.sendMessage(responseEbxmlMessage);
	}

	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 *
	 * @Author      - Sirius
	 *
	 * @param e
	 * 
	 * Http sync ebXML ޽ ó  ˼   ߻   ޽ ϴ .
	 */
	protected void sendUndefinedErrorMessage(Exception e, EbxmlMessage errorEbxmlMessage) throws EbmsTransportException {
		//  ޽ մϴ.
		EbxmlMessageSender sender = new EbxmlMessageSender();
		
		response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
		
		sender.sendMessageRedirect(errorEbxmlMessage, response);
	}

	
	/**
	 * Version     - v1.0
	 * Create time - May 23, 2007
	 * Update time - May 23, 2007
	 * 
	 * 
	 * 
	 * @Author      - Sirius
	 *
	 * @param e
	 * 
	 * Http sync ebXML ޽ ó    ߻   ޽ ϴ .
	 * 
	 * -      ޽ ٸ äη Ѵ.
	 */
	protected void sendValidationErrorMessage(EbmsEbxmlValidationException e, EbxmlMessage errorEbxmlMessage) throws EbmsTransportException {
		//  ޽ մϴ.
		EbxmlMessageSender sender = new EbxmlMessageSender();
		
		response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
		
		sender.sendMessageRedirect(errorEbxmlMessage, response);
	}
	
	
	/**
	 * FlushBuffer
	 * 
	 * @param response
	 * @throws IOException
	 */
	private void flushBuffer(HttpServletResponse response, int responseCode) throws EbmsTransportException {
		try {
			log.info("Flushbuffer ...");
			
			if( response != null && !response.isCommitted() ) {
				response.setStatus(HttpServletResponse.SC_OK);
				response.setContentLength(0);
				
				response.flushBuffer();
			}
		}
		catch(IOException e) {
			throw new EbmsTransportException(1, 0, "FlushBuffer ", e);
		}
	}
}
