package org.kldp.ebmsh.message.transport.rm;
//
//  @ Date : 2006-02-03
//  @ Author : Seung min 
//

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.transport.EbmsTransportException;



/**
 * AckReceiver Class
 * 
 * Acknowledgement ޴ Ŭ
 * 
 * @author Sirius
 * */
public class AckReceiveNotifier {	
	private final static Log log = LogFactory.getLog(AckReceiveNotifier.class);
	private final static AckReceiveNotifier instance = new AckReceiveNotifier();
	private RMManager rmManager = null;
	
    /**
	 * .
	 */
	private AckReceiveNotifier() {
		rmManager = RMManager.getInstance();
	}
	
	public static AckReceiveNotifier getInstance() {
		return instance;
	}
	
	public void receiveAck(String _refToMessageId)  {
		if( checkAckMessage(_refToMessageId) ) {
			// ٸ ޽ °
			log.info("ùٸ ACKԴϴ. RefToMessageId -> " + _refToMessageId);
			
			rmManager.removeAckRequestMessage(_refToMessageId);
		}
		else {
			// ٸ ʴ ޽ °
			log.info("ġ  ACKԴϴ.");
		}
	}
	
	private boolean checkAckMessage(String refToMessageId) {
		if(rmManager.isAckWaitMessage(refToMessageId)) 
			return true;
		else
			return false;
	}
}