package org.kldp.ebmsh.message.transport.rm;
//
//  @ Date : 2006-02-03
//  @ Author : Seung min 
//

import java.util.TimerTask;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.transport.EbxmlMessageSender;
import org.kldp.ebmsh.message.transport.EbmsTransportException;
import org.kldp.ebmsh.message.util.MessageUtil;



/**
 * AckRequestSender Class
 * 
 * Ack Request  Ŭ 
 * TimerTask ӹ޾ 췯  Ѵ.
 * */
class AckRequestSender extends TimerTask {
	private static Log log = LogFactory.getLog(AckRequestSender.class);
	private EbxmlMessage ebxmlMessage;	
	private int nowRetryCount;
	private int maxRetryCount;
	
	/**
	 * @param messageId  ޽ Id
	 * @param maxRetryCount ִ Retry Ƚ
	 * 
	 * 
	 */
	public AckRequestSender(EbxmlMessage ebxmlMessage, int maxRetryCount) {
		this.ebxmlMessage = ebxmlMessage;
		this.nowRetryCount = -1;
		this.maxRetryCount = maxRetryCount;
	}
	
	
	/**
	 * Scheduler  ð ϴ ޼
	 * */
	public void run() {
		try {
			if( nowRetryCount < maxRetryCount ) {
				nowRetryCount++;
				
				log.info("RM ޽ մϴ. ");
				log.info("Sending message id -> " + ebxmlMessage.getMessageId());
				log.info("Now retry count -> " + this.nowRetryCount);
				
				new EbxmlMessageSender().sendMessageWithoutAction(ebxmlMessage);
				
				log.info("RM ޽  մϴ.");
				
				log.info(ebxmlMessage.getMessageId() + " sending ok.\n");
			}
		}
		finally {
			if( nowRetryCount >= maxRetryCount ) {
				log.info("Message sending failed");
				log.info("Message id -> " + ebxmlMessage.getMessageId());
				
				RMManager.getInstance().removeAckRequestMessage(ebxmlMessage.getMessageId());
			}
		}
	}
}