package org.kldp.ebmsh.message.transport.rm;
//
//  @ Date : 2006-02-03
//  @ Author : Seung min 
//

import java.util.Hashtable;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


/**
 * Reliable messaging  
 * 
 * Singleton 
 */
public class RMManager {
	private final static Log log = LogFactory.getLog(RMManager.class);
	private Hashtable ackRequestSenderTable = new Hashtable();
		
	private final static RMManager instance = new RMManager();

	private static int senderCount = 0;
	
	/**
	 * 
	 */
	private RMManager() {
	}
	
	
	/**
	 * @return RMManager
	 * 
	 * RMManager ü  ޼
	 */
	public static RMManager getInstance() {
		return instance;
	}
	
	
	/**
	 * @param ebxmlMessage AckRequest ڸ  ִ ebxmlMessage
	 * @param ackRequestSender AckRequest ޽ ϴ Sender
	 * 
	 * AckRequestMessage ߰ 
	 */
	public void addAckRequestMessage(String messageId, AckRequestSender ackRequestSender) {
		senderCount++;
		
		log.info("RMSENDER  - " + senderCount);
		ackRequestSenderTable.put(messageId, ackRequestSender);
	}
	
	
	/**
	 * @param ebxmlMessage AckRequest ڸ  ִ ebxmlMessage
	 * @param ackRequestSender AckRequest ޽ ϴ sender
	 * 
	 * AckRequestMessage 
	 */
	public void removeAckRequestMessage(String refToMessageId) {
		senderCount--;
		
		log.info("RMSENDER  - " + senderCount);
		AckRequestSender _ackRequestSender = (AckRequestSender)ackRequestSenderTable.get(refToMessageId);
		_ackRequestSender.cancel();
		
		ackRequestSenderTable.remove(refToMessageId);
	}
	
	
	/**
	 * @param refToMessageId  ACK  Message ID
	 * 
	 * ڷ  refToMessageId  Acknowledgement ٸ Ȯ
	 */
	public boolean isAckWaitMessage(String refToMessageId) {
		if( ackRequestSenderTable.get(refToMessageId) != null )
			return true;
		else
			return false;
	}
}