package org.kldp.ebmsh.message.transport.rm;
//
//  @ Date : 2006-02-03
//  @ Author : Seung min 
//

import java.util.Timer;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.cpa.EbmsCpaException;
import org.kldp.ebmsh.cpa.Cpa;
import org.kldp.ebmsh.cpa.CpaManagerFactory;
import org.kldp.ebmsh.cpa.PartyInfo;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.transport.EbmsTransportException;


/**
 * RMSender Class
 * 
 * @author Sirius
 * 
 * AckRequest Ʈ Ե ޽  Ŭ
 * */
public class RMSender {
	private final static Log log = LogFactory.getLog(RMSender.class);
	
	
	/**
	 * @param ebxmlMessage  ebxmlMessage
	 */
	public void sendMessage(EbxmlMessage ebxmlMessage) throws EbmsTransportException {
		try {
			RMManager rmManager = RMManager.getInstance();
			
			String from = ebxmlMessage.getFrom();
			
			Cpa cpa = new CpaManagerFactory().createInstance().getCpa(ebxmlMessage.getCPAId());
			PartyInfo fromPartyInfo = cpa.getPartyInfo(from);
			
			int maxRetryCount = fromPartyInfo.getReliableMessagebySenderUnderDocExchange(ebxmlMessage.getAction()).getRetries();
			int retryInterval = fromPartyInfo.getReliableMessagebySenderUnderDocExchange(ebxmlMessage.getAction()).getRertryInterval().getSecond();
			long retryIntervalLong = retryInterval * 1000L;		
			
			AckRequestSender ackRequestSender = new AckRequestSender(ebxmlMessage, maxRetryCount);
			
			rmManager.addAckRequestMessage(ebxmlMessage.getMessageId(), ackRequestSender);
			
			addEbxmlMessageAtScheduler(ackRequestSender, retryIntervalLong);
		}
		catch(EbmsCpaException e) {
			throw new EbmsTransportException(1, 0, e);
		}
	}
	
	
	/**
	 * @param ackRequestSender AckRequestSender
	 * @param retryInterval CPA  Retry 
	 */
	private void addEbxmlMessageAtScheduler(AckRequestSender ackRequestSender, long retryInterval) {
		Timer jobScheduler = new Timer(true);
		
		jobScheduler.scheduleAtFixedRate(ackRequestSender, 0, retryInterval);
	}
}
