//Source file: c:\\code\\com\\softmeca\\ebmsh\\message\\util\\MessageUtil.java

package org.kldp.ebmsh.message.util;

import java.io.ByteArrayOutputStream;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Random;
import java.util.TimeZone;

import javax.mail.internet.ContentType;
import javax.mail.internet.MimeBodyPart;
import javax.xml.soap.MimeHeaders;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPFactory;
import javax.xml.soap.SOAPMessage;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xmlbeans.GDuration;
import org.kldp.ebmsh.cpa.EbmsCpaException;
import org.kldp.ebmsh.cpa.Cpa;
import org.kldp.ebmsh.cpa.PartyInfo;
import org.kldp.ebmsh.message.packaging.EbmsEbxmlMessageException;
import org.kldp.ebmsh.message.packaging.EBXMLMimeMultipart;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.packaging.RefToMessageId;
import org.kldp.ebmsh.message.packaging.TimeToLive;
import org.kldp.ebmsh.message.packaging.impl.EbxmlMessageFactoryImpl;
import org.kldp.ebmsh.message.packaging.impl.EbxmlMessageImpl;
import org.kldp.ebmsh.message.security.EbmsKeyStoreException;
import org.kldp.ebmsh.message.security.EbmsSignException;
import org.kldp.ebmsh.message.security.EbmsSignature;
import org.kldp.util.log.LogUtil;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;


/**
 @author pio
 @version 0.0
 @since 2003.1.1


 2006 3 20
 - SyncReply, AckRequest, DuplicateElimination CPA üũϰ EbxmlMessage ߰ϴ ޼ ߰
 */
public class MessageUtil 
{

	private static Log log = LogFactory.getLog(MessageUtil.class);

	/**
   @since 2003.1.1
   @roseuid 400B3609018E
	 */
	public MessageUtil() 
	{    
	}

	public static void lookingGood(EbxmlMessage msg)
	{



		try{

			// Create transformer
			TransformerFactory tff = TransformerFactory.newInstance();
			Transformer tf = tff.newTransformer();

			// Get reply content
			Source sc = msg.getSOAPPart().getContent();

			// Set output transformation
			StreamResult result = new StreamResult(System.out);
			tf.transform(sc, result);
			System.out.println();

		}catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e));
		}

	}
	/**
   @since 2003.1.1

   MessageId uniqueϰ ͱ׷ ش.
   To,cpaid,service,action ̿ؼ .
   @param partyTo
   @param CPAId
   @param service
   @param action
   @return java.lang.String
   @roseuid 400B361A0016
	 */
	//TODO 켱 hermes Ѵ.
	public static String generateMessageId(String partyTo, String CPAId, String service, String action) 
	{
		final Calendar c =
			Calendar.getInstance(TimeZone.getTimeZone("GMT"));
		c.setTime(new Date());
		String year = String.valueOf(c.get(Calendar.YEAR));
		for ( ; year.length()<4 ; year = "0" + year);
		String month = String.valueOf(c.get(Calendar.MONTH)+1);
		for ( ; month.length()<2 ; month = "0" + month);
		String day = String.valueOf(c.get(Calendar.DAY_OF_MONTH));
		for ( ; day.length()<2 ; day = "0" + day);
		String hour = String.valueOf(c.get(Calendar.HOUR_OF_DAY));
		for ( ; hour.length()<2 ; hour = "0" + hour);
		String minute = String.valueOf(c.get(Calendar.MINUTE));
		for ( ; minute.length()<2 ; minute = "0" + minute);
		String second = String.valueOf(c.get(Calendar.SECOND));
		for ( ; second.length()<2 ; second = "0" + second);
		String milliSecond = String.valueOf(c.get(Calendar.MILLISECOND));
		for ( ; milliSecond.length()<3 ; milliSecond = "0" + milliSecond);
		int localCounter;

		Random r = new Random();

		final StringBuffer localPart = new StringBuffer();
		localPart.append(year).append(month).append(day).append("-");
		localPart.append(hour).append(minute).append(second)
		.append(milliSecond).append("-").append(CPAId).append(".");
		localPart.append("service" + String.valueOf(r.nextInt())).append(".").append(action).append(".");


		String domain = "unknownDomain";
		try {
			InetAddress localAddr = InetAddress.getLocalHost();
			domain = localAddr.getHostAddress();
		}
		catch (UnknownHostException e) {}

		final String messageId = localPart.toString() + "@" + domain;

		return messageId;
	}

	/**
	 @since 2003.1.1

	 MessageId uniqueϰ ͱ׷ ش.
	 To,cpaid,service,action ̿ؼ .
	 @param partyTo
	 @param CPAId
	 @param service
	 @param action
	 @return java.lang.String
	 @roseuid 400B361A0016
	 */
	//TODO 켱 hermes Ѵ.
	public static String generateShortMessageId(String partyTo, String CPAId, String service, String action) 
	{
		final Calendar c =
			Calendar.getInstance(TimeZone.getTimeZone("GMT"));
		c.setTime(new Date());
		String year = String.valueOf(c.get(Calendar.YEAR));
		for ( ; year.length()<4 ; year = "0" + year);
		String month = String.valueOf(c.get(Calendar.MONTH)+1);
		for ( ; month.length()<2 ; month = "0" + month);
		String day = String.valueOf(c.get(Calendar.DAY_OF_MONTH));
		for ( ; day.length()<2 ; day = "0" + day);
		String hour = String.valueOf(c.get(Calendar.HOUR_OF_DAY));
		for ( ; hour.length()<2 ; hour = "0" + hour);
		String minute = String.valueOf(c.get(Calendar.MINUTE));
		for ( ; minute.length()<2 ; minute = "0" + minute);
		String second = String.valueOf(c.get(Calendar.SECOND));
		for ( ; second.length()<2 ; second = "0" + second);
		String milliSecond = String.valueOf(c.get(Calendar.MILLISECOND));
		for ( ; milliSecond.length()<3 ; milliSecond = "0" + milliSecond);
		int localCounter;

		Random r = new Random();

		final StringBuffer localPart = new StringBuffer();
		localPart.append(year).append(month).append(day).append("-");
		localPart.append(hour).append(minute).append(second)
		.append(milliSecond);
		localPart.append(action);



		final String messageId = localPart.toString();

		return messageId;
	}

	public static String getMessage(EbxmlMessage em)
	{
		ByteArrayOutputStream bo = new ByteArrayOutputStream();
		try{


			em.writeTo(bo);
		}catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e));
		}
		return bo.toString();
	}


	public static String getSOAPMessage(SOAPMessage em)
	{
		ByteArrayOutputStream bo = new ByteArrayOutputStream();
		try{


			em.writeTo(bo);
		}catch(Exception e)
		{
			log.fatal( LogUtil.stackTraceToString(e));
		}
		return bo.toString();
	}

	/**
   @since 2003.1.1
   ð utc String ٲش.
   @param date
   @return java.lang.String
   @roseuid 400B36290036
	 */
	//TODO 켱 hermes  ״ Ѵ.
	public static String dateToUTC(Date date) 
	{

		final Calendar c =
			Calendar.getInstance(TimeZone.getTimeZone("GMT"));
		c.setTime(date);
		String year = String.valueOf(c.get(Calendar.YEAR));
		for ( ; year.length()<4 ; year = "0" + year);
		String month = String.valueOf(c.get(Calendar.MONTH)+1);
		for ( ; month.length()<2 ; month = "0" + month);
		String day = String.valueOf(c.get(Calendar.DAY_OF_MONTH));
		for ( ; day.length()<2 ; day = "0" + day);
		String hour = String.valueOf(c.get(Calendar.HOUR_OF_DAY));
		for ( ; hour.length()<2 ; hour = "0" + hour);
		String minute = String.valueOf(c.get(Calendar.MINUTE));
		for ( ; minute.length()<2 ; minute = "0" + minute);
		String second = String.valueOf(c.get(Calendar.SECOND));
		for ( ; second.length()<2 ; second = "0" + second);
		String timeStamp = year + "-" + month + "-" + day + "T" + hour + ":"
		+ minute + ":" + second + "Z";

		return timeStamp;
	}

	/**
   @since 2003.1.1
   utc String Dateü  ش.
   @param utcString
   @return java.util.Date
   @roseuid 400B3AD60394
	 */
	//TODO 켱 hermes  Ѵ.
	public static Date utcToDate(String utcString) 
	{

		try {
			ArrayList parts = new ArrayList();
			int i, j;
			for (i = 0, j = 0; i < utcString.length(); i++) {
				if ("-+:TZ.".indexOf(utcString.charAt(i)) != -1 ||
						i == utcString.length() - 1) {
					parts.add(utcString.substring(j, i));
					j = i + 1;
				}
			}



			// Check if all date/time components exist or not
			int count = parts.size();


			if (count < 6) return null;



			int year = Integer.parseInt((String)parts.get(0));
			int month = Integer.parseInt((String)parts.get(1));
			int day = Integer.parseInt((String)parts.get(2));
			int hour = Integer.parseInt((String)parts.get(3));
			int minute = Integer.parseInt((String)parts.get(4));
			int second = Integer.parseInt((String)parts.get(5));

			if (count == 8) {
				int hourOffset = Integer.parseInt((String)parts.get(6));
				int minOffset = Integer.parseInt((String)parts.get(7));
				if (utcString.indexOf("+") != -1) {
					hour -= hourOffset;
					minute -= minOffset;
				}
				else {
					hour += hourOffset;
					minute += minOffset;
				}
			}

			final Calendar c =
				Calendar.getInstance(TimeZone.getTimeZone("GMT"));
			c.clear();

			// In Calendar class, January = 0
			c.set(year, month - 1, day, hour, minute, second);

			return c.getTime();

		} catch (NumberFormatException nfe) {
			nfe.printStackTrace();
			return null;
		}
	}
	//Section: QuangHung add 
	/*
	 * input: UTC Duration Data Type
	 * output: long value of milliseconds
	 */
	public long convertUTCDuration(String utcDuration)
	{
		long millisecond = 0;
		String temp = utcDuration.substring(utcDuration.indexOf("P"));

		String day =  temp.substring(0,temp.indexOf("T"));
		String time = temp.substring(temp.indexOf("T")+1);
		String[] utc = new String[6];
		if(day.length() > 0){
			utc[0] = day.substring(0,day.indexOf('Y'));
			utc[1] = day.substring(day.indexOf('Y')+1,day.indexOf('M'));
			utc[2] = day.substring(day.indexOf('M')+1,day.indexOf('D'));
		}
		if(time.length() > 0){	
			utc[3] = time.substring(0,time.indexOf('H'));
			utc[4] = time.substring(time.indexOf('H')+1,time.indexOf("M"));
			utc[5] = time.substring(time.indexOf('M')+1,time.indexOf("S"));
		}
		int[] millis = new int[6];
		for(int i = 0; i < 6; i ++)
		{
			if(utc[i].length() > 0){
				switch(i){
				case 0:
					millisecond += Integer.parseInt(utc[i])*365*24*3600;
					break;
				case 1:{
					millisecond += Integer.parseInt(utc[i])*30*24*3600;
					break;
				}
				case 2:{
					millisecond += Integer.parseInt(utc[i])*24*3600;
					break;
				} 
				case 3:{
					millisecond += Integer.parseInt(utc[i])*3600;
					break;
				}
				case 4:{
					millisecond += Integer.parseInt(utc[i])*60;
					break;
				}
				case 5:{
					millisecond += Integer.parseInt(utc[i]);
					break;					 	 		
				}
				}
			}
		}
		return (millisecond*1000);
	}


	/*public static long getMessageEndTime(long receiveTime, EbxmlMessage ebxmlMessage) {
	   GDuration persistDuration = CpaManager.getInstance().getCPA(ebxmlMessage.getCPAId()).getPartyInfo(ebxmlMessage.getTo()).getPersistDurationbyReceiver(ebxmlMessage.getAction());
	   long persistDurationLong = MessageUtil.gdurationToLong(persistDuration);		
	   log.info("PersistDuration -> str:" + persistDuration + " long:" + persistDurationLong);

	   java.util.Date endTime = new java.util.Date(receiveTime + persistDurationLong);

	   log.info("ReceiveTime -> " + receiveTime);
	   log.info("EndTime -> " + endTime.getTime());

	   return endTime.getTime();
   }*/

	// Seung min ( 2006-2-10 )
	// GDuration long(TimeMillisecond) ȯش.
	public static long gdurationToLong(GDuration duration) {
		long time = 0;

		//org.apache.xmlbeans.GDuration du = new GDuration("PT45S");

		java.util.Calendar calendar = java.util.Calendar.getInstance();	   
		calendar.set(duration.getYear(), duration.getMonth(), duration.getDay(), duration.getHour(), duration.getMinute(), duration.getSecond());

		java.util.Calendar calendar_ = java.util.Calendar.getInstance();	   
		calendar_.set(0, 0, 0, 0, 0, 0);

		time = calendar.getTimeInMillis() - calendar_.getTimeInMillis();

		return time;
	}


	
	public static SOAPElement convertDOMToSOAPElement(SOAPEnvelope env, org.w3c.dom.Node DOMNode)throws SOAPException{		 
		if((DOMNode.getNodeType()) != org.w3c.dom.Node.ELEMENT_NODE)
			throw new SOAPException("DOMNode must of type ELEMENT_NODE");



		SOAPFactory sef = SOAPFactory.newInstance();
		SOAPElement se = sef.createElement(DOMNode.getLocalName(), DOMNode.getPrefix(), DOMNode.getNamespaceURI());

		if (DOMNode.hasAttributes()){
			NamedNodeMap DOMAttributes = DOMNode.getAttributes();

			int noOfAttributes = DOMAttributes.getLength();

			for(int i = 0; i < noOfAttributes; i++){
				org.w3c.dom.Node attr = DOMAttributes.item(i);
				se.addAttribute(env.createName(attr.getLocalName(), attr.getPrefix(),
						attr.getNamespaceURI()), attr.getNodeValue());
			}
		}


		if(DOMNode.hasChildNodes()){ 
			NodeList children = DOMNode.getChildNodes();

			for(int i = 0; i< children.getLength(); i++){
				org.w3c.dom.Node child = children.item(i);

				switch(child.getNodeType()) {
				case org.w3c.dom.Node.PROCESSING_INSTRUCTION_NODE: 
					break;

				case org.w3c.dom.Node.DOCUMENT_TYPE_NODE: 
					break;

				case org.w3c.dom.Node.TEXT_NODE: {
					se.addTextNode(child.getNodeValue());
					break;
				}

				default:		
					se.addChildElement(convertDOMToSOAPElement(env, child));
				}

			}//end of for
		}//end of if

		return se;
	}


	public static String buildMimepartEbxmlMessage(EbxmlMessage ebxmlMessage) {
		try {
			String resultEbxmlMessageString = null;

			MimeHeaders mimeHeaders = ebxmlMessage.getMimeHeaders();

			String contentType = mimeHeaders.getHeader("Content-Type")[0];

			if( contentType.startsWith("text/xml") ) {
				ByteArrayDataSource bas = new ByteArrayDataSource(MessageUtil.getSOAPMessage(ebxmlMessage), "text/xml");
				EBXMLMimeMultipart mp = new EBXMLMimeMultipart(bas);

				MimeBodyPart mb = mp.getRootPart();

				MultipartDataSource ds = new MultipartDataSource(MessageUtil.getSOAPMessage(ebxmlMessage));
				ds.setContentTypeAndId(mb.getContentType(), mb.getContentID());

				ContentType ct = mp.getContentType();
				String bnd = ct.getParameter("boundary");

				ds.setBoundary(bnd);

				resultEbxmlMessageString = ds.getString();
			}
			else if( contentType.startsWith("multipart/related") )
				resultEbxmlMessageString = ebxmlMessage.toString();

			return resultEbxmlMessageString;
		}
		catch(Exception e) {
			e.printStackTrace();

			return null;
		}
	}

	public static boolean isMimepartEbxmlMessage(EbxmlMessage ebxmlMessage) {
		try {
			MimeHeaders mimeHeaders = ebxmlMessage.getMimeHeaders();

			String contentType = mimeHeaders.getHeader("Content-Type")[0];

			if( contentType.startsWith("multipart/related") )
				return true;

			return false;
		}
		catch(Exception e) {
			e.printStackTrace();

			return false;
		}
	}
	

	/**
	 * Version     - v1.0
	 * Create time - May 9, 2007
	 * Update time - May 9, 2007
	 *
	 * Author      - Sirius
	 *
	 * @param action
	 * @return
	 * 
	 * ý ޽ Ȯմϴ.
	 */
	public static boolean isSystemLevelActionMessage(EbxmlMessage ebxmlMessage) {
		String action = ebxmlMessage.getAction();
		
		if(action.equals("Acknowledgment") || 
			action.equals("MessageStatusRequest") || 
			action.equals("MessageStatusResponse") || 
			action.equals("MessageError") || 
			action.equals("Ping") || 
			action.equals("Pong") ) {
			return true;
		}
		else {
			return false;
		}
	}
}