package org.kldp.ebmsh.queue;

import java.util.Hashtable;

import javax.jms.Queue;
import javax.jms.QueueConnectionFactory;
import javax.naming.NamingException;

import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.util.j2ee.resource.QueueConnectionFactoryServiceLocator;
import org.kldp.util.j2ee.resource.QueueServiceLocator;

public class ToApplicationQueueManager {
	private final static ToApplicationQueueManager instance = new ToApplicationQueueManager();
	
	private Hashtable toApplicationQueues = null;
	
	private ToApplicationQueueManager() {
		toApplicationQueues = new Hashtable();
	}
	
	public static ToApplicationQueueManager getInstance() {
		return instance;
	}
	
	public QueueHelper getToApplicationQueueHelper(String queueDestName) throws EbmsQueueException {
		QueueHelper queue = null;
		
		if( !toApplicationQueues.containsKey(queueDestName) )
			addNewToApplicationQueueManager(queueDestName);
		
		queue = (QueueHelper)toApplicationQueues.get(queueDestName);
		
		return queue;
	}
	
	private void addNewToApplicationQueueManager(String queueDestName) throws EbmsQueueException {
		try {
			QueueConnectionFactoryServiceLocator queueConnectionFactoryResource = QueueConnectionFactoryServiceLocator.getInstance();
			QueueServiceLocator queueResource = QueueServiceLocator.getInstance();
			QueueConnectionFactory queueConnectionFactory = queueConnectionFactoryResource.getQueueConnectionFactory(EbmsConstants.queueConnectionFactoryName);
			Queue queue = queueResource.getQueue(queueDestName);
			
			QueueHelper queueHelper = new QueueHelper(queueConnectionFactory, queue);
			
			toApplicationQueues.put(queueDestName, queueHelper);
		}
		catch(NamingException e) {
			throw new EbmsQueueException(1, 0, e);
		}
	}
}