package org.kldp.ebmsh.tracker;

import javax.jms.Queue;
import javax.jms.QueueConnectionFactory;
import javax.naming.NamingException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.message.persistant.PersistantStorage;
import org.kldp.ebmsh.message.util.MessageUtil;
import org.kldp.ebmsh.queue.QueueHelper;
import org.kldp.ebmsh.queue.TrackerMessage;
import org.kldp.ebmsh.queue.TrackerMessageConverter;
import org.kldp.util.j2ee.resource.QueueConnectionFactoryServiceLocator;
import org.kldp.util.j2ee.resource.QueueServiceLocator;


/**
 * Tracker Ŭ
 * 
 * TrackerQueue Tracker ޽ Ѵ.
 * 
 * @author	Sirius
 * @since	2007-3-9
 */
public class Tracker {
	private final static Log log = LogFactory.getLog(Tracker.class);
	private static boolean isInited;
	private static QueueHelper queueHelper;
	
	/**
	 * Unable constructor
	 */
	private Tracker() { }
	
	
	/**
	 * ʱȭ ۾
	 * 
	 * @throws NamingException ť ã  ߻
	 */
	private static void init() throws EbmsTrackerException {
		QueueServiceLocator queueResource = QueueServiceLocator.getInstance();
		QueueConnectionFactoryServiceLocator queueConnectionFactoryResource = QueueConnectionFactoryServiceLocator.getInstance();
		
		try {
			QueueConnectionFactory queueConnectionFactory = queueConnectionFactoryResource.getQueueConnectionFactory(EbmsConstants.queueConnectionFactoryName);
			Queue queue = queueResource.getQueue(EbmsConstants.queueJNDIHeaderName + EbmsConstants.trackerQueueName);
			
			queueHelper = new QueueHelper(queueConnectionFactory, queue);
		}
		catch(NamingException e) {
			throw new EbmsTrackerException(0, 0, "Queue resource   ϴ.", e);
		}
	}
	
	
	/**
	 * Tracking  Queue ϴ.
	 * 
	 * @param trackerKey
	 * @param timestamp
	 * @param state
	 * @param information
	 */
	public static void tracking( String messageId, java.util.Date timestamp, String state, String information ) {
		// ʱȭ ۾ 
		// Synchronized ̿  ʱȭ  Ǵ° Ѵ.
		synchronized (Tracker.class) {
			if( isInited == false ) {
				init();
				
				isInited = true;
			}	
		}
		
		if( information == null )
			information = "";
		
		// Tracker ޽ 
		TrackerMessage trackerMessage = new TrackerMessage();			
		trackerMessage.setMessageId(messageId);
		trackerMessage.setTimestamp(timestamp);
		trackerMessage.setState(state);
		trackerMessage.setInformation(information);
		
		// QueueHelper ̿ TrackerQueue ޽ 
		queueHelper.sendMessage(trackerMessage, new TrackerMessageConverter());
	}
}