package org.kldp.ebmsh.message.processer;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import javax.servlet.*;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.config.EbmsConfigException;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.config.EbmsProperties;
import org.kldp.util.io.FileIoUtil;


public class EbmsInitializer implements ServletContextListener{
	private static Log log = LogFactory.getLog(EbmsInitializer.class);
	
	public void contextInitialized(ServletContextEvent servletContextEvent) {
		// Bizbox engine ʿ  Ŭ 
		System.setProperty("javax.xml.soap.MessageFactory", "com.sun.xml.messaging.saaj.soap.MessageFactoryImpl");
		System.setProperty("javax.xml.soap.SOAPFactory", "com.sun.xml.messaging.saaj.soap.SOAPFactoryImpl");
		System.setProperty("javax.xml.parsers.DocumentBuilderFactory", "com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl");
		
		// bizbox ȯ    Ǿ Ȯմϴ.
		String currentPath = servletContextEvent.getServletContext().getRealPath("/");
		
		String bizboxRootPath = FileIoUtil.fileSeparatorAddOrNone(new File(currentPath).getParent()); 
		
		String bizboxConfigPath = bizboxRootPath + "config" + File.separator  + "ebmsConfig.properties";
		
		File bizboxConfigFile = new File(bizboxConfigPath);
		
		log.info("Bizbox ġ : " + bizboxRootPath);
		
		if( bizboxConfigFile.exists() ) {
			// Config file ϴ 
			//    Environment Ŭ մϴ.
			log.info("Bizbox   ε մϴ.");
			log.info("Bizbox  : " + bizboxConfigPath);
			
			try {
				// Bizbox ġ 丮 
				EbmsConstants.bizboxDirectory = FileIoUtil.fileSeparatorAddOrNone( bizboxRootPath );
				
				
				// Properties BizboxProperties wrapping
				Properties properties = new Properties();
				
				properties.load(new FileInputStream(EbmsConstants.bizboxDirectory + "config" + File.separator  + "ebmsConfig.properties"));
				
				EbmsProperties bizboxProperties = new EbmsProperties(properties);
				
				EbmsConstants.cpaPath = FileIoUtil.fileSeparatorAddOrNone( EbmsConstants.bizboxDirectory + bizboxProperties.getCpaPath() );				
				log.info("cpaPath -> " + EbmsConstants.cpaPath);
				
				EbmsConstants.messagePath = FileIoUtil.fileSeparatorAddOrNone( EbmsConstants.bizboxDirectory + bizboxProperties.getMessagePath() );
				log.info("messagePath -> " + EbmsConstants.messagePath);
				
				EbmsConstants.keyStoreType = bizboxProperties.getKeyStoreType();
				log.info("keyStoreType -> " + EbmsConstants.keyStoreType);
				
				EbmsConstants.keyStorePath = FileIoUtil.fileSeparatorAddOrNone( EbmsConstants.bizboxDirectory + bizboxProperties.getKeyStorePath() );
				log.info("keyStorePath -> " + EbmsConstants.keyStorePath);
				
				EbmsConstants.keyStorePassword = bizboxProperties.getKeyStorePassword();
				log.info("keyStorePassword -> " + EbmsConstants.keyStorePassword);
				
				EbmsConstants.keyPassword = bizboxProperties.getKeyPassword();
				log.info("keyPassword -> " + EbmsConstants.keyPassword);
				
				EbmsConstants.csrPath = FileIoUtil.fileSeparatorAddOrNone( EbmsConstants.bizboxDirectory + bizboxProperties.getCsrPath() );
				log.info("csrPath -> " + EbmsConstants.csrPath);
				
				EbmsConstants.queueConnectionFactoryName = bizboxProperties.getQueueConnectionFactoryName();
				log.info("queueConnectionFactoryName -> " + EbmsConstants.queueConnectionFactoryName);
				
				EbmsConstants.queueJNDIHeaderName = bizboxProperties.getQueueJNDIHeaderName();
				log.info("queueJNDIHeaderName -> " + EbmsConstants.queueJNDIHeaderName);
				
				EbmsConstants.applicationResultQueueName = bizboxProperties.getApplicationResultQueueName();
				log.info("applicationResultQueueName -> " + EbmsConstants.applicationResultQueueName);
				
				EbmsConstants.trackerQueueName = bizboxProperties.getTrackerQueueName();
				log.info("trackerQueueName -> " + EbmsConstants.trackerQueueName);
				
				EbmsConstants.dataSourceName = bizboxProperties.getDataSourceName();
				log.info("dataSourceName -> " + EbmsConstants.dataSourceName);
				
				EbmsConstants.databaseType = bizboxProperties.getDatabaseType();
				
				if( EbmsConstants.databaseType.equals("mysql") ) {
					EbmsConstants.duplicateErrorCode = 1062;
				}
				else if( EbmsConstants.databaseType.equals("oracle") ) {
					EbmsConstants.duplicateErrorCode = 1;
				}
				log.info("databaseType -> " + EbmsConstants.databaseType);
				log.info("duplicateErrorCode -> " + EbmsConstants.duplicateErrorCode);
				
				EbmsConstants.cpaManagerJNDIName = bizboxProperties.getCpaManagerJNDIName();
				log.info("cpaManagerJNDIName -> " + EbmsConstants.cpaManagerJNDIName);
				
				EbmsConstants.bizboxDatabaseHeaderName = bizboxProperties.getBizboxDatabaseHeaderName();
				log.info("bizboxDatabaseHeaderName -> " + EbmsConstants.bizboxDatabaseHeaderName);
				
				// configure  üũ.
				EbmsConstants.configured = true;
			}
			catch(IOException e) {
				throw new EbmsConfigException(1, 0, e);
			}
			catch(RuntimeException e) {
				throw new EbmsConfigException(1, 0, e);
			}
		}
		else {			
			// Config file  ʴ 
			EbmsConstants.configured = false;
			
			log.fatal("Bizbox    ʽϴ. setup   ֽʽÿ.");
		}
	}

	public void contextDestroyed(ServletContextEvent arg0) {
	}
}