package org.kldp.ebmsh.message.processer;



import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.xml.soap.*;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.cpa.Cpa;
import org.kldp.ebmsh.message.packaging.EbxmlMessage;
import org.kldp.ebmsh.message.packaging.EbxmlMessageFactory;
import org.kldp.ebmsh.message.packaging.impl.EbxmlMessageFactoryImpl;
import org.kldp.ebmsh.message.packaging.impl.EbxmlMessageImpl;
import org.kldp.ebmsh.message.persistant.FileDAO;
import org.kldp.ebmsh.message.persistant.PersistantStorage;
import org.kldp.ebmsh.message.processer.http.ASyncMessageProcesser;
import org.kldp.ebmsh.message.processer.http.SyncMessageProcesser;
import org.kldp.util.log.LogUtil;


/**
 * File name   - BodyValidator.java
 * Create date - May 9, 2006
 * Update time - May 9, 2006
 * Version     - v1.0
 * 
 * Author      - Sirius
 */
public class EbmsServlet extends HttpServlet {
	private static Log log = LogFactory.getLog(EbmsServlet.class);
	private static long successCount = 0;
	private static long failCount = 0;
	
	
	/**
	 * Constructor
	 */
	public EbmsServlet() {
		
	}
	
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException {
		try {
			PrintWriter pw = response.getWriter();
			
			pw.write(
					"<html>" +
					"	Bizbox Get Page<br />" +
					"</html>"
					);
			
			pw.flush();
			pw.close();
		}
		catch(IOException e) {
			log.fatal( LogUtil.stackTraceToString(e) );
		}
	}
	
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException {
		EbxmlMessage receiveEbxmlMessage = null;
		
		try {
			log.info("޽ ޾ҽϴ");
			
			InputStream receiveInputStream = request.getInputStream();
			MimeHeaders mimeHeaders = getMimeHeaders(request);
			
			printReceivedHttpInfo(request);
			
			//TODO Ebxml ޽ ´ Ű Ȯϴ  ʿ
			
			// EbxmlMessage 
			receiveEbxmlMessage = createEbxmlMessage(mimeHeaders, receiveInputStream);
			
			if( receiveEbxmlMessage.getEbxmlHeader().hasSyncReply() ) {
				// Sync
				SyncMessageProcesser messageProcesser = new SyncMessageProcesser();
				
				messageProcesser.process(receiveEbxmlMessage, response);
			}
			else {
				// ASync
				new ASyncMessageProcesser().process(receiveEbxmlMessage, response);
			}

			successCount++;
		}
		catch(Throwable e) {
			failCount++;
			
			log.fatal("޽ ó ");
			log.fatal(LogUtil.stackTraceToString(e));
			
			if( receiveEbxmlMessage != null ) 
				new PersistantStorage().saveFailMessageToFile(receiveEbxmlMessage);
			
			throw new ServletException(e);
		}
		finally {
			log.info("ó īƮ [ : " + successCount + " : " + failCount + " ]");
		}
	}
	
	
	/**
	 * ޽ ޾ ȣǴ ޼.
	 * 1. Ebxml Message ޽ 
	 * 2. CPA ˻
	 * 3. ޽ Validate
	 * 4. ޽ Sorting
	 * 5. ޽ ó
	 * 
	 *  Ѵ.
	 */
	/*public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException {
		try {
			log.info("޽ ޾ҽϴ");
			
			InputStream receiveInputStream = request.getInputStream();
			MimeHeaders mimeHeaders = getMimeHeaders(request);
			
			//  ޽  ȭ鿡 
			// printReceivedHttpInfo(request);
			
			// EbxmlMessage 
			EbxmlMessage receiveEbxmlMessage = createEbxmlMessage(mimeHeaders, receiveInputStream);
			
			if( receiveEbxmlMessage.getEbxmlHeader().hasSyncReply() ) {
				// Sync
				//ServletReceivedSyncMessageProcesser messageProcesser = new ServletReceivedSyncMessageProcesser();
				
				//messageProcesser.messageProcess(receiveEbxmlMessage, response);
			}
			else {
				// ASync
				new ASyncMessageProcesser().process(receiveEbxmlMessage, response);
			}
			
			successCount++;
		}
		catch(Throwable e) {
			failCount++;
			
			log.fatal("޽ ó ");
			log.fatal(MessageUtil.stackTraceToString(e));
		}
		finally {
			// ޽ ó Ƚ 
			log.info("ó īƮ [ : " + successCount + " : " + failCount + " ]");
		}
	}*/
	
	
	/**
	 * @param httpServletRequest
	 * @return
	 */
	private MimeHeaders getMimeHeaders(HttpServletRequest httpServletRequest) {
		Enumeration enumeration = httpServletRequest.getHeaderNames();
		MimeHeaders mimeheaders = new MimeHeaders();
		
		while(enumeration.hasMoreElements()) 
		{
			String s = (String)enumeration.nextElement();
			String s1 = httpServletRequest.getHeader(s);
			
			StringTokenizer stringTokenizer = new StringTokenizer(s1, ",");
			
			while(stringTokenizer.hasMoreTokens()) 
				mimeheaders.addHeader(s, stringTokenizer.nextToken().trim());
		}
		
		return mimeheaders;
	}
	
	
	/**
	 * SOAPMessage -> EbxmlMessage ϴ ޼
	 * 
	 * @param message  SOAPMessage
	 * @return EbxmlMessage
	 * @throws SOAPException
	 */
	private EbxmlMessage createEbxmlMessage(MimeHeaders headers, InputStream messageInputStream) throws SOAPException, IOException {	
		EbxmlMessage ebxmlMessage = null;

		try {
			log.info("EbxmlMesssage մϴ.");
			
			EbxmlMessageFactory ebxmlMessageFactory = new EbxmlMessageFactoryImpl();
			
			SOAPMessage soapMessage = ebxmlMessageFactory.createMessage(headers, messageInputStream);
						
			ebxmlMessage = new EbxmlMessageImpl(soapMessage, ebxmlMessageFactory);
		}
		catch(SOAPException e) {
			throw e;
		}
		catch(IOException e) {
			throw e;
		}
		
		return ebxmlMessage;
	}
	
	/**
	 *  ޽  Ѵ.
	 * 
	 * @param message EbxmlMessage
	 */
	private void printReceivedHttpInfo(HttpServletRequest request) throws IOException {
		log.info("------  HTTP  ------");
		
		Enumeration headerNames = request.getHeaderNames();
		
		while( headerNames.hasMoreElements() ) {
			String headerName = (String)headerNames.nextElement();
			String headerValue = request.getHeader(headerName);
			
			log.info("(Http header)\t" + headerName + ": " + headerValue);
		}
		
		log.info("------  HTTP  ------");
		
		/*ServletInputStream sis = request.getInputStream();
		
		BufferedReader br = new BufferedReader(new InputStreamReader(sis));
		StringBuffer sb = new StringBuffer();
		
		sis.mark( request.getContentLength() + 1 );
		
		while( true ) {
			String line = br.readLine();
			
			if( line == null ) 
				break ;
			else 
				sb.append("\r\n" + line);
		}
		
		log.info("(Http body)" + sb.toString());
		
		sis.reset();
		
		sis.mark(-1);
		
		log.info("------  HTTP  ------");*/
	}
}