package org.kldp.ebmsh.tracker;

import javax.ejb.EJBException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.Message;
import javax.jms.MessageListener;

import jeus.security.util.LoggerUtil;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.message.persistant.EbmsPersistantException;
import org.kldp.ebmsh.message.persistant.PersistantStorage;
import org.kldp.ebmsh.message.util.MessageUtil;
import org.kldp.ebmsh.queue.EbmsQueueMessageException;
import org.kldp.ebmsh.queue.TrackerMessage;
import org.kldp.ebmsh.queue.TrackerMessageConverter;
import org.kldp.util.log.LogUtil;


/**
 * Tracker  DB ϴ MessageDrivenBean
 * 
 * @author Sirius
 */
public class TrackerHandler implements MessageDrivenBean, MessageListener {
	private final static Log log = LogFactory.getLog(TrackerHandler.class);
	private MessageDrivenContext ctx;
	
	public void ejbCreate() throws EJBException {
	}
	
	public void ejbRemove() throws EJBException {
	}
	
	
	public void setMessageDrivenContext(MessageDrivenContext ctx) {
		this.ctx = ctx;
	}
	
	public void onMessage(Message message) {
		try {
			TrackerMessage trackerMessage = (TrackerMessage)new TrackerMessageConverter().convertToQueueMessage(message);
		
			new PersistantStorage().insertTrackerDetail(trackerMessage.getMessageId(), trackerMessage.getState(), trackerMessage.getInformation());
		}
		catch(RuntimeException e) {
			log.fatal(LogUtil.stackTraceToString(e));
			
			throw e;
		}
	}
}