package org.kldp.util.io;

import java.io.*;

/**
 * File Directory õ Util
 * 
 * @author	antasis9
 * @version	1.0
 * @since	2006.5.10
 */
public class FileIoUtil {
	/**
	 * Fileκ Data о´.
	 * 
	 * @param _filePath		о  
	 * @return				о ͸ String ȯѴ.
	 * @throws IOException	 ã    ߻
	 */
	public static byte[] readDataFromFile(String _filePath) throws IOException {
		if( !hasFile(_filePath) )
			throw new FileNotFoundException(" ã  ϴ. File name: " + _filePath);
		
		File file = new File(_filePath);
		
		FileInputStream fileInputStream = new FileInputStream(file);
		ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
		
		byte[] buffer = new byte[1024];
		int count = 0;
		
		while( (count = fileInputStream.read(buffer)) != -1 )
			byteArrayOutputStream.write(buffer, 0, count);
		
		byte[] result = byteArrayOutputStream.toByteArray();
		
		byteArrayOutputStream.flush();		
		byteArrayOutputStream.close();		
		fileInputStream.close();
		
		return result;
	}
	
	
	/**
	 * ͸ Ͽ Ѵ.
	 * 
	 * @param _directoryPath	丮 
	 * @param _fileName			 ̸
	 * @param _fileData			 
	 * @throws IOException		ġ        ߻
	 */
	public static void saveDataToFile(String _directoryPath, String _fileName, byte[] _fileData) throws IOException {
		_directoryPath = fileSeparatorAddOrNone(_directoryPath);		
		directoryCreateOrNone(_directoryPath);
		
		try {
			File f = new File(_directoryPath + _fileName);			
			f.createNewFile();
			
			FileOutputStream fileOutputStream = new FileOutputStream(f);
			
			fileOutputStream.write(_fileData);
			fileOutputStream.flush();			
			fileOutputStream.close();
		}
		catch(IOException e) {
			throw new IOException("Ͽ  ϴ. File name: " + _directoryPath + _fileName);
		}
	}
	
	
	/**
	 *  ϴ ˻
	 * 
	 * @param _filePath		 
	 * @return				  
	 */
	public static boolean hasFile(String _filePath) {
		File file = new File(_filePath);
		
		return file.exists();
	}
	
	
	/**
	 * 丮 ϴ ˻
	 * 
	 * @param _directoryPath	丮 
	 * @return					丮  
	 */
	public static boolean hasDirectory(String _directoryPath) {
		File directory = new File(_directoryPath);
		
		return directory.exists();
	}
	
	
	/**
	 * 丮 Ѵ.
	 *     ʴ´.
	 * 
	 * @param _directoryPath	丮 
	 */
	public static boolean directoryCreateOrNone(String _directoryPath) {
		if( !hasDirectory(_directoryPath) )
			return new File(_directoryPath).mkdirs();
		
		return true;
	}
	
	
	/**
	 *  ڸ δ.
	 *   ڰ     ʴ´.
	 * 
	 * @param _directoryPath	 ڸ  丮 
	 * @return
	 */
	public static String fileSeparatorAddOrNone(String _directoryPath) {
		if( !(_directoryPath.endsWith("/") || _directoryPath.endsWith("\\")) ) 
			_directoryPath += File.separator;
		
		return _directoryPath;
	}
	
	public static boolean isAbsolutePath(String _directoryPath) {
		File file = new File(_directoryPath);
		
		return file.isAbsolute();
	}
	
	public static boolean delete(String _filePath) {
		File file = new File(_filePath);
		
		return file.delete();
	}
}