package org.kldp.util.j2ee.resource;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;


/**
 * DataSourceServiceLocator
 * 
 * ServiceLocator pattern, Singleton pattern
 * 
 * DataSource ѹ lookupؼ ĳϰ, Connection  մϴ.
 * 
 * DataSource thread-safe Ȯ Ųٴ  ⶧ ĳ  ʴ´.
 * 
 * @author Sirius
 */
public class DataSourceServiceLocator {
	private final static DataSourceServiceLocator instance = new DataSourceServiceLocator();

	private DataSourceServiceLocator() { }

	public static DataSourceServiceLocator getInstance() {
		return instance;
	}

	public DataSource getDataSource(String dataSourceName) throws NamingException {
		Context context = new InitialContext();
		
		DataSource dataSource = (DataSource)context.lookup(dataSourceName);
					
		return dataSource;
	}
}