package org.kldp.util.j2ee.resource;

import java.util.HashMap;
import java.util.Map;

import javax.ejb.EJBLocalHome;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class EJBLocalHomeServiceLocator {
	private final static EJBLocalHomeServiceLocator instance = new EJBLocalHomeServiceLocator();

	private Map<String, EJBLocalHome> cache = new HashMap<String, EJBLocalHome>();

	private EJBLocalHomeServiceLocator() { }

	public static EJBLocalHomeServiceLocator getInstance() {
		return instance;
	}
	
	public EJBLocalHome getEJBLocalHome(String localHomeName) throws NamingException {
		Context context = null;
		
		EJBLocalHome ejbLocalHome = null;

		// ĳ ϸ ٷ  ش.
		if( cache.containsKey(localHomeName) ) {
			ejbLocalHome = cache.get(localHomeName);
		}
		// ĳ    Resource lookupؼ ãϴ.
		else {
			context = new InitialContext();

			ejbLocalHome = (EJBLocalHome)context.lookup(localHomeName);

			cache.put(localHomeName, ejbLocalHome);
		}

		return ejbLocalHome;
	}
}
