package org.kldp.util.j2ee.resource;

import javax.jms.QueueConnectionFactory;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * QueueServiceLocator
 * 
 * ServiceLocator pattern
 * 
 * @author Sirius
 */
public class QueueConnectionFactoryServiceLocator {
	private final static QueueConnectionFactoryServiceLocator instance = new QueueConnectionFactoryServiceLocator();

	private QueueConnectionFactoryServiceLocator() { }

	public static QueueConnectionFactoryServiceLocator getInstance() {
		return instance;
	}
	
	public QueueConnectionFactory getQueueConnectionFactory(String queueConnectionFactoryName) throws NamingException {
		Context context = new InitialContext();
			
		QueueConnectionFactory queueConnectionFactory = (QueueConnectionFactory)context.lookup(queueConnectionFactoryName);

		return queueConnectionFactory;
	}
}