package org.kldp.ebmsh.moniter.persistant;

import java.sql.Connection;
import java.sql.SQLException;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.kldp.ebmsh.config.EbmsConstants;


class AdminDAO {
	
	/**
	 *  ID Password Ȯմϴ.
	 * 
	 * @param id
	 * @param password
	 * @return
	 * @throws MoniterPersistantException
	 */
	boolean authorizeAdmin(String id, String password) throws MoniterPersistantException {
		try {
			Admin admin = null;
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "Admin where Id=? and Password=?";
			
			final Object[] parameters = new Object[2];
			parameters[0] = id; // [0] Id
			parameters[1] = password; // [1] Password
			
			DbTemplate dbTemplate = new DbTemplate();
			admin = (Admin)dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanHandler(Admin.class);
							
							Admin admin = null;
							
							try {
								admin = (Admin)runner.query(_conn, queryStr, parameters, resultSetHandler);
							} 
							catch (SQLException e) {
								throw new MoniterPersistantException(1, e.getErrorCode(), e);
							}
							
							return admin;
						}
					}
				);
			
			if( admin != null )
				return true;
			else
				return false;
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(1, 0, e);
		}
	}
	
	void updateAdminPassword(String id, String password) throws MoniterPersistantException {
		try {
			DbTemplate dbTemplate = new DbTemplate();
			
			final String queryStr = "update " + EbmsConstants.bizboxDatabaseHeaderName + "Admin set Password=? where Id = ?";
			
			final Object[] parameters = new Object[2];
			parameters[0] = password; // [0] Password
			parameters[1] = id; // [1] Id
			
			dbTemplate.executeQuery(
					new DbWorker() {
						
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							try {
								runner.update(_conn, queryStr, parameters);
							}
							catch(SQLException e) {
								throw new MoniterPersistantException(0, e.getErrorCode(), e);
							}
							
							return null;
						}
						
					});
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(0, 0, e);
		}
	}
	
	/**
	 *   Ȯմϴ.
	 * 
	 * @param id
	 * @param password
	 * @return
	 * @throws MoniterPersistantException
	 */
	Admin getAdmin(String id) throws MoniterPersistantException {
		try {
			Admin admin = null;
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "Admin where Id=?";
			
			final Object[] parameters = new Object[1];
			parameters[0] = id; // [0] Id
			
			DbTemplate dbTemplate = new DbTemplate();
			admin = (Admin)dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanHandler(Admin.class);
							
							Admin admin = null;
							
							try {
								admin = (Admin)runner.query(_conn, queryStr, parameters, resultSetHandler);
							} 
							catch (SQLException e) {
								throw new MoniterPersistantException(1, e.getErrorCode(), e);
							}
							
							return admin;
						}
					}
				);
			
			return admin;
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(1, 0, e);
		}
	}
}