package org.kldp.ebmsh.moniter.persistant;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.List;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.apache.commons.dbutils.handlers.BeanListHandler;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.config.EbmsConstants;


class BsiMessageStatusDAO {
	private final static Log log = LogFactory.getLog(BsiMessageStatusDAO.class);
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbmsPersistantException
	 */
	BsiMessageStatus getBsiMessageStatus(String messageId) throws MoniterPersistantException {
		try {
			BsiMessageStatus bsiMessageStatus = null;
			
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "BsiMessageStatus where MessageId=?";
			
			final Object[] parameters = new Object[1];
			parameters[0] = messageId; // [0] MessageId
			
			DbTemplate dbTemplate = new DbTemplate();
			bsiMessageStatus = (BsiMessageStatus)dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanHandler(BsiMessageStatus.class);
							
							BsiMessageStatus bsiMessageStatus = null;
							
							try {
								bsiMessageStatus = (BsiMessageStatus)runner.query(_conn, queryStr, parameters, resultSetHandler);
							} 
							catch (SQLException e) {
								throw new MoniterPersistantException(1, e.getErrorCode(), e);
							}
							
							return bsiMessageStatus;
						}
					}
				);
			
			return bsiMessageStatus;
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(1, 0, e);
		}
	}
	
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbmsPersistantException
	 */
	List getBsiMessagesByStatusCode(int statusCode) throws MoniterPersistantException {
		try {
			List bsiMessageStatusList = null;
			
			DbTemplate dbTemplate = new DbTemplate();
			
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "BsiMessageStatus where Status=?";
			
			final Object[] parameters = new Object[1];
			parameters[0] = statusCode; // [0] MessageId
			
			bsiMessageStatusList = (List)dbTemplate.executeQuery(
					new DbWorker() {
						
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanListHandler(BsiMessageStatus.class);
							
							List queryResult = null;
							
							try {
								queryResult = (List)runner.query(_conn, queryStr, parameters, resultSetHandler);
							}
							catch(SQLException e) {
								throw new MoniterPersistantException(0, e.getErrorCode(), e);
							}
							
							return queryResult;
						}
						
					});
			
			return bsiMessageStatusList;
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(0, 0, e);
		}
	}
}
