package org.kldp.ebmsh.moniter.persistant;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import javax.naming.NamingException;
import javax.sql.DataSource;

import org.apache.commons.dbutils.DbUtils;
import org.kldp.ebmsh.config.EbmsConstants;
import org.kldp.ebmsh.moniter.MoniterException;
import org.kldp.util.j2ee.resource.DataSourceServiceLocator;


/**
 * Bizbox  DBTemplate
 * 
 * @author Sirius
 * @since 2007-03-30
 */
public class DbTemplate {
	public Object executeQuery(DbWorker _dbWorker) throws MoniterPersistantException {
		Connection conn = null;
		Object result = null;
		
		try {
			DataSource dataSource = DataSourceServiceLocator.getInstance().getDataSource(EbmsConstants.dataSourceName);
			
			conn = dataSource.getConnection();
		}
		catch(NamingException e) {
			throw new MoniterPersistantException(0, 0, e);
		}
		catch(SQLException e) {
			throw new MoniterPersistantException(0, 0, e);
		}
		
		try {
			result = _dbWorker.work(conn);
		}
		finally {
			try {
				DbUtils.close(conn);
			} catch (SQLException ignore) {
			}
		}
		
		return result;
	}
}
