package org.kldp.ebmsh.moniter.persistant;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.apache.commons.dbutils.handlers.BeanListHandler;
import org.kldp.ebmsh.config.EbmsConstants;



class DocumentIdInfoDAO {
	/**
	 * Action شϴ DocumentId ɴϴ.
	 * 
	 * @param messageId
	 * @return
	 * @throws EbmsPersistantException
	 */
	DocumentIdInfo getDocumentIdInfoByAction(String action) throws MoniterPersistantException {
		try {
			DocumentIdInfo documentIdInfo = null;
			
			DbTemplate dbTemplate = new DbTemplate();
			
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "DocumentIdInfo where Action=?";
			
			final Object[] parameters = new Object[1];
			parameters[0] = action; // [0] Action
			
			documentIdInfo = (DocumentIdInfo)dbTemplate.executeQuery(
					new DbWorker() {
						
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanHandler(DocumentIdInfo.class);
							
							DocumentIdInfo documentIdInfo = null;
							
							try {
								documentIdInfo = (DocumentIdInfo)runner.query(_conn, queryStr, parameters, resultSetHandler);
							}
							catch(SQLException e) {
								throw new MoniterPersistantException(0, e.getErrorCode(), e);
							}
							
							return documentIdInfo;
						}
						
					});
			
			return documentIdInfo;
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(0, 0, e);
		}
	}
	
	
	/**
	 * DB ϵ  DocumentIdInfo ɴϴ.
	 * 
	 * @param messageId
	 * @return
	 * @throws EbmsPersistantException
	 */
	List getDocumentIdInfos() throws MoniterPersistantException {
		try {
			List documentIdInfos = null;
			
			DbTemplate dbTemplate = new DbTemplate();
			
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "DocumentIdInfo";
			
			documentIdInfos = (List)dbTemplate.executeQuery(
					new DbWorker() {
						
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanListHandler(DocumentIdInfo.class);
							
							List documentIdInfos = null;
							
							try {
								documentIdInfos = (List)runner.query(_conn, queryStr, resultSetHandler);
							}
							catch(SQLException e) {
								throw new MoniterPersistantException(0, e.getErrorCode(), e);
							}
							
							return documentIdInfos;
						}
						
					});
			
			return documentIdInfos;
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(0, 0, e);
		}
	}
	
	void insertDocumentIdInfo(String action, int payloadIndex, String xPath) throws MoniterPersistantException {
		try {
			DbTemplate dbTemplate = new DbTemplate();
			
			final String queryStr = "insert into " + EbmsConstants.bizboxDatabaseHeaderName + "DocumentIdInfo(Action, PayloadIndex, XPath) values(?, ?, ?)";
			
			final Object[] parameters = new Object[3];
			parameters[0] = action; // [0] Action
			parameters[1] = new Integer(payloadIndex); // [1] PayloadIndex
			parameters[2] = xPath; // [2] XPath
			
			
			dbTemplate.executeQuery(
					new DbWorker() {
						
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							try {
								runner.update(_conn, queryStr, parameters);
							}
							catch(SQLException e) {
								throw new MoniterPersistantException(0, e.getErrorCode(), e);
							}
							
							return null;
						}
						
					});
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(0, 0, e);
		}
	}
	
	void updateDocumentIdInfo(String action, int payloadIndex, String xPath) throws MoniterPersistantException {
		try {
			DbTemplate dbTemplate = new DbTemplate();
			
			final String queryStr = "update " + EbmsConstants.bizboxDatabaseHeaderName + "DocumentIdInfo set PayloadIndex = ?, XPath = ? where Action=?";
			
			final Object[] parameters = new Object[3];
			parameters[0] = new Integer(payloadIndex); // [0] PayloadIndex
			parameters[1] = xPath; // [1] XPath
			parameters[2] = action; // [2] Action
			
			dbTemplate.executeQuery(
					new DbWorker() {
						
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							try {
								runner.update(_conn, queryStr, parameters);
							}
							catch(SQLException e) {
								throw new MoniterPersistantException(0, e.getErrorCode(), e);
							}
							
							return null;
						}
						
					});
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(0, 0, e);
		}
	}
	
	void deleteDocumentIdInfo(String action) throws MoniterPersistantException {
		try {
			DbTemplate dbTemplate = new DbTemplate();
			
			final String queryStr = "delete from " + EbmsConstants.bizboxDatabaseHeaderName + "DocumentIdInfo where Action=?";
			
			final Object[] parameters = new Object[1];
			parameters[0] = action; // [0] Action
			
			dbTemplate.executeQuery(
					new DbWorker() {
						
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							try {
								runner.update(_conn, queryStr, parameters);
							}
							catch(SQLException e) {
								throw new MoniterPersistantException(0, e.getErrorCode(), e);
							}
							
							return null;
						}
						
					});
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(0, 0, e);
		}
	}
}