package org.kldp.ebmsh.moniter.persistant;

import java.sql.Connection;
import java.sql.SQLException;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.config.EbmsConstants;



class MessageStatusDAO {
	private final static Log log = LogFactory.getLog(MessageStatusDAO.class);
	
	
	/**
	 * ޽   մϴ.
	 * 
	 * @param ebxmlMessage
	 * @throws EbmsPersistantException
	 */
	MessageStatus getMessageStatus(String messageId) throws MoniterPersistantException {
		try {
			MessageStatus messageStatus = null;
			
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "MessageStatus where MessageId=?";
			
			final Object[] parameters = new Object[1];
			parameters[0] = messageId; // [0] MessageId
			
			
			DbTemplate dbTemplate = new DbTemplate();
			messageStatus = (MessageStatus)dbTemplate.executeQuery(
					new DbWorker() {
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanHandler(MessageStatus.class);
							
							MessageStatus messageStatus = null;
							
							try {
								messageStatus = (MessageStatus)runner.query(_conn, queryStr, parameters, resultSetHandler);
							} catch (SQLException e) {
								throw new MoniterPersistantException(1, e.getErrorCode(), e);
							}
							
							return messageStatus;
						}
					}
				);
			
			return messageStatus;
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(1, 0, e);
		}
	}
}