package org.kldp.ebmsh.moniter.persistant;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.kldp.ebmsh.config.EbmsConstants;


/**
 * " + Environment.bizboxDatabaseName + "MessageStore DAO
 * 
 * @author Sirius
 * @since 2007-03-30
 */
class MessageStoreDAO {
	private final static Log log = LogFactory.getLog(MessageStoreDAO.class);
	
	/**
	 * messageId شϴ ޽  ˻մϴ.
	 * 
	 * @param messageId
	 * @return
	 * @throws EbmsPersistantException
	 */
	MessageStore getMessageStoreMessage(String messageId) throws MoniterPersistantException {
		try {
			MessageStore messageStore = null;
			
			DbTemplate dbTemplate = new DbTemplate();
			
			final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "Messagestore where MessageId=?";
			
			final Object[] parameters = new Object[1];
			parameters[0] = messageId; // [0] MessageId
			
			messageStore = (MessageStore)dbTemplate.executeQuery(
					new DbWorker() {
						
						public Object work(Connection _conn) throws MoniterPersistantException {
							QueryRunner runner = new QueryRunner();
							ResultSetHandler resultSetHandler = new BeanHandler(MessageStore.class);
							
							MessageStore messageStore = null;
							
							try {
								messageStore = (MessageStore)runner.query(_conn, queryStr, parameters, resultSetHandler);
							}
							catch(SQLException e) {
								throw new MoniterPersistantException(0, e.getErrorCode(), e);
							}
							
							return messageStore;
						}
						
					});
			
			return messageStore;
		}
		catch(MoniterPersistantException e) {
			throw e;
		}
		catch(Exception e) {
			throw new MoniterPersistantException(1, 0, e);
		}
	}
}
