package org.kldp.ebmsh.moniter.persistant;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanListHandler;
import org.kldp.ebmsh.config.EbmsConstants;



/**
 * " + Environment.bizboxDatabaseName + "Tracker " + Environment.bizboxDatabaseName + "Tracker_Detail DAO
 * 
 * @author Sirius
 * @since 2007-03-30
 */
class TrackerDAO {
	/**
	 * Tracker detail  ɴϴ.
	 * 
	 * @param trackerKey
	 * @return
	 * @throws EbmsPersistantException
	 */
	List getTrackers(String messageId) throws MoniterPersistantException {
		List trackerDetailList = null;
		
		DbTemplate dbTemplate = new DbTemplate();
		
		final String queryStr = "select * from " + EbmsConstants.bizboxDatabaseHeaderName + "Tracker where MessageId=? order by TrackingTime asc";
		
		final Object[] parameters = new Object[1];
		parameters[0] = messageId; // [0] MessageId
		
		trackerDetailList = (List)dbTemplate.executeQuery(
				new DbWorker() {
					
					public Object work(Connection _conn) throws MoniterPersistantException {
						QueryRunner runner = new QueryRunner();
						ResultSetHandler resultSetHandler = new BeanListHandler(Tracker.class);
						
						List queryResult = null;
						
						try {
							queryResult = (List)runner.query(_conn, queryStr, parameters, resultSetHandler);
						}
						catch(SQLException e) {
							throw new MoniterPersistantException(0, e.getErrorCode(), e);
						}
						
						return queryResult;
					}
					
				});
		
		return trackerDetailList;
	}
}