package org.kldp.ebmsh.setup;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import javax.naming.NamingException;
import javax.sql.DataSource;

import org.apache.commons.dbutils.DbUtils;
import org.kldp.util.io.FileIoUtil;
import org.kldp.util.j2ee.resource.DataSourceServiceLocator;

public class EbmsSetupManager {
	public void createCpaDirectory(String cpaSetupRealPath) throws EbmsSetupException {
		// CPA 丮 
		try {
			if( !FileIoUtil.hasDirectory(cpaSetupRealPath) ) {
				if( !FileIoUtil.directoryCreateOrNone(cpaSetupRealPath) )
					throw new EbmsSetupException("丮   ϴ.");
			}
			else 
				throw new EbmsSetupException("̹ ϴ 丮 Դϴ.");
		}
		catch(Throwable t) {
			throw new EbmsSetupException(t);
		}
	}
	
	public void createMessageDirectory(String messageSetupRealPath) throws EbmsSetupException {
		// Message 丮 
		try {
			if( !FileIoUtil.hasDirectory(messageSetupRealPath) ) {
				if( !FileIoUtil.directoryCreateOrNone(messageSetupRealPath) )
					throw new EbmsSetupException("丮   ϴ.");
			}
			else 
				throw new EbmsSetupException("̹ ϴ 丮 Դϴ.");
		}
		catch(Throwable t) {
			throw new EbmsSetupException(t);
		}
	}
	
	public void createDatabase(String bizboxSetupSqlPath, String dataSourceName, String databaseType, String bizboxDatabaseHeaderName) throws EbmsSetupException {
		// Query list
		String createIncomingMessageTable = "";
		String createOutgoingMessageTable = "";
		String createMessageStoreTable = "";
		String createMessageStatusTable = "";
		String createAckMessageTable = "";
		String createDuplicateMessageTable = "";
		String createMessageIdAndDocumentIdTable = "";
		String createTrackerTable = "";
		String createBsiMessageStatusTable = "";
		String createAdminTable = "";
		String createDocumentIdInfoTable = "";
		String createIncomingMessageIndex = "";
		String createOutgoingMessageIndex = "";
		String createDocumentIdIndex = "";
		String createAdminInsert = "";
		
		// Database 
		DataSource dataSource = null;
		
		// DataSource  κ
		try {
			dataSource = DataSourceServiceLocator.getInstance().getDataSource(dataSourceName);
		}
		catch(NamingException e) {
			throw new EbmsSetupException("DataSource   ϴ. ( datasource -> " + dataSourceName + " )");
		}
		catch(Throwable e) {
			throw new EbmsSetupException(e);
		}
		
		// Sql  κ
		try {
			EbmsSetupQueryLoader queryLoader = new EbmsSetupQueryLoader(bizboxSetupSqlPath);
			
			if( databaseType.equals("mysql") ) {
				createIncomingMessageTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlIncomingMessageTableCreateSql(), bizboxDatabaseHeaderName);
				
				createOutgoingMessageTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlOutgoingMessageTableCreateSql(), bizboxDatabaseHeaderName);
				
				createMessageStoreTable =
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlMessageStoreTableCreateSql(), bizboxDatabaseHeaderName);
				
				createMessageStatusTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlMessageStatusTableCreateSql(), bizboxDatabaseHeaderName);
				
				createAckMessageTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlAckMessageTableCreateSql(), bizboxDatabaseHeaderName);
				
				createDuplicateMessageTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlDuplicateMessageTableCreateSql(), bizboxDatabaseHeaderName);
				
				createMessageIdAndDocumentIdTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlMessageIdAndDocumentIdTableCreateSql(), bizboxDatabaseHeaderName);
				
				createTrackerTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlTrackerTableCreateSql(), bizboxDatabaseHeaderName);
				
				createBsiMessageStatusTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlBsiMessageStatusTableCreateSql(), bizboxDatabaseHeaderName);
				
				createAdminTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlAdminTableCreateSql(), bizboxDatabaseHeaderName);
				
				createDocumentIdInfoTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlDocumentIdInfoTableCreateSql(), bizboxDatabaseHeaderName);
				
				createIncomingMessageIndex = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlIncomingMessageIndexCreateSql(), bizboxDatabaseHeaderName);
				
				createOutgoingMessageIndex = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlOutgoingMessageIndexCreateSql(), bizboxDatabaseHeaderName);
				
				createDocumentIdIndex = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlDocumentIdIndexCreateSql(), bizboxDatabaseHeaderName);
				
				createAdminInsert = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getMysqlAdminInsertSql(), bizboxDatabaseHeaderName);
			}
			else if( databaseType.equals("oracle") ) {
				createIncomingMessageTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleIncomingMessageTableCreateSql(), bizboxDatabaseHeaderName);
				
				createOutgoingMessageTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleOutgoingMessageTableCreateSql(), bizboxDatabaseHeaderName);
				
				createMessageStoreTable =
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleMessageStoreTableCreateSql(), bizboxDatabaseHeaderName);
				
				createMessageStatusTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleMessageStatusTableCreateSql(), bizboxDatabaseHeaderName);
				
				createAckMessageTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleAckMessageTableCreateSql(), bizboxDatabaseHeaderName);
				
				createDuplicateMessageTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleDuplicateMessageTableCreateSql(), bizboxDatabaseHeaderName);
				
				createMessageIdAndDocumentIdTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleMessageIdAndDocumentIdTableCreateSql(), bizboxDatabaseHeaderName);
				
				createTrackerTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleTrackerTableCreateSql(), bizboxDatabaseHeaderName);
				
				createBsiMessageStatusTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleBsiMessageStatusTableCreateSql(), bizboxDatabaseHeaderName);
				
				createAdminTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleAdminTableCreateSql(), bizboxDatabaseHeaderName);
				
				createDocumentIdInfoTable = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleDocumentIdInfoTableCreateSql(), bizboxDatabaseHeaderName);
				
				createIncomingMessageIndex = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleIncomingMessageIndexCreateSql(), bizboxDatabaseHeaderName);
				
				createOutgoingMessageIndex = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleOutgoingMessageIndexCreateSql(), bizboxDatabaseHeaderName);
				
				createDocumentIdIndex = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleDocumentIdIndexCreateSql(), bizboxDatabaseHeaderName);
				
				createAdminInsert = 
					EbmsSetupUtils.replaceToBizboxDatabaseHeaderName(queryLoader.getOracleAdminInsertSql(), bizboxDatabaseHeaderName);
			}
			else {
				throw new EbmsSetupException("Bizbox  ʴ Database Դϴ. ( database type -> " + databaseType + " )");
			}
			
			Connection connection = null;
			Statement stmt = null;
			
			//   
			try {
				connection = dataSource.getConnection();
				
				stmt = connection.createStatement();
				
				System.out.println(createIncomingMessageTable);
				stmt.executeUpdate(createIncomingMessageTable);
				
				System.out.println(createOutgoingMessageTable);
				stmt.executeUpdate(createOutgoingMessageTable);
				
				System.out.println(createMessageStoreTable);
				stmt.executeUpdate(createMessageStoreTable);
				
				System.out.println(createMessageStatusTable);
				stmt.executeUpdate(createMessageStatusTable);
				
				System.out.println(createAckMessageTable);
				stmt.executeUpdate(createAckMessageTable);				
				
				System.out.println(createDuplicateMessageTable);
				stmt.executeUpdate(createDuplicateMessageTable);
				
				System.out.println(createMessageIdAndDocumentIdTable);
				stmt.executeUpdate(createMessageIdAndDocumentIdTable);
				
				System.out.println(createTrackerTable);
				stmt.executeUpdate(createTrackerTable);
				
				System.out.println(createBsiMessageStatusTable);
				stmt.executeUpdate(createBsiMessageStatusTable);
				
				System.out.println(createAdminTable);
				stmt.executeUpdate(createAdminTable);			
				
				System.out.println(createDocumentIdInfoTable);
				stmt.executeUpdate(createDocumentIdInfoTable);
				
				System.out.println(createIncomingMessageIndex);
				stmt.executeUpdate(createIncomingMessageIndex);
				
				System.out.println(createOutgoingMessageIndex);
				stmt.executeUpdate(createOutgoingMessageIndex);
				
				System.out.println(createDocumentIdIndex);
				stmt.executeUpdate(createDocumentIdIndex);
				
				System.out.println(createAdminInsert);
				stmt.executeUpdate(createAdminInsert);
			}
			catch(SQLException e) {
				throw new EbmsSetupException(e);
			}
			finally {
				if( stmt != null )
					DbUtils.closeQuietly(stmt);
				
				if( connection != null )
					DbUtils.closeQuietly(connection);
			}
		}
		catch(IOException e) {
			throw new EbmsSetupException("Bizbox setup    ε  ϴ. ( query file -> " + bizboxSetupSqlPath + " )");
		}
		catch(EbmsSetupException e) {
			throw e;
		}
		catch(Throwable e) {
			throw new EbmsSetupException(e);
		}
	}
}
