package org.kldp.ebmsh.setup;

import java.io.*;
import java.util.Properties;

public class EbmsSetupQueryLoader {
	private Properties properties;
	
	public EbmsSetupQueryLoader(String queryFilePath) throws IOException {
		properties = new Properties();
		
		InputStream is = new FileInputStream(new File(queryFilePath));
			
		properties.load(is);
	}
	
	public String getOracleIncomingMessageTableCreateSql() {
		return properties.getProperty("oracleIncomingMessageTableCreate");
	}
	
	public String getMysqlIncomingMessageTableCreateSql() {
		return properties.getProperty("mysqlIncomingMessageTableCreate");
	}
	
	public String getOracleOutgoingMessageTableCreateSql() {
		return properties.getProperty("oracleOutgoingMessageTableCreate");
	}
	
	public String getMysqlOutgoingMessageTableCreateSql() {
		return properties.getProperty("mysqlOutgoingMessageTableCreate");
	}
	
	public String getOracleMessageStoreTableCreateSql() {
		return properties.getProperty("oracleMessageStoreTableCreate");
	}
	
	public String getMysqlMessageStoreTableCreateSql() {
		return properties.getProperty("mysqlMessageStoreTableCreate");
	}
	
	public String getOracleMessageStatusTableCreateSql() {
		return properties.getProperty("oracleMessageStatusTableCreate");
	}
	
	public String getMysqlMessageStatusTableCreateSql() {
		return properties.getProperty("mysqlMessageStatusTableCreate");
	}
	
	public String getOracleAckMessageTableCreateSql() {
		return properties.getProperty("oracleAckMessageTableCreate");
	}
	
	public String getMysqlAckMessageTableCreateSql() {
		return properties.getProperty("mysqlAckMessageTableCreate");
	}
	
	public String getOracleDuplicateMessageTableCreateSql() {
		return properties.getProperty("oracleDuplicateMessageTableCreate");
	}
	
	public String getMysqlDuplicateMessageTableCreateSql() {
		return properties.getProperty("mysqlDuplicateMessageTableCreate");
	}
	
	public String getOracleMessageIdAndDocumentIdTableCreateSql() {
		return properties.getProperty("oracleMessageIdAndDocumentIdTableCreate");
	}
	
	public String getMysqlMessageIdAndDocumentIdTableCreateSql() {
		return properties.getProperty("mysqlMessageIdAndDocumentIdTableCreate");
	}
	
	public String getOracleTrackerTableCreateSql() {
		return properties.getProperty("oracleTrackerTableCreate");
	}
	
	public String getMysqlTrackerTableCreateSql() {
		return properties.getProperty("mysqlTrackerTableCreate");
	}
	
	public String getOracleBsiMessageStatusTableCreateSql() {
		return properties.getProperty("oracleBsiMessageStatusTableCreate");
	}
	
	public String getMysqlBsiMessageStatusTableCreateSql() {
		return properties.getProperty("mysqlBsiMessageStatusTableCreate");
	}
	
	public String getOracleAdminTableCreateSql() {
		return properties.getProperty("oracleAdminTableCreate");
	}
	
	public String getMysqlAdminTableCreateSql() {
		return properties.getProperty("mysqlAdminTableCreate");
	}
	
	public String getOracleDocumentIdInfoTableCreateSql() {
		return properties.getProperty("oracleDocumentIdInfoTableCreate");
	}
	
	public String getMysqlDocumentIdInfoTableCreateSql() {
		return properties.getProperty("mysqlDocumentIdInfoTableCreate");
	}
	
	public String getOracleIncomingMessageIndexCreateSql() {
		return properties.getProperty("oracleIncomingMessageIndexCreate");
	}
	
	public String getMysqlIncomingMessageIndexCreateSql() {
		return properties.getProperty("mysqlIncomingMessageIndexCreate");
	}
	
	public String getOracleOutgoingMessageIndexCreateSql() {
		return properties.getProperty("oracleOutgoingMessageIndexCreate");
	}
	
	public String getMysqlOutgoingMessageIndexCreateSql() {
		return properties.getProperty("mysqlOutgoingMessageIndexCreate");
	}
	
	public String getOracleDocumentIdIndexCreateSql() {
		return properties.getProperty("oracleDocumentIdIndexCreate");
	}
	
	public String getMysqlDocumentIdIndexCreateSql() {
		return properties.getProperty("mysqlDocumentIdIndexCreate");
	}
	
	public String getOracleAdminInsertSql() {
		return properties.getProperty("oracleAdminInsert");
	}
	
	public String getMysqlAdminInsertSql() {
		return properties.getProperty("mysqlAdminInsert");
	}
}
