package org.kldp.ebmsh.setup;

import java.io.File;

import javax.servlet.ServletContext;

import org.kldp.util.io.FileIoUtil;

public class EbmsSetupUtils {
	public static String getEbmsRootPath(ServletContext application) {
		String currentPath = application.getRealPath("/");
		
		return FileIoUtil.fileSeparatorAddOrNone(new File(currentPath).getParent());
	}
	
	public static String getEbmsConfigPath(ServletContext application) {
		String configPath = FileIoUtil.fileSeparatorAddOrNone(getEbmsRootPath(application) + "config");
		
		return ( configPath + "ebmsConfig.properties" );
	}
	
	public static String getEbmsSetupSqlPath(ServletContext application) {
		String setupPath = FileIoUtil.fileSeparatorAddOrNone(application.getRealPath("/setup"));
		
		String sqlPath = FileIoUtil.fileSeparatorAddOrNone(setupPath + "sql");
		
		return ( sqlPath + "ebmsSetupSql.properties" );
	}
	
	public static String replaceToBizboxDatabaseHeaderName(String query, String bizboxDatabaseHeaderName) {
		return query.replaceAll("\\Q[\\EBizboxDataBaseHeader\\Q]\\E", bizboxDatabaseHeaderName);
	}
}
