package org.kldp.ebmsh.webservice;


import java.util.List;

import org.kldp.ebmsh.moniter.persistant.DocumentIdInfo;
import org.kldp.ebmsh.moniter.persistant.EbmsMoniterManager;
import org.kldp.ebmsh.moniter.persistant.InComingMessage;
import org.kldp.ebmsh.moniter.persistant.MessageStatus;
import org.kldp.ebmsh.moniter.persistant.MessageStore;
import org.kldp.ebmsh.moniter.persistant.MoniterPersistantException;
import org.kldp.ebmsh.moniter.persistant.SearchResult;
import org.kldp.ebmsh.moniter.persistant.SendSearchResult;
import org.kldp.ebmsh.moniter.persistant.Tracker;


/**
 * File name   - BizboxMoniterManagerImpl.java
 * Create date - 2007. 06. 13
 * Update time - 2007. 06. 13
 * Version     - v1.0
 *
 * Author      - Administrator
 */
public class EbmsMoniterManagerImpl implements IEbmsMoniterMananger {

	public boolean authorizeAdmin(String id, String password) throws MoniterPersistantException {
		
		return new EbmsMoniterManager().authorizeAdmin(id, password);
	}

	public void deleteDocumentIdInfo(String action) throws MoniterPersistantException {
		new EbmsMoniterManager().deleteDocumentIdInfo(action);
	}

	public DocumentIdInfo getDocumentIdInfoByAction(String action) throws MoniterPersistantException {
		return new EbmsMoniterManager().getDocumentIdInfoByAction(action);
	}

	public List<DocumentIdInfo> getDocumentIdInfos() throws MoniterPersistantException {
		return new EbmsMoniterManager().getDocumentIdInfos();
	}

	public InComingMessage getInComingMessage(String messageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().getInComingMessage(messageId);
	}

	public MessageStatus getMessageStatus(String messageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().getMessageStatus(messageId);
	}

	public MessageStore getMessageStoreMessage(String messageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().getMessageStoreMessage(messageId);
	}

	public List<Tracker> getTrackers(String messageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().getTrackers(messageId);
	}

	public void insertDocumentIdInfo(String action, int payloadIndex, String xPath) throws MoniterPersistantException {
		new EbmsMoniterManager().insertDocumentIdInfo(action, payloadIndex, xPath);
	}

	public List<SearchResult> searchFailReceiveMessagesByPeriod(long startTime, long endTime, int pageCount) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchFailReceiveMessagesByPeriod(startTime, endTime, pageCount);
	}

	public SearchResult searchReceiveMessageByMessageId(String messageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchReceiveMessageByMessageId(messageId);
	}

	public int searchReceiveMessageCountByDocumentId(String documentId) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchReceiveMessageCountByDocumentId(documentId);
	}

	public long searchReceiveMessageCountByPeriod(long startTime, long endTime) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchReceiveMessageCountByPeriod(startTime, endTime);
	}

	public List<SearchResult> searchReceiveMessagesByDocumentId(String documentId, int pageCount) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchReceiveMessagesByDocumentId(documentId, pageCount);
	}

	public List<SearchResult> searchReceiveMessagesByPeriod(long startTime, long endTime, int pageCount) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchReceiveMessagesByPeriod(startTime, endTime, pageCount);
	}

	public List<SendSearchResult> searchSendMessageByMessageId(String messageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchSendMessageByMessageId(messageId);
	}

	public List<SendSearchResult> searchSendMessageByPeriod(long startTime, long endTime, int pageCount) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchSendMessageByPeriod(startTime, endTime, pageCount);
	}

	public List<SendSearchResult> searchSendMessageByRefToMessageId(String refToMessageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchSendMessageByRefToMessageId(refToMessageId);
	}

	public long searchSendMessageCountByMessageId(String messageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchSendMessageCountByMessageId(messageId);
	}

	public long searchSendMessageCountByPeriod(long startTime, long endTime) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchSendMessageCountByPeriod(startTime, endTime);
	}

	public long searchSendMessageCountByRefToMessageId(String refToMessageId) throws MoniterPersistantException {
		return new EbmsMoniterManager().searchSendMessageCountByRefToMessageId(refToMessageId);
	}

	public void updateAdminPassword(String id, String password) throws MoniterPersistantException {
		new EbmsMoniterManager().updateAdminPassword(id, password);
	}

	public void updateDocumentIdInfo(String action, int payloadIndex, String xPath) throws MoniterPersistantException {
		new EbmsMoniterManager().updateDocumentIdInfo(action, payloadIndex, xPath);
	}

	public void printArgs(String arg0) {
		System.out.println(" : " + arg0);
	}
}
