package org.kldp.ebmsh.webservice;

import java.util.List;

import org.kldp.ebmsh.cpa.EbmsCpaException;

/**
 * File name   - ICpaService.java
 * Create date - 2007. 06. 12
 * Update time - 2007. 06. 12
 * Version     - v1.0
 *
 * Author      - Administrator
 * 
 * CpaService webservice ϱ  ̽.
 */
public interface ICpaService {
	public List<String> getCpaIds() throws EbmsCpaException;
	
	
	public List<String> getPartyNames(String cpaId) throws EbmsCpaException;
	
	public String[] getDeliveryChannelIds(String cpaId, String partyName) throws EbmsCpaException;
	public String[] getPackageIds(String cpaId) throws EbmsCpaException;
	
	//ڰ cpa  ʰ action ߰ Ҽ ִ 
	
	public void addAction(
			String cpaId, 
			String partyName, String bindingId, String action, String packageId, String[] channelId, 
			String otherPartyName, String otherBindingId, String otherAction, String[] otherChannelId) throws EbmsCpaException;
		
	
	public List<CanSend> getCanSends(String cpaid, String partyName) throws EbmsCpaException;

	public List<CanReceive> getCanReceives(String cpaId, String partyName) throws EbmsCpaException;
		
	public String[] getDefaultEndpoints(String cpaid, String partyName) throws EbmsCpaException;
	public void  setEndpoints(String cpaid, String partyName,String endpoint,String _deliveryChannelId) throws EbmsCpaException;
	
	public void  setCertificate(String cpaid ,String partyName , String _oldCertId, String _newCertId, int _keySeq, String _keyName, int _certSeq, String _x509Certificate);
	
	public List<Certificate> getCertificates(String cpaid ,String partyName ) throws EbmsCpaException;
	
	public void createNewCpa(String orgName,String cpaName);
	public void setPartyName(String cpaid , String orgName,String newName);
	public void setCpaId( String orgCpaId, String newCpaId);
	
	public void addPackaging(
			String cpaId, 
			String packagingId, String compositeId, String constituentMessageHeaderIdRef, String constituentPayloadIdRef
			) throws EbmsCpaException;
}
