package org.kldp.ebmsh.webservice;

import java.util.List;

import org.kldp.ebmsh.moniter.persistant.DocumentIdInfo;
import org.kldp.ebmsh.moniter.persistant.InComingMessage;
import org.kldp.ebmsh.moniter.persistant.MessageStatus;
import org.kldp.ebmsh.moniter.persistant.MessageStore;
import org.kldp.ebmsh.moniter.persistant.MoniterPersistantException;
import org.kldp.ebmsh.moniter.persistant.SearchResult;
import org.kldp.ebmsh.moniter.persistant.SendSearchResult;
import org.kldp.ebmsh.moniter.persistant.Tracker;

/**
 * File name   - BizboxMoniterManangerWS.java
 * Create date - 2007. 06. 13
 * Update time - 2007. 06. 13
 * Version     - v1.0
 *
 * Author      - Administrator
 */
public interface IEbmsMoniterMananger {
//	  ޽ ˻ Section
	/**
	 * DocumentId  ޽ ˻մϴ
	 * 
	 * @param documentId
	 * @return
	 * @throws MoniterPersistantException
	 */
	public List<SearchResult> searchReceiveMessagesByDocumentId(String documentId,
			int pageCount) throws MoniterPersistantException;

	/**
	 * MessageId  ޽ ˻մϴ
	 * 
	 * @param documentId
	 * @return
	 * @throws MoniterPersistantException
	 */
	public SearchResult searchReceiveMessageByMessageId(String messageId)
			throws MoniterPersistantException;

	/**
	 * Ⱓ ޽ ˻մϴ.
	 * 
	 * @param startTime
	 * @param endTime
	 * @param pageCount
	 * @return
	 * @throws MoniterPersistantException
	 */
	public List<SearchResult> searchReceiveMessagesByPeriod(long startTime, long endTime,
			int pageCount) throws MoniterPersistantException;

	/**
	 * Ⱓ ˻ ޽   ޽ մϴ.
	 * 
	 * @param startTime
	 * @param endTime
	 * @param pageCount
	 * @return
	 * @throws MoniterPersistantException
	 */
	public List<SearchResult> searchFailReceiveMessagesByPeriod(long startTime, long endTime,
			int pageCount) throws MoniterPersistantException;

	/**
	 * Ⱓ ˻ ޽ ˻  մϴ.
	 * 
	 * @param startTime
	 * @param endTime
	 * @return
	 * @throws MoniterPersistantException
	 */
	public long searchReceiveMessageCountByPeriod(long startTime, long endTime)
			throws MoniterPersistantException;

	public int searchReceiveMessageCountByDocumentId(String documentId)
			throws MoniterPersistantException;

	//  ޽ ˻ Section end

	//  ޽ ˻ Section
	/**
	 * MessageId ޽ ˻մϴ.
	 */
	public List<SendSearchResult> searchSendMessageByMessageId(String messageId)
			throws MoniterPersistantException;

	/**
	 * Ⱓ ˻ ޽ ˻  մϴ.
	 * 
	 * @param startTime
	 * @param endTime
	 * @return
	 * @throws MoniterPersistantException
	 */
	public long searchSendMessageCountByMessageId(String messageId)
			throws MoniterPersistantException;

	/**
	 * RefToMessageId ޽ ˻մϴ.
	 * 
	 * @param refToMessageId
	 * @return
	 * @throws MoniterPersistantException
	 */
	public List<SendSearchResult> searchSendMessageByRefToMessageId(String refToMessageId)
			throws MoniterPersistantException;

	/**
	 * Ⱓ ˻ ޽ ˻  մϴ.
	 * 
	 * @param startTime
	 * @param endTime
	 * @return
	 * @throws MoniterPersistantException
	 */
	public long searchSendMessageCountByRefToMessageId(String refToMessageId)
			throws MoniterPersistantException;

	/**
	 * Ⱓ ޽ ˻մϴ.
	 * 
	 * @param startTime
	 * @param endTime
	 * @return
	 * @throws MoniterPersistantException
	 */
	public List<SendSearchResult> searchSendMessageByPeriod(long startTime, long endTime,
			int pageCount) throws MoniterPersistantException;

	/**
	 * Ⱓ ˻ ޽ ˻  մϴ.
	 * 
	 * @param startTime
	 * @param endTime
	 * @return
	 * @throws MoniterPersistantException
	 */
	public long searchSendMessageCountByPeriod(long startTime, long endTime)
			throws MoniterPersistantException;

	//  ޽ ˻ Section end

	public boolean authorizeAdmin(String id, String password)
			throws MoniterPersistantException;

	public void updateAdminPassword(String id, String password)
			throws MoniterPersistantException;

	public void deleteDocumentIdInfo(String action)
			throws MoniterPersistantException;

	public void insertDocumentIdInfo(String action, int payloadIndex,
			String xPath) throws MoniterPersistantException;

	public void updateDocumentIdInfo(String action, int payloadIndex,
			String xPath) throws MoniterPersistantException;

	public List<Tracker> getTrackers(String messageId) throws MoniterPersistantException;

	public MessageStore getMessageStoreMessage(String messageId)
			throws MoniterPersistantException;

	public DocumentIdInfo getDocumentIdInfoByAction(String action)
			throws MoniterPersistantException;

	public List<DocumentIdInfo> getDocumentIdInfos() throws MoniterPersistantException;

	public InComingMessage getInComingMessage(String messageId)
			throws MoniterPersistantException;

	public MessageStatus getMessageStatus(String messageId)
			throws MoniterPersistantException;

	
	public void printArgs(String arg0);
}
